2022-02-20  Mosè Giordano  <mose@gnu.org>

	* Version 13.1 released.

2022-02-17  Arash Esbati  <arash@gnu.org>

	Update style/ltxdoc.el to class version 2.1d

	* style/ltxdoc.el ("ltxdoc"): Add '|' to `LaTeX-shortvrb-chars'
	before running the 'shortvrb' style hook.  Add missing symbols to
	the style hook incl. fontification.
	(LaTeX-ltxdoc-class-options): New variable.

	* tex-ispell.el (TeX-ispell-skip-cmds-list): Add one entry "cs".

2022-02-15  Arash Esbati  <arash@gnu.org>

	Update footmisc package options to v6.0b

	* style/footmisc.el (LaTeX-footmisc-package-options): Delete
	"bottomfootnotes".

2022-02-13  Arash Esbati  <arash@gnu.org>

	Update footmisc package options to v6.0a

	* style/footmisc.el (LaTeX-footmisc-package-options): Add new
	package options.

2022-02-12  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add NEWS item

	* doc/changes.texi: Announce changes in
	`LaTeX-indent-environment-list'.

2022-02-11  Arash Esbati  <arash@gnu.org>

	Consider environments defined with newfloat package

	* style/subcaption.el ("subcaption"): Offer environments defined
	with newfloat package when declaring the sub-caption feature.

2022-02-11  Arash Esbati  <arash@gnu.org>

	Improve fontification for LaTeX kernel macros

	* font-latex.el (font-latex-built-in-keyword-classes): Add
	fontification support for LaTeX kernel macros to various keyword
	classes.

	* tests/latex/font-latex-test.el
	(font-latex-general-fontification): Update test for fontification.

2022-02-09  Arash Esbati  <arash@gnu.org>

	Adjust entries for completion

	(TeX-arg-corner, TeX-arg-lr): Remove empty strings and unlistify
	the elements in collection argument of `completing-read'.

2022-02-09  Arash Esbati  <arash@gnu.org>

	Improve query for opt. arguments of \parbox and minipage

	* latex.el (LaTeX-env-minipage): Support query for all optional
	arguments of minipage environment.  Don't use INITIAL-VALUE
	argument when reading the width with `TeX-read-string', use
	DEFAULT-VALUE instead and indicate the value in the prompt.
	(TeX-arg-tb): Add new argument POSLIST which can be used to offer
	more sides for completion.
	(LaTeX-common-initialization): Use new arguments of `TeX-arg-tb'
	for the "parbox" entry.

2022-02-05  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add default entries to LaTeX-indent-environment-list (bug#28405)

	My previous commits disregard user's customization on
	LaTeX-indent-environment-list. Reconsideration led to move entries to
	its default value.

	* style/amsmath.el ("amsmath"):
	* style/mathtools.el ("mathtools"):
	Move entries into default value in latex.el.
	* latex.el (LaTeX-indent-environment-list): Pull in those entries.
	Add math envs without alignment as well to fix bug#28405.

2022-01-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add M-RET support for smallmatrix variants

	* style/mathtools.el ("mathtools"): Add smallmatrix variant
	environments to `LaTeX-item-list'.

2022-01-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add new test for indent

	* tests/latex/latex-test.el (LaTeX-indent-tabular): Add cookie to
	recognize \usepackage.
	* tests/latex/tabular-in.tex:
	* tests/latex/tabular-out.tex:
	Add \usepackage to deal with align and aligned environments.
	Add new test involving aligned environment.

2022-01-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add support for indent for environments with alignment

	* latex.el (LaTeX-indent-environment-list): Move align, align* and
	equation* environment to amsmath.el.
	* style/amsmath.el ("amsmath"): Add amsmath environments with
	alignment to local value of `LaTeX-indent-environment-list'.
	Add smallmatrix environment to `LaTeX-item-list'.
	* style/mathtools.el ("mathtools"): Add mathtools environments with
	alignment to local value of `LaTeX-indent-environment-list'.
	Add FIXME comment to `LaTeX-item-list' for spreadlines environment.
	Update copyright year.

	TODO: Add support for empheq environment as well. It would be
	necessary to implement a new function which looks into the argument of
	empheq environment and indents approapriately.

2022-01-21  Arash Esbati  <arash@gnu.org>

	Re-run LaTeX when .toc|lof|lot is missing

	* tex-buf.el (TeX-LaTeX-sentinel): Recognize missing .toc|lof|lot
	files and suggest a LaTeX re-run.  Issue raised in:
	https://lists.gnu.org/archive/html/auctex/2022-01/msg00020.html

2022-01-21  Arash Esbati  <arash@gnu.org>

	Fontify LaTeX kernel macros

	* font-latex.el (font-latex-built-in-keyword-classes): Add 3 core
	macros for TOC, LOF and LOT to function class.

2022-01-20  Arash Esbati  <arash@gnu.org>

	* tex-ispell.el: Skip the arguments of stabular*? environments.

2022-01-18  Arash Esbati  <arash@gnu.org>

	Add macros to skip from caption package

	* tex-ispell.el (TeX-ispell-skip-cmds-list): Add macros from
	caption.sty.

2022-01-11  Arash Esbati  <arash@gnu.org>

	Re-add support for deprecated but necessary macros

	* style/siunitx.el ("siunitx"): Add back support for deprecated
	macros \si et al.
	Conditionalize support for macros \qty and \units to avoid clash
	with other packages defining macros with the same name.

2022-01-08  Andrea Greselin  <greselin.andrea@gmail.com>  (tiny change)

	Make TeX-insert-quote robust for corner case (bug#52852)

	* tex.el (TeX-insert-quote): Go back only when there's enough room to
	do so.

2022-01-06  Arash Esbati  <arash@gnu.org>

	Fix tabular test for siunitx v3

	* tests/latex/tabular-count-ampersands-in.tex:
	* tests/latex/tabular-count-ampersands-out.tex: Replace the s
	column specifier with S which is the only one provided by siunitx
	version 3.

2021-12-29  Tassilo Horn  <tsdh@gnu.org>

	Revert "Properly destructure LaTeX-xparse-macro/environment-list entries"

	This reverts commit 0c2eda1940e2efb89006d4353d234ce3cb66ecb0.

2021-12-29  Andrea Greselin  <greselin.andrea@gmail.com>  (tiny change)

	Properly destructure LaTeX-xparse-macro/environment-list entries

	* style/xparse.el (LaTeX-xparse-macro-parse): Properly destructure
	LaTeX-xparse-macro/environment-list entries (bug#52872).

2021-12-28  David Kastrup  <dak@gnu.org>

	Make preview.sty deal with newer LaTeX hiding \shipout

2021-12-25  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix TeX-complete-make-expert-command-functions

	* tex.el (TeX-complete-make-expert-command-functions): Use dynamically
	generated, dedicated variable to register expert entities.

2021-12-23  Tassilo Horn  <tsdh@gnu.org>

	Refactor completion annotation code

	* tex.el
	(TeX--completion-annotation-from-tex--prettify-symbols-alist): New
	function.
	(TeX--completion-annotation-function): Use it.

2021-12-22  Tassilo Horn  <tsdh@gnu.org>

	Add completion annotation support from LaTeX-math-list/default

	* latex.el (LaTeX--completion-annotation-from-math-menu): New
	function.
	* tex.el (TeX--completion-annotation-function): Use it if bound.

2021-12-21  Tassilo Horn  <tsdh@gnu.org>

	Add an :annotation-function for completion and CAPF

	* tex.el (TeX--completion-annotation-function): New function.
	(TeX--completion-at-point): Use it.
	(TeX--symbol-completion-table): New function.
	(TeX-insert-macro): Use both new functions.

2021-12-18  Arash Esbati  <arash@gnu.org>

	Support enhanced tabular indentation

	* style/stabular.el ("stabular"): Append defined environments to
	`LaTeX-indent-environment-list'.

2021-12-15  Arash Esbati  <arash@gnu.org>

	Add style/sidecap.el

	* Makefile.in (STYLESRC): Add new style.

	* style/sidecap.el: New file.

2021-12-15  Arash Esbati  <arash@gnu.org>

	Add new style/rotating.el

	* Makefile.in (STYLESRC): Add new style.

	* style/rotating.el: New file.

2021-12-15  Arash Esbati  <arash@gnu.org>

	Add styles for packages from sttools collection

	* Makefile.in (STYLESRC): Add new styles.

	* style/cuted.el:
	* style/floatpag.el:
	* style/flushend.el:
	* style/midfloat.el:
	* style/stabular.el:
	* style/stfloats.el: New files.

2021-12-06  Arash Esbati  <arash@gnu.org>

	Update style/url.el to package version 3.4

	* style/url.el: Add parsing abilities for the macros \urldef and
	\DeclareUrlCommand.
	(TeX-arg-url-urlstyle): New function renamed from
	`TeX-arg-urlstyle'.
	(TeX-arg-url-DeclareUrlCommand, TeX-arg-url-urldef): New
	functions.
	("url"): Remove macros for setting new styles, linebreaks
	etc. from fontification.  Move '\urlstyle' to function class.
	(LaTeX-url-package-options): Update package options.

2021-11-30  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix marker management

	* latex.el (LaTeX-env-figure): Set marker only when it's really a
	marker.

2021-11-26  Arash Esbati  <arash@gnu.org>

	Track changes in LaTeX kernel 2021-11-15

	* font-latex.el (font-latex-built-in-keyword-classes): Add the
	macros \counterwith(in|out) to variable keyword-class.

	* latex.el (LaTeX-common-initialization): Support completion for
	\counterwith(in|out) macros.

2021-11-26  Arash Esbati  <arash@gnu.org>

	Add new style/unicodefonttable.el

	* Makefile.in (STYLESRC): Add new style.

	* style/unicodefonttable.el: New file.

2021-11-25  Arash Esbati  <arash@gnu.org>

	Update style/siunitx.el to package version 3

	* doc/changes.texi: Document the update of siunitx.el.

	* style/siunitx.el: Change email address.
	(LaTeX-siunitx-regexp): Adjust regexp to match the second
	mandatory argument of '\DeclareSIPower'.
	(LaTeX-siunitx-cleanup): Delete function since the function
	`LaTeX-siunitx-unit-list' already moves parsed elements to the
	variable `LaTeX-siunitx-unit-list'.  Don't add the function to
	`TeX-auto-cleanup-hook'.
	(LaTeX-siunitx-unit-list-parsed): New function returning all
	predefined and parsed units.
	(LaTeX-arg-siunitx-unit): Use the function
	`LaTeX-siunitx-unit-list-parsed'.
	(LaTeX-siunitx-package-options): Update to (and only to) key=vals
	defined in package version 3.
	(LaTeX-siunitx-key-val-options): New function returning key=vals.
	("siunitx"): Use the function `LaTeX-siunitx-key-val-options' in
	the hook.
	Remove deprecated macros and units.  Keep fontification for
	deprecated main macros \si, \SI, \SIlist and \SIrange.
	(LaTeX-siunitx-package-options): Support the preamble-only key
	'table-column-type'.

2021-11-25  Arash Esbati  <arash@gnu.org>

	Add new style/cancel.el

	* Makefile.in (STYLESRC): Add new style.

	* style/cancel.el: New file.

2021-11-23  Arash Esbati  <arash@gnu.org>

	Add new style/xr.el

	* Makefile.in (STYLESRC): Add new style.

	* style/xr.el: New file.

2021-11-23  Arash Esbati  <arash@gnu.org>

	Add new style/xr-hyper.el

	* Makefile.in (STYLESRC): Add new style.

	* style/xr-hyper.el: New file.

2021-11-23  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals in style/tcolorbox.el

	* style/tcolorbox.el (LaTeX-tcolorbox-keyval-options-local)
	(LaTeX-tcolorbox-update-style-key): Remove now unused variable and
	function.
	(LaTeX-tcolorbox-keyval-options): New function returning key=vals.
	(LaTeX-tcolorbox-keyval-options-full): Change the content of the
	variable.  It now holds a list of symbols.
	(LaTeX-tcolorbox-keyval-options-full): New function returning
	key=vals from symbols in the variable
	`LaTeX-tcolorbox-keyval-options-full'.
	("tcolorbox-tcbuselibrary"): Add the missing prefix to plural
	argument.
	(LaTeX-tcolorbox-auto-cleanup): Don't call
	`LaTeX-tcolorbox-update-style-key' anymore.
	("tcolorbox"): Use new function `LaTeX-tcolorbox-keyval-options'
	in the hook.
	Process the library names read in by \tcbuselibrary directly.

	* style/tcolorboxlib-raster.el
	(LaTeX-tcolorbox-lib-raster-env-item): Use the new function
	`LaTeX-tcolorbox-keyval-options'.
	("tcolorboxlib-raster"): Register library variable
	`LaTeX-tcolorbox-lib-raster-keyval-options' in
	`LaTeX-tcolorbox-keyval-options-full'.
	Use the function `LaTeX-tcolorbox-keyval-options' in the hook.

2021-11-22  Arash Esbati  <arash@gnu.org>

	Update style/multicol.el to package version 1.9b

	* style/multicol.el ("multicol"): Add new macros.  Change the
	query for \columnbreak which accepts an optional argument.
	Add fontification support for relevant macros.
	(LaTeX-multicol-package-options): Add new option "colcation".

2021-11-22  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix misc minor issues

	* latex.el (LaTeX-env-figure): Ensure temporal marker is cleaned in
	all cases.
	(LaTeX-current-verbatim-macro): Include asterisk, if present, in
	returned name.
	* tex-info.el (TeX-texinfo-mode): Set `TeX-comment-start-regexp'.
	* tex.el (TeX-verbatim-p): Call `TeX-verbatim-p-function' with
	argument POS.
	(TeX-verbatim-p-function): State explicitly in doc string about the
	argument POS of the function.

2021-11-21  Arash Esbati  <arash@gnu.org>

	Fontify \tabularnewline macro

	* font-latex.el (font-latex-built-in-keyword-classes): Add an
	entry for \tabularnewline to warning class.

2021-11-21  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals in style/caption.el

	* style/caption.el (LaTeX-caption-key-val-options-local)
	(LaTeX-caption-update-key-val-options): Remove now unused variable
	and function.
	(LaTeX-arg-caption-command): Remove function since the
	functionality is now provided by `TeX-arg-key-val' which is used
	in the hook.
	("caption"): Use `completing-read' to read a single key from
	provided key=vals for the macros \clearcaptionsetup*?.
	Various docstring fixes.

	* style/subcaption.el ("subcaption"): Don't use removed variable
	`LaTeX-caption-key-val-options-local' anymore.
	Various docstring fixes.

2021-11-19  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals in style/hologo.el

	* style/hologo.el ("hologo"): Use `TeX-arg-key-eval' instead of
	more complicated call of `TeX-arg-eval'.

2021-11-19  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals in style/floatrow.el

	* style/floatrow.el (LaTeX-floatrow-key-val-options-local)
	(LaTeX-floatrow-update-key-val-options): Remove now unused
	variable and function.
	(LaTeX-floatrow-key-val-options): New function returning key=vals.
	(LaTeX-floatrow-auto-cleanup)
	(LaTeX-floatrow-arg-declare-new-options): Remove call of
	`LaTeX-floatrow-update-key-val-options'.
	("floatrow"): Call the function `LaTeX-floatrow-key-val-options'
	instead of the variable `LaTeX-floatrow-key-val-options-local'.
	Minor spacing fixes.

2021-11-19  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix logic again

	* latex.el (LaTeX-fill-region-as-paragraph): When identifying code
	comment, continue search if the found candidate turns out not to be a
	code comment.
	Add a comment for regexp.

2021-11-18  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix wrong logic of the previous commit

	* latex.el (LaTeX-fill-region-as-paragraph): Take into account lines
	ending with "\par" or "\\" before code comments. We must always
	perform both code comment detection and regexp match.
	* tests/latex/latex-filling-in.tex:
	* tests/latex/latex-filling-out.tex:
	Add additional tests.

2021-11-17  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use coherent logic to identify code comment (bug#51762)

	* latex.el (LaTeX-fill-region-as-paragraph): Use the same logic to
	identify code comment as the rest of latex.el.
	Use shy regexp groups when possible.
	Add some comments.
	* tests/latex/latex-test.el (LaTeX-filling):
	* tests/latex/latex-filling-in.tex:
	* tests/latex/latex-filling-out.tex:
	Add new tests (including ones for bug#48937).

2021-11-17  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals in style/listings.el

	* style/listings.el (LaTeX-listings-key-val-options): Fix a typo.
	(LaTeX-listings-key-val-options-local)
	(LaTeX-listings-update-style-key): Remove now unused variable and
	function.
	(LaTeX-listings-key-val-options): New function returning key=vals.
	(LaTeX-listings-lstnewenvironment-regexp): Adjust matching of
	first optional argument.
	("listings"): Call the function `LaTeX-listings-key-val-options'
	instead of the variable `LaTeX-listings-key-val-options-local'.
	Various docstring fixes.

2021-11-15  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals in style/enumitem.el

	* style/enumitem.el (LaTeX-enumitem-key-val-options-local)
	(LaTeX-enumitem-newlist-list-local): Remove now unused variables.
	(LaTeX-enumitem-key-val-options): New function returning key=vals.
	Replace all occurrences of `LaTeX-enumitem-key-val-options-local'
	with a call to the new function.
	(LaTeX-arg-enumitem-SetLabelAlign)
	(LaTeX-arg-enumitem-SetEnumitemKey)
	(LaTeX-arg-enumitem-SetEnumitemValue): Add library prefix to the
	function names.
	(LaTeX-arg-enumitem-setlist): New function.
	(LaTeX-enumitem-update-key-val-options): Remove unused function.
	("enumitem"): Update style to package version 3.9, add support for
	'size' feature in \setlist and adjust fontification.  Fix typo for
	'labelindent'.  Various docstring fixes.

2021-11-13  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals in style/fancyvrb.el

	* style/fancyvrb.el (LaTeX-fancyvrb-key-val-options-local): Remove
	now unused variable.
	(LaTeX-fancyvrb-key-val-options): New New function returning
	key=vals.  Replace all occurrences of
	`LaTeX-fancyvrb-key-val-options-local' with a call to the new
	function.

	* style/fvextra.el (LaTeX-fvextra-key-val-options): Uncomment the
	"numbers" key=val.
	(LaTeX-fvextra-update-key-val): Remove the unused function and its
	addition to `TeX-auto-cleanup-hook'.
	("fvextra"): Replace all occurrences of
	`LaTeX-fancyvrb-key-val-options-local' with a call to the function
	`LaTeX-fancyvrb-key-val-options'.

	* style/pythontex.el: Declare the function
	`LaTeX-fancyvrb-key-val-options'.
	(LaTeX-env-pythontex, "pythontex"): Replace all occurrences of
	`LaTeX-fancyvrb-key-val-options-local' with a call to the function
	`LaTeX-fancyvrb-key-val-options'.

	* style/tex-live.el ("tex-live"): Call the function
	`LaTeX-fancyvrb-key-val-options' instead of the variable
	`LaTeX-fancyvrb-key-val-options-local'.

2021-11-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Don't use obsolete @inforef

	* doc/preview-latex.texi (Keys and lisp):
	(The Emacs interface):
	Use @xref instead of @inforef as Texinfo 6.8 marked it as obsolete.

2021-11-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	* doc/todo.texi (Mid-term Goals): Add TODO about tool bar.

2021-11-10  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals in style/minted.el

	* style/minted.el (LaTeX-minted-key-val-options-local)
	(LaTeX-minted-update-key-vals): Remove now unused variable and
	function.
	(LaTeX-minted-key-val-options): New function returning key=vals.
	(LaTeX-minted-auto-cleanup): Delete call of
	`LaTeX-minted-update-key-vals'.
	("minted"): Use new function in the style hook.

2021-11-10  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals in style/mdframed.el

	* style/mdframed.el (LaTeX-mdframed-key-val-options-local)
	(LaTeX-mdframed-update-style-key): Remove now unused variable and
	function.
	(LaTeX-mdframed-newmdenv-regexp)
	(LaTeX-mdframed-mdtheorem-regexp): Use the helper function
	`LaTeX-extract-key-value-label' to build the regexp.
	(LaTeX-mdframed-key-val-options): New function returning key=vals.
	("mdframed"): Use new function in the style hook.

2021-11-10  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals style/newfloat.el

	* style/newfloat.el (LaTeX-empheq-key-val-options-local): Remove
	now unused variable.
	(LaTeX-newfloat-key-val-options): New function returning key=vals.
	("newfloat"): Use new function `LaTeX-newfloat-key-val-options'.

2021-11-10  Arash Esbati  <arash@gnu.org>

	Improve handling of key=vals in style/empheq.el

	* style/empheq.el (LaTeX-empheq-key-val-options-local)
	(LaTeX-empheq-update-key-val-options): Remove now unused variable
	and function.
	(LaTeX-empheq-key-val-options): New function returning key=vals.
	(LaTeX-empheq-env, LaTeX-empheq-env-overload, "empheq"): Use new
	function `LaTeX-empheq-key-val-options' instead of variable
	`LaTeX-empheq-key-val-options-local'.  Minor code rearrangements.

2021-11-09  Arash Esbati  <arash@gnu.org>

	Improve style/babel.el

	* style/babel.el (LaTeX-babel-cleanup-babeltags): Use \' instead
	of $ to match string-end.  Drop unnecessary grouping.
	("babel"): Update various key=vals.

2021-11-09  Arash Esbati  <arash@gnu.org>

	* style/babel.el ("babel"): Use `LaTeX-fontspec-font-features'.

2021-11-08  Arash Esbati  <arash@gnu.org>

	Update style/fontspec.el to package version 2.7i

	* style/fontspec.el (LaTeX-fontspec-font-features): Update
	key=val list.
	(LaTeX-fontspec-font-features-local)
	(LaTeX-fontspec-update-font-features): Remove now unused variable
	and function.
	(LaTeX-fontspec-font-features): New function returning key=vals.
	(LaTeX-fontspec-auto-cleanup): Remove the call of
	`LaTeX-fontspec-update-font-features'.
	("fontspec"): Replace `LaTeX-fontspec-font-features-local' with
	`LaTeX-fontspec-font-features' call.

2021-11-08  Ikumi Keita  <ikumi@ikumi.que.jp>

	Supplement doc string

	* style/kpfonts.el (LaTeX-kpfonts-default): Supplement doc string
	according to recent change in doc string of `LaTeX-math-list'.

2021-11-03  Arash Esbati  <arash@gnu.org>

	Autoload `TeX-check-engine-add-engines' in tex.el

	* style/arabxetex.el ("arabxetex"):
	* style/babel.el ("babel"):
	* style/bidi.el ("bidi"):
	* style/fontspec.el ("fontspec"):
	* style/polyglossia.el ("polyglossia"): Don't require tex-buf.el
	in the style hook.

	* tex.el (TeX-check-engine-add-engines): Autoload the function so
	the styles using it don't have to require tex-buf.el.

2021-10-29  Arash Esbati  <arash@gnu.org>

	Extend `TeX-read-key-val' to accept a function call

	* doc/changes.texi: Document the change.

	* latex.el (TeX-read-key-val): Accept a function call returning an
	alist as second argument.

2021-10-24  Arash Esbati  <arash@gnu.org>

	* style/graphicx.el (LaTeX-graphicx-key-val-options): Add alt key.

2021-10-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Cater for corner case when dealing with TeX error

	* tex-buf.el (TeX-find-display-help): Don't try to open error file
	when it wasn't found.
	Some cleanups.

2021-10-05  Ikumi Keita  <ikumi@ikumi.que.jp>

	Silence compiler warning

	* tex-buf.el (TeX-parse-TeX):
	(TeX-error-overview-goto-source):
	Don't let-bind `default-major-mode'.
	(TeX-find-display-help): Fall back to the major mode of command
	buffer.

2021-10-05  Ikumi Keita  <ikumi@ikumi.que.jp>

	Explain how to do forward search by mouse

	* doc/auctex.texi (I/O Correlation): Add a sample usage of
	`TeX-source-correlate-map' and `TeX-view-mouse'.

2021-09-24  Ikumi Keita  <ikumi@ikumi.que.jp>

	* tests/latex/latex-test.el (LaTeX-flush-left-indent): New test.

2021-09-24  Ikumi Keita  <ikumi@ikumi.que.jp>

	Cleanup indentation of verbatim environments

	* latex.el (LaTeX-begin-regexp): Delete because this variable isn't
	used anywhere.
	(LaTeX-indent-calculate-last): Remove redundant regexp grouping.

2021-09-24  Ikumi Keita  <ikumi@ikumi.que.jp>

	Don't indent begin/end of comment env

	Begin/end line of comment environment must be flush left, just like
	verbatim environments.  However, comment environment shouldn't be
	included in `LaTeX-verbatim-environments' because
	1. filling shouldn't be disabled inside comment environment
	2. contents inside comment environment should be fontified as comment

	* latex.el (LaTeX-verbatim-regexp): Attach a new optional argument
	COMMENT to allow inclusion of comment environments.
	(LaTeX-indent-calculate): Indent begin/end line of comment environment
	at column 0.
	Remove redundant regexp grouping.
	(LaTeX-indent-calculate-last): Calculate indent after comment
	environment correctly.
	Remove redundant regexp grouping.

2021-09-24  Ikumi Keita  <ikumi@ikumi.que.jp>

	Explain how to support option completion

	* doc/auctex.texi (Adding Other): Add explanation for style file
	authors: How to provide support for completion of optional arguments
	for \usepackage and \documentclass.

2021-09-22  Ikumi Keita  <ikumi@ikumi.que.jp>

	Delete obsolete files and targets

	* auctex.spec:
	* preview-latex.spec:
	Delete rpm spec files.
	* Makefile.in (): Remove make targets rpm-packages and
	windows-package.
	* doc/preview-readme.texi (Availability): Remove mention about rpm
	package.
	Supplement description about git access.

2021-09-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add NEWS for two commands available in Texinfo mode

	* doc/changes.texi: Add news of two new entries in `TeX-command-list',
	"Texindex" and "Texi2dvi".

2021-09-08  Tassilo Horn  <tsdh@gnu.org>

	Recognize L3 \msg_line_context: on warning parsing

	* tex-buf.el (TeX-warning): Recognize L3 \msg_line_context: on warning
	parsing which reads "on line X" instead of "on input line X".

2021-09-02  Arash Esbati  <arash@gnu.org>

	Track standardized generic hook names in LaTeX kernel

	* latex.el (TeX-read-hook): Unify query for hooks and track the
	change for standardized generic hook names described in:
	https://github.com/latex3/latex2e/blob/develop/base/doc/ltnews34.tex

2021-08-30  Arash Esbati  <arash@gnu.org>

	Handle optional embellishment arguments correctly

	* style/xparse.el (LaTeX-xparse-macro-regexp)
	(LaTeX-xparse-environment-regexp): Include the entire match text
	to avoid ambiguity.
	(LaTeX-arg-xparse-embellishment-query): New function.
	(LaTeX-xparse-macro-parse): Handle embellishments (e/E argument
	type) correctly.

2021-08-30  Arash Esbati  <arash@gnu.org>

	Check the options and load the style backref.el

	* style/hyperref.el ("hyperref"): Run the style hook for
	backref.el when the corresponding option is given.
	Correct link to testform.tex.

2021-08-28  Tassilo Horn  <tsdh@gnu.org>

	Fix error when tex.el is loaded while default-directory doesn't exist

	* tex.el (TeX-view-program-select-evince): Bind `default-directory' to
	HOME for the shell command testing for the availability of
	evince-based viewer.  That triggered an error when tex.el is loaded as
	response to finding a tex file in a non-existent directory which at
	this point is the value of `default-directory' (bug#50225).

2021-08-27  Arash Esbati  <arash@gnu.org>

	Add new style/backref.el

	* Makefile.in (STYLESRC): Add new style.

	* style/backref.el: New file.

2021-08-26  Arash Esbati  <arash@gnu.org>

	* style/beamer.el ("beamer"): Improve indentation of \frametitle.

2021-08-24  Arash Esbati  <arash@gnu.org>

	Improve obeying the value of `TeX-insert-braces'

	* latex.el (LaTeX-common-initialization): Add "columnseprule" to
	list of known lengths and remove it from style/multicol.el.
	Remove 0 as specifier for symbols formerly provided by the
	textcomp package.

	* style/multicol.el ("multicol"): Add lengths defined by the
	package to list of known lengths.

	* style/brazilian.el ("brazilian"):
	* style/currvita.el ("currvita"):
	* style/ltugboat.el ("ltugboat"):
	* style/marginnote.el ("marginnote"):
	* style/mflogo.el ("mflogo"):
	* style/portuguese.el ("portuguese"): Remove 0 as specifier for
	the defined symbols.  Braces are now inserted after the symbols if
	`TeX-insert-braces' is non-nil.

2021-08-21  Al Haji-Ali  <abdo.haji.ali@gmail.com>

	Add NEWS entry for output-dir feature


	* doc/changes.texi (News in 13.1): Add NEWS entry for Al's output-dir
	feature.

2021-08-20  Arash Esbati  <arash@gnu.org>

	Update Pygments styles

	* style/minted.el (LaTeX-minted-key-val-options): Update values
	for style-key provided by Pygments v2.9.

2021-08-17  Arash Esbati  <arash@gnu.org>

	* style/ltxguide.el ("ltxguide"): Update syntactic font-locking.

2021-08-13  Arash Esbati  <arash@gnu.org>

	Improve style/xparse.el

	* style/xparse.el (LaTeX-xparse-macro-parse): Remove unnecessary
	grouping in regexps.
	("xparse"): Fix number of arguments of testing macros.

2021-08-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Avoid superfluous output directories

	* tex.el (TeX--master-output-dir): Add new optional argument ENSURE so
	that it doesn't make output dir when `TeX-region-file' is called from
	`TeX-set-mode-name', which can be called from
	`TeX-source-correlate-mode' in major mode function.
	(TeX--output-dir-arg): Feed t for the above new argument ENSURE.

2021-07-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add index files as clean target in Texinfo mode

	* tex-info.el (Texinfo-clean-intermediate-suffixes): Add index file
	suffixes.

2021-07-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add entries for Texinfo mode in `TeX-command-list'

	* tex.el (TeX-command-list): Add "Texindex" and "Texi2dvi" entries in
	`TeX-command-list'.
	* doc/auctex.texi (Superseding): Mention "Texindex" instead of "Index".

2021-07-21  Arash Esbati  <arash@gnu.org>

	Update style/ulem.el

	* style/ulem.el ("ulem"): Add macros \dashuline and \dotuline.
	Fix \markoverwith which takes one argument.
	Add \ULdepth to list of known lengths.
	Cater fontification for added macros.
	(LaTeX-ulem-fontdecl, LaTeX-ulem-fontcmd): Rename from
	`LaTeX-arg-fontdecl' and `LaTeX-arg-fontcmd'.
	(TeX-arg-ulem-fontdecl, TeX-arg-ulem-fontcmd): Use renamed
	variables.
	(TeX-arg-ulem-useunder): Don't listify the completion candidates,
	`completing-read' can handle list of strings.

2021-07-19  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix slowdown of font lock in doctex mode

	`texmathp' limits search by looking for empty lines, which appear
	frequently in LaTeX documents.  However, docTeX documents often lack
	such true empty lines.  In such buffer, `texmathp' must search
	from (point-min) every time, which slowed down font lock operation
	siginificantly.

	* texmathp.el (texmathp): Adjust regular expression so that a line
	containing only whitespaces except consecutive %'s at its beginning
	is considered as empty in doctex mode buffer.

2021-07-18  Arash Esbati  <arash@gnu.org>

	Be more precise about the first element in `LaTeX-math-list'

	* doc/auctex.texi (Mathematics):
	* latex.el (LaTeX-math-list): Update description for the first
	element KEY in `LaTeX-math-list'.
	Remove unnecessary quoting of opening/closing parenthesis.

2021-07-16  Arash Esbati  <arash@gnu.org>

	* tex-fold.el (TeX-fold-macro-spec-list): Add entry for "footref".

2021-07-12  Ikumi Keita  <ikumi@ikumi.que.jp>

	Clean up temporal markers

	* latex.el (LaTeX-env-figure, LaTeX-fill-region-as-paragraph)
	(LaTeX-fill-region-as-para-do,LaTeX-fill-paragraph)
	(LaTeX-fill-region):
	* style/dinbrief.el (LaTeX-dinbrief-env-recipient):
	* style/letter.el (LaTeX-env-recipient):
	* tex-info.el (Texinfo-reftex-section-info):
	* tex.el (TeX-parse-argument):
	Clean up temporal markers after their usage so that they don't slow
	down the subsequent editing in the buffer.

2021-07-07  Arash Esbati  <arash@gnu.org>

	Add support for LaTeX hook macros

	* doc/auctex.texi (Adding Macros): Document new functions for
	reading and inserting LaTeX hooks.

	* doc/changes.texi: Add entry for LaTeX hooks support.

	* font-latex.el (font-latex-built-in-keyword-classes): Add hook
	macros to function keywords class.

	* latex.el (TeX-global-input-files-with-extension): New variable.
	(TeX-read-hook, TeX-arg-hook): New functions for reading and
	inserting LaTeX hooks.
	(LaTeX-common-initialization): Add hook macros to AUCTeX's LaTeX2e
	hook.

2021-07-05  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add defensive `save-match-data'

	* preview.el.in (preview-set-texinputs): Follow the instruction
	"Simple Match Data Access" in elisp reference:
	   A search which fails may or may not alter the match data.  In the
	current implementation, it does not, but we may change it in the future.
	Don’t try to rely on the value of the match data after a failing search.

2021-07-05  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix order of arguments

	* preview.el.in (preview-make-image): Rearrange the arguments of `get'
	in correct order.
	Adapt doc string.

2021-07-05  Arash Esbati  <arash@gnu.org>

	* doc/auctex.texi (Modes and Hooks): Fix hook name.

2021-06-22  Ikumi Keita  <ikumi@ikumi.que.jp>

	Improve tool bar appearance

	* toolbar-x.el (toolbarx-emacs-add-button): Use built-in separator.
	Add :vert-only property to suppress labels unless vertical alignment
	is specified for labels.
	Reindent the codes.
	* preview.el.in (preview-mode-setup): Add :vert-only property as well.

2021-06-16  Ikumi Keita  <ikumi@ikumi.que.jp>

	Update document

	* doc/auctex.texi (Multifile): Delete description about nonexistent
	feature.

2021-06-16  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix doc strings and comment

	* latex.el (LaTeX-style-list):
	* preview.el.in (preview-document-pt-list):
	* tex-buf.el (TeX--concat-ext, TeX-command)
	(TeX-active-master-with-quotes):
	* tex.el (TeX-master,TeX-auto-regexp-list,TeX-auto-x-regexp-list)
	(TeX-output-dir, TeX--master-output-dir, TeX--output-dir-arg):
	Fix doc strings.
	Fix defcutom specs.
	* tex-fold.el (TeX-fold-mode): Fix comment.

2021-06-16  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix arguments given to makeglossaries

	* tex.el (TeX-expand-list-builtin): Add new placeholder "%(d-dir)".
	(TeX-command-list): Use it and give basename of the document, not .aux
	file names, as argument for makeglossaries.
	Tweak the order of the argument for biber and dvipdfmx for coherency.

2021-06-11  Arash Esbati  <arash@gnu.org>

	Define `TeX-parse-all-errors' in tex.el

	* tex-buf.el:
	* tex.el (TeX-parse-all-errors): Move defintion of custom variable
	into tex.el.  This variable is also used in
	`TeX-mode-specific-command-menu-entries' and results in an error
	when selecting 'Command' in the menu bar since tex.el doesn't
	require tex-buf.el.

2021-06-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix bug#36651

	* tex-fold.el (TeX-fold-mode): Open folded portion when isearch
	matches the hidden text.

2021-06-09  Tassilo Horn  <tsdh@gnu.org>

	Fix filling of code-and-comment lins where code ended in \% (bug#48937)

	* latex.el (LaTeX-fill-region-as-paragraph): Fix filling of
	code-and-comment lins where code ended in \% (bug#48937).

2021-06-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make TeX-fold-mode aware of superscript and subscript

	* tex-fold.el (TeX-fold-hide-item): Copy `display' property of
	underlying text to displayed text to raise superscript and lower
	subscript suitably.

2021-06-04  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use own error description for LaTeX mode only

	* tex-buf.el (TeX-error-description-list): Move its value to new
	variable in latex.el.  Now it holds user defined entries only and
	defaults to nil.
	(TeX-error-description-list-local): New variable to store buffer
	local list of error descriptions.
	(TeX-help-error): Combine values of the above two variables.
	* latex.el (LaTeX-error-description-list): New variable for LaTeX
	specific error descriptions, formerly stored in
	`TeX-error-description-list'.
	(LaTeX-common-initialization): Set local value of
	`TeX-error-description-list-local'.
	* tex-jp.el (toplevel): Overwrite `LaTeX-error-description-list'
	instead of `TeX-error-description-list'.
	* doc/changes.texi (News in 13.1): Mention about it.

2021-06-02  Ikumi Keita  <ikumi@ikumi.que.jp>

	Adapt for Texinfo mode

	* tex.el (TeX-local-master-p): Just look into
	`file-local-variables-alist' to return correct value even in TeXinfo
	mode.  This fixes bug#33227 as well.

2021-06-02  Arash Esbati  <arash@gnu.org>

	Define minor modes using keywords

	* tex.el (TeX-Omega-mode, TeX-interactive-mode):
	* tex-fold.el (TeX-fold-mode):
	* style/kpfonts.el (LaTeX-kpfonts-mode):
	* latex.el (LaTeX-math-mode): Use keywords to define minor modes.

2021-06-02  Arash Esbati  <arash@gnu.org>

	Check for `auto-fill-function' before filling

	* style/algorithm.el (LaTeX-env-algorithm):
	* style/beamer.el ("beamer"):
	* style/bicaption.el (LaTeX-arg-bicaption-bicaption):
	* style/caption.el (LaTeX-arg-caption-captionbox)
	(LaTeX-arg-caption-captionof):
	* style/currvita.el (LaTeX-currvita-env-with-label):
	* style/enumitem.el (LaTeX-enumitem-env-with-opts):
	* style/longtable.el (LaTeX-env-longtable):
	* style/moodle.el (LaTeX-moodle-question-env-with-args):
	* style/subcaption.el (LaTeX-arg-subcaption-subcaption)
	(LaTeX-arg-subcaption-subcaptionbox):
	* style/tcolorboxlib-raster.el (LaTeX-tcolorbox-lib-raster-env-item):
	* style/xltabular.el (LaTeX-env-xltabular): Fill the paragraph if
	`auto-fill-function' is non-nil.

2021-06-01  Tassilo Horn  <tsdh@gnu.org>

	Only re-fill \item contents if auto-fill-mode is active (bug#48760)

	* latex.el (LaTeX-env-item): Only fill the paragraph of the new \item
	if auto-fill-mode is activated (bug#48760).

2021-06-01  Arash Esbati  <arash@gnu.org>

	Remove backspace as paragraph separator

	* tex-info.el (TeX-texinfo-mode): Remove backspace from paragraph
	separator and start.  See also Emacs commit 3c6b59918a.

2021-05-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use #' rather than ' to quote function names

	* latex.el (LaTeX-match-class-option, LaTeX-auto-cleanup):
	* style/beamer.el (LaTeX-beamer-after-insert-env):
	* style/doc.el (LaTeX-doc-after-insert-macrocode):
	* tex-buf.el (TeX-style-check, TeX-error-overview-make-entries):
	* tex.el (TeX-match-style, TeX-run-style-hooks)
	(TeX-complete-word)
	(TeX-complete-make-expert-command-functions)
	(TeX-default-mode,TeX-auto-parse-region):
	Use #' rather than ' to quote function names.

2021-05-30  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix markups in documents

	* doc/auctex.texi (Internationalization): Fix markups.
	(Japanese): Reorder words so that unbreakable email addresses don't
	make the line ugly in pdf output.

2021-05-28  Ikumi Keita  <ikumi@ikumi.que.jp>

	Followup my commit on May 6

	* tex-buf.el (TeX-LaTeX-sentinel): Use `insert-file-contents-literally'
	instead of `insert-file-contents'.

2021-05-28  Arash Esbati  <arash@gnu.org>

	Improve completion

	* style/pdfpages.el ("pdfpages"): Allow directories while reading
	the file name.  Use "\'" to match the empty string at the end of
	regexp.

2021-05-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Improve `TeX-electric-macro' in Texinfo mode

	* tex.el (TeX-electric-macro): Compare with `last-command-event'
	rather than constant ?\ in case `@' is typed in Texinfo mode.

2021-05-26  Arash Esbati  <arash@gnu.org>

	Delete style/latexinfo.el from AUCTeX

	* Makefile.in (STYLESRC): Delete entry for style/latexinfo.el.

	* doc/changes.texi: Document removal of style.

2021-05-25  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add -dDELAYBIND only when necessary

	* preview.el.in (preview-pdf2dsc-sentinel): Add gs option -dDELAYBIND
	only when preview-latex tries to tweak foreground color.  According to
	gs developer[1], -dDELAYBIND option must be accompanied by ".bindnow"
	in gs init string.
	[1] https://lists.gnu.org/r/auctex-devel/2021-05/msg00030.html

2021-05-23  Ikumi Keita  <ikumi@ikumi.que.jp>

	Update documentation

	* doc/auctex.texi (Internationalization): Update according to recent
	utf8-oriented change in LaTeX.
	(Modes and Hooks): Display mode function names in lower case because
	`major-mode' variable holds those forms.
	(Mapping): Fix typo in key sequence.
	(Processing): Add mention about options to customize tool bar.
	(Adding Other): Add description how to examine package/class names and
	options.
	* doc/preview-latex.texi: Remove duplicated "@contents".
	* doc/preview-readme.texi (More documentation): Update acoording to
	change already done in favor of pdf format.
	* doc/quickstart.texi (Editing Facilities): Update paragraph written
	in days that `global-font-lock-mode' wasn't enabled by default.
	(Processing Facilities): Add mention about synctex.
	Update paragraph mentioning `TeX-PDF-from-DVI' rather than obsolete
	`TeX-PDF-via-dvips-ps2pdf' option.

	* doc/auctex.texi:
	* doc/changes.texi:
	* doc/faq.texi:
	* doc/install.texi:
	* doc/preview-faq.texi:
	* doc/preview-latex.texi:
	* doc/preview-problems.texi:
	* doc/preview-readme.texi:
	* doc/preview-todo.texi:
	* doc/quickstart.texi:
	* doc/tex-ref.tex:
	* doc/todo.texi:
	* doc/wininstall.texi:
	Fix and (hopefully) improve a lot of markups and comments.
	Add some FIXME's.
	Convert tabs to spaces.
	Add more indexes.
	Use "init.el" as well as ".emacs" as the name of user init file.

2021-05-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Indent region (bug#48518)

	* latex.el (LaTeX-insert-environment): Indent active region when
	`auto-fill-mode' is disabled.

2021-05-20  Arash Esbati  <arash@gnu.org>

	Improve style/algorithm.el

	* style/algorithm.el (LaTeX-algorithm-package-options): Add
	missing options.
	(LaTeX-env-algorithm): Insert a newline only when a label is
	really added.  Remove unnecessary comments.
	("algorithm"): Move `TeX-dialect' to be the third argument of the
	hook.

2021-05-13  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add new test

	* tests/latex/font-latex-test.el (font-latex-unclosed-dollars): New
	test.
	* font-latex.el (font-latex-find-dollar-math): Clean up doc string and
	comment.

2021-05-12  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix fontification when $ is unclosed in buffer

	* font-latex.el (font-latex-match-dollar-math): Ensure that limit
	passed to `font-latex-find-dollar-math' doesn't exceed end of buffer.

2021-05-12  Arash Esbati  <arash@gnu.org>

	Add new variable `TeX-normal-mode-reset-list'

	* latex.el:
	* style/graphicx.el: Add variables to `TeX-normal-mode-reset-list'
	which were hard-coded in `TeX-normal-mode'.

	* tex.el (TeX-normal-mode-reset-list): New variable for symbols to
	be reset when the command `TeX-normal-mode' is run with argument.
	(TeX-normal-mode): Remove the hard-coded variables and use
	`TeX-normal-mode-reset-list'.
	Remove the defvar's silencing the compiler.

2021-05-11  Tassilo Horn  <tsdh@gnu.org>

	Skip inline math $ inside comments (bug#48365)

	* font-latex.el (font-latex-find-dollar-math): Skip inline math $
	inside comments.

2021-05-11  Arash Esbati  <arash@gnu.org>

	Introduce new variable `LaTeX-global-package-files'

	* latex.el (LaTeX-global-package-files): New variable holding
	LaTeX package files.
	(LaTeX-arg-usepackage-read-packages-with-options): Set and use it
	instead of `TeX-global-input-files'.

	* tex.el (TeX-normal-mode): Reset also
	`LaTeX-global-package-files' when invoked with ARG.
	Silence the compiler.

2021-05-06  Ikumi Keita  <ikumi@ikumi.que.jp>

	Ensure rawness of data to compute MD5

	* tex-buf.el (TeX-run-TeX): Use `insert-file-contents-literally'
	instead of `insert-file-contents' in order to avoild possible wrong
	MD5 value due to unnecessary encoding conversion.
	;(TeX-sentinel-function, TeX-sentinel-default-function): Fix typo.

2021-05-06  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make `TeX-run-format' self-contained (bug#48144)

	* tex-buf.el (TeX-run-format, TeX-run-TeX): Move initialization of
	`TeX-error-report-switches' from `TeX-run-TeX' to `TeX-run-format'.
	This makes `TeX-TeX-sentinel', set to `TeX-sentinel-function', work
	without error when `TeX-run-format' is called outside of
	`TeX-run-TeX'.
	(TeX-error-report-switches, TeX-error-report-has-errors-p): Define
	them before `TeX-run-format' to prevent compiler warning.

2021-05-05  Arash Esbati  <arash@gnu.org>

	Support new kernel macro \footref

	* font-latex.el (font-latex-built-in-keyword-classes): Add entry
	for footref to reference class.

	* latex.el (LaTeX-common-initialization): Add support for
	\footref macro.

2021-05-04  Arash Esbati  <arash@gnu.org>

	Add support for (Brazilian) Portuguese

	* tex.el (TeX-quote-language-alist): Add entry for "portuguese".

	* doc/auctex.texi (European): Document the features of new
	language styles.

	* Makefile.in (STYLESRC): Add entries for new styles.

	* style/brazil.el:
	* style/brazilian.el:
	* style/portuges.el:
	* style/portuguese.el: New files.

2021-04-28  Tassilo Horn  <tsdh@gnu.org>

	Allow one level of braces in verbatim environment args (bug#48078)

	* font-latex.el (font-latex-set-syntactic-keywords): Allow one level
	of braces in verbatim environment args (bug#48078).

2021-04-27  Tassilo Horn  <tsdh@gnu.org>

	Fix filling issue caused by commit 98455d05.

	* latex.el (LaTeX-fill-region-as-para-do): Call
	LaTeX-back-to-indentation without explicit arg again.

2021-04-25  Tassilo Horn  <tsdh@gnu.org>

	Fix matching of script chars (bug#48012)

	* font-latex.el (font-latex-match-script-chars): Don't stop after
	findind the first script char which turns out not to be an actual
	script char (bug#48012).

2021-04-23  Tassilo Horn  <tsdh@gnu.org>

	Give explicit arg to LaTeX-back-to-indentation in filling functions.

	Also add some comment filling tests, and adapt one existing test to
	new filling behavior introduced in previous commit.

	* latex.el (LaTeX-fill-region-as-para-do):
	(LaTeX-fill-move-to-break-point): Provide explicit arg to
	`LaTeX-back-to-indentation'.

2021-04-23  Tassilo Horn  <tsdh@gnu.org>

	Don't treat comments with whitespace before % as code comments

	* latex.el (LaTeX-fill-region-as-paragraph): Don't treat comments with
	whitespace before % as code comments (mentioned as addendum to
	bug#47757).

2021-04-23  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add new test

	* tests/latex/latex-test.el (LaTeX-electric-pair-interaction): New
	test.
	* latex.el (LaTeX-insert-left-brace): Add comments.

2021-04-22  Ikumi Keita  <ikumi@ikumi.que.jp>

	Follow up previous commit

	* latex.el (LaTeX-insert-left-brace): Let side effects of
	self-insertion, such as electric paring, to occur when this function
	doesn't do special treatment.

2021-04-22  Ikumi Keita  <ikumi@ikumi.que.jp>

	Get rid of unexpected side effects

	* latex.el (LaTeX-insert-left-brace): Use `insert' instead of
	`self-insert-command' to avoid all unexpected interactions.
	(LaTeX-insert-corresponding-right-macro-and-brace)
	(LaTeX-common-initialization):
	Remove codes which is no longer necessary.

2021-04-21  Philip K  <philipk@posteo.net>

	Improve handling for parentheses with electric-pair-mode (bug#47936)

	* latex.el (LaTeX-insert-corresponding-right-macro-and-brace): Improve
	handling for parentheses with electric-pair-mode (bug#47936).

2021-04-18  Tassilo Horn  <tsdh@gnu.org>

	Fix the fix of bug#47757 which broke comment filling.

	* latex.el (LaTeX-back-to-indentation): Move point to the comment
	content only if the current command is no newline command (fixes the
	previous fix for bug#47757 which broke comment filling).

2021-04-16  Tassilo Horn  <tsdh@gnu.org>

	Rename TeX-xreader-sync-view to TeX-reader-sync-view (bug#47807)

	* tex.el (TeX-reader-sync-view): Rename from
	TeX-xreader-sync-view (bug#47807).

2021-04-14  Tassilo Horn  <tsdh@gnu.org>

	Don't move past % if the current command is a non-indent command

	* latex.el (LaTeX-back-to-indentation): Don't move past % if the
	current command is a non-indent command (bug#47757).

2021-04-05  Ikumi Keita  <ikumi@ikumi.que.jp>

	Simplify conditionals evaluating to constant

	* font-latex.el (font-latex-bold-face, font-latex-italic-face)
	(font-latex-math-face, font-latex-string-face)
	(font-latex-warning-face, font-latex-verbatim-face)
	(font-latex-script-char-face):
	All supported emacsens support :inherit attribute for face and
	have `fixed-pitch' basic face.

2021-04-05  Ikumi Keita  <ikumi@ikumi.que.jp>

	Resolve constant fboundp/boundp/featurep

	* bib-cite.el (bib-apropos-keyword-at-point):
	* context.el (ConTeXt-menu-update)
	(ConTeXt-mode-common-initialization):
	* latex.el (LaTeX-math-initialize)
	(LaTeX-fill-move-to-break-point):
	* multi-prompt.el (multi-prompt-next):
	* preview.el.in (preview-transparent-border)
	(preview-place-preview, preview-reinstate-preview):
	* style/kpfonts.el (math):
	* style/dk-bib.el (LaTeX-dk-bib-package-options):
	* tex-buf.el (TeX-shell-command-option, TeX-check-engine):
	* tex-fold.el (TeX-fold-item, TeX-fold-post-command):
	* tex.el (TeX-source-specials-view-start-server)
	(TeX-auto-private, TeX-style-private, TeX-complete-symbol)
	(VirTeX-common-initialization, TeX-token-char)
	(TeX-mode-specific-command-menu-entries)
	(TeX-math-input-method-off, TeX-abbrev-mode-setup):
	Simplify conditionals containing `fboundp', `boundp' and `featurep'
	which evaluate to constant.

	* latex.el (LaTeX-math-initialize, LaTeX-fold-math-spec-list):
	Simplify by not using `decode-char'.  Now that emacs is unicode based,
	(decode-char 'ucs ARG) is trivial operation which just returns ARG.
	Code point in ucs is the same as emacs char.

	* multi-prompt (multi-prompt): Use #' to quote function names.
	(multi-prompt-next-must-match): Use
	`minibuffer-contents-no-properties' instead of
	`buffer-substring-no-properties'.

2021-04-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for Emacs<24.3

	* latex.el (LaTeX-insert-left-brace):
	* tex.el (TeX-insert-dollar):
	Simplify the property `delete-selection-mode'.
	(VirTeX-common-initialization): Use " " for `comment-padding'.
	(TeX-math-input-method-off): Never use `inactivate-input-method'.

2021-04-01  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use #' instead of ' to quote function names

	* bib-cite.el (bib-switch-to-buffer-function):
	* latex.el (LaTeX-item-array, LaTeX-item-tabular*)
	(LaTeX-math-insert-function, LaTeX-environment-menu-entry)
	(LaTeX-environment-modify-menu-entry)
	(LaTeX-section-menu-entry, LaTeX-indent-tabular)
	* preview.el.in (preview-auto-reveal, preview-copy-mml)
	(preview-copy-region-as-mml, preview-generate-preview):
	* style/amsmath.el (LaTeX-item-equation-alignat):
	* style/amsthm.el (LaTeX-amsthm-auto-cleanup)
	("amsthm"):
	* style/biblatex.el ("biblatex"):
	* style/dinbrief.el (LaTeX-dinbrief-style)
	(LaTeX-dinbrief-env-recipient):
	* style/exam.el ("exam"):
	* style/jurabib.el ("jurabib"):
	* style/letter.el (LaTeX-env-recipient):
	* style/minted.el (LaTeX-minted-auto-cleanup):
	* style/natbib.el ("natbib"):
	* style/ntheorem.el (LaTeX-ntheorem-auto-cleanup)
	("ntheorem"):
	* style/pythontex.el ("pythontex"):
	* style/tcolorbox.el (LaTeX-tcolorbox-auto-cleanup):
	* style/theorem.el (LaTeX-theorem-auto-cleanup)
	("theorem"):
	* style/xparse.el (LaTeX-xparse-macro-parse):
	* tests/latex/font-latex-test.el (font-latex-three-dollars)
	(font-latex-extend-region-backwards-quotation)
	(font-latex-general-fontification):
	* tex-bar.el (TeX-bar-TeX-button-alist)
	(TeX-bar-LaTeX-button-alist):
	* tex-buf.el (TeX-command-master, TeX-view):
	* tex-info.el (TeX-texinfo-mode):
	* tex-fold.el (TeX-fold-post-command):
	* tex-site.el.in (tex-site-unload-hook):
	* tex.el (TeX-expand-list-builtin,toplevel)
	(TeX-source-correlate-start-server-maybe)
	(TeX-install-font-lock, TeX-command-current)
	(TeX-command-select-master, TeX-command-select-buffer)
	(TeX-command-select-region, TeX-newline-function)
	(TeX-mode-specific-command-menu-entries)
	(TeX-font-replace-function, TeX-insert-dollar):
	* toolbar-x.el (toolbarx-default-toolbar-meaning-alist):
	* doc/auctex.texi (Mathematics, Filling, Folding)
	(Hacking the Parser):
	* doc/tex-ref.tex:
	Use #' instead of ' to quote function names.

	tex.el (): Add `declare-function' for `gnuserv-start'.

2021-04-01  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use closure rather than hand-made lambda

	* latex.el (LaTeX-math-initialize):
	* style/kpfonts.el (math):
	* toolbar-x.el (toolbarx-make-command):
	Use closure rather than hand-made lambda form.

2021-04-01  Ikumi Keita  <ikumi@ikumi.que.jp>

	Resolve unnecassary back quote

	* font-latex.el (font-latex-user-keyword-classes,
	(font-latex-slide-title-face):
	* tex-fold.el (TeX-fold-macro-spec-list):
	Turn unnecassary back quote into forward quote.
	Fix typo in doc string.

2021-04-01  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove xemacs compat elements

	* tex-bar.el (TeX-bar-TeX-buttons, TeX-bar-LaTeX-buttons):
	Don't use vector as element.
	* toolbar-x.el (toolbarx-install-toolbar): Fix doc string.
	Partially revert the comments removed recently which are still
	valid.

2021-03-31  Arash Esbati  <arash@gnu.org>

	Add new fontification test

	* tests/latex/font-latex-test.el
	(font-latex-general-fontification): Add test for general
	fontification of vanilla LaTeX files.

2021-03-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use built-in functions for similar functions

	* tex.el (TeX-split-string): Simplify by `split-string' and mark
	obsolete.
	(TeX-assoc): Simplify by `assoc-string' and mark obsolete.
	* doc/changes.texi (News in 13.0): Add announce that these functions
	are removed in future release.

	* latex.el (LaTeX-split-bibs, LaTeX-auto-cleanup)
	(LaTeX-209-to-2e):
	* style/babel.el (LaTeX-babel-active-languages):
	Replace `TeX-split-string' by `split-string'.

	* tex-buf.el (TeX-command-query, TeX-printer-query): Replace
	`TeX-assoc' by `assoc-string'.

2021-03-30  Ikumi Keita  <ikumi@ikumi.que.jp>

	Some minor followups

	* doc/tex-ref.tex: Fix markups as well as a few errors.
	Remove mention about xemacs.
	* tex.el (TeX-expand-list-builtin): Simplify.
	* tests/make-test-deps.emacs-lisp: Enable lexical binding.
	Update Copyright year.

2021-03-29  Arash Esbati  <arash@gnu.org>

	Fix broken test

	* tests/japanese/preview-latex.el: Mark
	`japanese-TeX-error-messages' as special before dynamically
	binding it.

2021-03-28  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix doc string

	* tex.el (TeX-expand-list): Delete obsolete comment.
	State that variable name is allowed as the second element and how that
	is treated.

2021-03-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Reduce byte compiler warning

	* tex.el (): Move `(eval-when-compile (require 'dbus))' before
	`declare-function's of dbus related functions because otherwise they
	seem ineffective.
	Both NOERROR optional argument for `(require 'dbus)' and `(featurep
	'dbusbind)' test are removed deliberately because
	(1) Now all supported emacsen have dbus.el.
	(2) Even if emacs is built with configure option "--without-dbus", it
	    doesn't cause error to load dbus.el just to get macro definition
	    of `dbus-ignore-errors'.
	This way, it works fine even when
	(a) Emacs used for byte-compiling lacks D-Bus support.
	(b) Emacs at run time has D-Bus support.
	without relying on `TeX--if-macro-fboundp'.

	(): Remove `declare-function' for `dbus-ignore-errors' because it's
	now guaranteed that the macro is expanded away at byte compile time.
	(): Remove `defvar' for `dbus-debug' because `dbus.el' provides a
	suitable defvar.

2021-03-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Reduce byte compiler warning

	* tex.el (VirTeX-common-initialization,toplevel): Don't set obsolete
	ispell variables `ispell-tex-p' and `ispell-tex-major-modes'.  Neither
	appears in NEWS.* nor source of emacs 24.3.
	(TeX-run-ispell): Don't call obsolete functions `spell-buffer' and
	`spell-region'.
	(): Discard `declare-function' for `spell-buffer'.
	Add `defvar' for `ispell-parser' to silence byte compiler.

2021-03-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use #' instead of ' to quote function where possible

	* latex.el (LaTeX-babel-insert-hyphen):
	* multi-prompt.el (multi-prompt-delete)
	(multi-prompt-next-must-match):
	* style/biblatex.el ("biblatex"):
	* style/newfloat.el ("newfloat"):
	* style/ntheorem.el ("ntheorem"):
	* style/wrapfig.el ("wrapfig"):
	* tex.el (TeX-electric-macro, TeX-insert-punctuation)
	(TeX-run-ispell):
	Use #' instead of ' to quote function where possible.

2021-03-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Reduce byte compiler warning

	* bib-cite.el (bib-display-or-find-label): Use `outline-show-entry'
	instead of `show-entry' when possible.  Wrap `show-entry' with
	`with-no-warnings'.
	(bib-get-citations, psg-list-env): Use `replace-regexp-in-string'
	instead of `dired-replace-in-string'.
	Use `split-string' instead of `dired-split' and `TeX-split-string'.
	(dired-replace-in-string,TeX-split-string): Delete fallback
	definitions.
	(): Remove `declare-function' for `dired-replace-in-string' and
	`dired-split'.

2021-03-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Reduce byte compiler warning

	* bib-cite.el (bib-bib-label-help-echo-format, bib-ext-list)
	(bib-label-help-echo, bib-label-help):
	Delete remaining XEmacs only functions and variables.
	(bib-highlight-mouse): Don't touch removed variable.
	(bib-etags-command, bib-etags-append-command, bib-display, bib-find)
	(bib-find-next, bib-make-bibliography, bib-edit-citation)
	(bib-get-bibliography):
	Fix doc strings.

2021-03-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	* tests/japanese/preview-latex.el: Make cleanup forms more robust

2021-03-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix preamble cache

	* preview.el.in (preview-cache-preamble): Remove trash left when
	preferring closure over backquote+lambda.
	(preview-gs-flag-error): Replace `str' with `string' for clarity;
	`str' is used again in the clause just after the one in question.

2021-03-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix preview-latex and regression tests

	* preview.el.in (preview-query-replace-reveal): Add treatment for
	nadvice functions.
	(): Promote defvar's without value to proper defvar's to prevent
	unexpected error when external program calls preview-latex functions.
	* tests/latex/font-latex-test.el (): Add defvar for `font-lock-beg'
	and `font-lock-end' to make dynamic binding at let-binding them.
	* tests/tex/path-expansion.el: Add temporal defvar for dummy variable.
	* tests/japanese/preview-latex.el
	(japanese-preview-preserve-kanji-option2)
	(japanese-preview-preserve-kanji-option3):
	Make cleanup forms more robust.

2021-03-25  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix font-latex.el

	* font-latex.el (font-latex-make-built-in-keywords): Defer making
	`font-latex-match-*' buffer-local so that it attains sane default
	value.

2021-03-25  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix void function error

	* font-latex.el (font-latex-make-built-in-keywords): Bring back the
	defun of `font-latex-match-*-make` before the defcustom of
	`font-latex-match-*-keywords' because the latter depends on the
	former through :set function.
	Add defvar without value to suppress byte compile warnings for
	`font-latex-match-*-keywords'.

2021-03-25  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix documents

	* doc/auctex.texi (LaTeX-amsmath-label): Add multline env. and remove
	aligned env. since the former gets label while the latter doesn't get.
	(Error overview): Delete spurious "on".
	* doc/install.texi (Prerequisites): Raise minimum required version to
	24.3.
	* doc/preview-faq.texi (Requirements): Add description about
	availability on Windows.
	Remove reference on table deleted before.
	Adapt subsection title.

2021-03-25  Ikumi Keita  <ikumi@ikumi.que.jp>

	Discard obsolete variables

	According to NEWS.24, `font-lock-defaults-alist' was removed at
	emacs 24.1.
	`font-lock-mode-enable-list' doesn't exist in any NEWS.* nor emacs
	24.3 source. (Xemacs specific variable?)
	According to loaddefs.el, `font-lock-auto-fontify' is xemacs variable
	corresponding to `global-font-lock-mode'.

	* tex-buf.el:
	(): Remove defvar for `font-lock-mode-enable-list',
	`font-lock-auto-fontify' and `font-lock-defaults-alist'.
	(TeX-region-create): Don't let-bind obsolete variables.
	Stop let-binding `font-lock-defaults' since it is buffer local
	variable. It doesn't make sense to let-bind it before changing the
	current buffer.
	Set NOWARN argument to t in `find-file-noselect' to suppress "(New
	file)" message in echo area.

2021-03-25  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix merging

	* tex-buf.el (TeX-region-update): Use `begin', not `TeX--begin'.
	* tex.el (TeX--call-minor-mode): Rename from `tex--call-minor-mode' to
	make prefix uniform in AUCTeX.
	(): Add autoload declaration of `TeX-previous-error'.
	(TeX-output-dir): Use #' instead of ' to quote function name.

2021-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Use UTF-8 for all ELisp files

	UTF-8 is the default encoding used for ELisp files nowadays, so
	convert the few remaining exceptions.

	* tests/japanese/preview-latex.el:
	* tex-jp.el: Remove `coding:` cookie and re-encode into utf-8.

2021-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Prefer lexical closures over hand-built lambda forms

	now that we have lexical-binding, we can use closures, which have the
	advantage over `(lambda ...) of allowing the byte-compiler to compile
	the code, and also makes it possible to Edebug it.

	* preview.el (preview-gs-close, preview-gs-flag-error)
	(preview-scale-from-face, preview-gs-flag-error)
	(preview-scale-from-face, preview-disabled-string)
	(preview-buffer-restore, preview-place-preview)
	(preview-reinstate-preview, preview-cache-preamble)
	(preview-generate-preview, preview-report-bug):
	* toolbar-x.el (toolbarx-emacs-mount-popup-menu):
	* tex.el (TeX-mode-specific-command-menu): Replace `(lambda...) with closures.

2021-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Activate lexical-binding everywhere

	Also, add an underscore at the beginning of unused arguments to
	silence warnings.

	* bib-cite.el (bib-highlight-mouse): Remove unused vars `extent`
	and `local-extent-list`.

	* latex.el (LaTeX-label): Remove unused var `label`.
	(LaTeX-math-mode-map): Move before first use.

	* preview.el.in (preview-start-dvipng, preview-start-dvips):
	Remove unused var `file`.

	* tex-fold.el (TeX-fold-macro-nth-arg): Remove unused var `close-string`.
	(TeX-fold-hide-item): Remove unused var `face`.

	* tex-font.el (tex-font-lock-keywords-2): Remove unused var `type`.

	* tex-info.el (Texinfo-mark-section): Rework to avoid relying on
	dynamic scoping to access local vars.

	* toolbar-x.el (toolbarx-test-toolbar-type): Remove unused vars
	`all-but-def-opts` and `all-opts`; remove always-t var `good-jobs`.

2021-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Expose the body of advice to the compiler

	While at it, use `advice-add` when available.
	We can drop `defadvice` completely when we bump the required version
	to Emacs-24.4, or if/when we add `nadvice` as a required package.

	* context.el (ConTeXt--invalidate-menu): New function.
	(ConTeXt-add-environments): Advise with it.

	* latex.el (LaTeX-add-bibliographies): Advise with `TeX-run-style-hooks`.
	(LaTeX--invalidate-menus): New function.
	(LaTeX-add-environments): Advise with it.

	* preview.el.in (preview--open-for-replace): New function.
	(replace-highlight): Advise with it.

	* tex.el (tex--call-minor-mode): New function.
	(hack-one-local-variable): Advise with it.

2021-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Miscellaneous minor changes

	Move to the next line arguments that are easy to misread.
	Fix some commenting style to obey `outline-minor-mode`.

	* auctex.el.in: Don't require `cl-lib` since it's bundled with Emacs-24.3.

	* README: Prefer HTTPS over HTTP/FTP for gnu.org sites.

	* bib-cite.el (bib-find-next): Simplify.

	* latex.el: Use a non-nil default value for `LaTeX-label-function`
	so RefTeX can override it with `add-function`.
	(LaTeX-label--default): New function, extracted from `LaTeX-label`.
	(LaTeX-label): Use it.
	(LaTeX-label-function): Use it as default value.

	* toolbar-x.el (toolbarx-emacs-mount-popup-menu): Make the control&data
	flow a bit simpler.
	(toolbarx-test-image-type, toolbarx-process-dropdown-group):
	Use `car-safe` and strength-reduce `eval` to `symbol-value`.

	* style/dinbrief.el: Remove redundant comment.

	* style/kpfonts.el (<toplevel>): Simplify.

	* style/latexinfo.el (LaTeXinfo-mode-map): Move initialization into
	the declaration.

	* style/url.el (TeX-arg-urlstyle):
	* style/prosper.el (LaTeX-prosper-slide-style-prompt):
	Completion tables can be lists of strings.

	* style/tikz.el (TeX-TikZ-single-macro-arg): Strength-reduce `eval` to
	`apply`.

	More misc changes

2021-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Remove some XEmacs and old-Emacs code

	Remove uses of `easy-menu-add` and `easy-menu-remove` which have
	always been no-op in Emacs and are declared obsolete in Emacs-28.

	* bib-cite.el (bib-cite-setup-highlight-mouse-keymap): Remove Emacs-19 code.

	* tex-buf.el (TeX-region-create): Remove use of variable
	`font-lock-maximum-size` declared obsolete in Emacs-24.

	* toolbar-x.el: Remove left over code from XEmacs compatibility.
	Remove XEmacs-only `:toolbar` and `:dropdown-toolbar` as well
	`:insert` which was only used to select Emacs-only or XEmacs-only entries.
	(toolbarx-default-toolbar-meaning-alist): Replace all uses of
	`[Emacs-only XEmacs-only]` vectors with the `Emacs-only` form.

2021-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Don't quote `lambda`

	Remove some redundant `:group` arguments

2021-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Use #' rather than ' to quote functions

	This helps track down typos, references to functions which don't exist
	any more, as well as references to obsolete functions.

2021-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* font-latex.el (font-latex-make-built-in-keywords): Make it a macro

	This lets us expose the code it generates to the compiler without
	having to call `byte-compile` explicitly.  It also reduces the reliance
	on `eval`, saving the souls of many kitten along the way.

	(font-latex-built-in-keyword-classes): Define it at compile-time as well.
	(font-latex-keywords-1, font-latex-keywords-2):
	Move their definition to `font-latex-make-built-in-keywords`.
	(font-latex-keyword-matcher): Define it at compile-time as well.
	(font-latex--make-match-defun): Rename from `font-latex-make-match-defun`.
	Define it at compile-time as well.  Return the function definition (as
	the docstring suggests) rather than evaluating it.
	(font-latex-make-user-keywords): Adjust call to it.
	(<toplevel>): Don't manually call the byte-compiler.

2021-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* font-latex.el (font-latex-make-built-in-keywords): Reorder defs

	Move definition of `font-latex-match-*-make` after the `defvar`s of
	the vars it uses.

2021-03-23  Ikumi Keita  <ikumi@ikumi.que.jp>

	Prepare for enabling lexical binding in preview.el.in

	* tex-buf.el (TeX-region-update):
	* preview.el.in (preview-region, preview-counters)
	(preview--counter-information):
	Turn a piece of advice for `TeX-region-create' into a helper function
	`preview--counter-information', and invoke it at all calls of
	`TeX-region-create'.
	Use `buffer-substring-no-properties' instead of `buffer-substring' to
	save memory usage a bit.
	Simplify code by `TeX-current-offset'.

	* tex-buf.el (TeX-region-create):
	* preview.el.in (preview-preamble, preview--skip-preamble-region):
	Turn another advice for `TeX-region-create' into a helper function
	`preview--skip-preamble-region' and call it in `TeX-region-create'.

	* tex-buf.el (TeX-region-extra): Move `defcustom' before its new first
	usage.

2021-03-18  Ikumi Keita  <ikumi@ikumi.que.jp>

	Discard `TeX-auto-update' to silence byte compiler

	Now that we add `TeX-safe-auto-write' as local hook in
	`write-contents-functions', we don't have to check every time whether
	it is AUCTeX buffer.

	* latex.el (BibTeX-auto-store):
	* tex-info.el (TeX-texinfo-mode):
	Don't set `TeX-auto-update'.
	* tex.el (VirTeX-common-initialization): Don't set `TeX-auto-update'.
	(TeX-safe-auto-write): Don't check whether it is AUCTeX buffer or
	BibTeX buffer.
	(TeX-update-style): Consult `major-mode' instead of `TeX-auto-update'
	to check whether it is BibTeX buffer.
	* bib-cite.el: Don't use `TeX-auto-update'. Consult `TeX-mode-p' to
	check whether it is AUCTeX buffer.

2021-03-17  Al Haji-Ali  <a.hajiali@hw.ac.uk>

	Implement the user option TeX-output-dir

	* doc/auctex.texi (Control/Controlling the output): Document the
	new TeX-output-dir user option.

	* preview.el.in (preview-pdf2dsc-command): Replace concatenated output
	file names with the new expansions.
	(preview-LaTeX-command): Use an expansion for filename only.
	(preview-create-subdirectory): Retrieve prv path from
	TeX-active-master.
	(preview-dump-replacements, preview-undump-replacements): Do not
	discard --output-directory from the command arguments.
	(preview-cache-preamble, preview-document): Call TeX-save-document
	with file function instead of filename.
	(TeX-inline-preview-internal): Retrieve prv path from TeX-master-file.

	* tex-bar.el (TeX-bar-TeX-button-alist, TeX-bar-LaTeX-button-alist):
	Call TeX-save-document with file function instead of filename.

	* tex-buf.el (TeX-save-document, TeX-command-default)
	(TeX-command-query): Change implementation to accept file function as
	well as filename as argument.
	(TeX--concat-ext): New helper function.
	(TeX-command-master, TeX-command-region): Call TeX-command-query with
	file function instead of filename.
	(TeX-command): Update documentation.
	(TeX-active-master-with-quotes): Add new argument for pre-processing
	filename.
	(TeX-command-sequence): Pass file function to TeX-command-default.
	(TeX-run-TeX, TeX-run-index, TeX-LaTeX-sentinel): Call
	TeX-active-master instead of concatenating extension to filename.
	(TeX-region-file): Change to return paths in TeX-output-dir when
	non-nil.

	* tex.el (TeX-command-list, LaTeX-command-style): Change commands to
	pass output-directory as an argument.
	(TeX-print-command, TeX-printer-list): Use "%d" for dvi files.
	(TeX-expand-list-builtin): Add expansions for output files and
	directories.
	(TeX-clean): Refactor to use the new TeX--clean-extensions-regexp.
	(TeX-master-file): Change to return output files inside
	TeX-output-file.
	(TeX-output-dir): New user option.
	(TeX--master-output-dir, TeX--output-dir-arg)
	(TeX--clean-extensions-regexp): New function.
	(TeX-split-string): Correct a spelling mistake.

2021-03-06  Arash Esbati  <arash@gnu.org>

	Improve style/footmisc.el

	* style/footmisc.el ("footmisc"): Add completion support for some
	macros.  Support special macros defined only with `splitrule'
	option.  Improve fontification.

2021-03-03  Tassilo Horn  <tsdh@gnu.org>

	Use "wrap region or query for logo" also in \[hH]ologoVariant

	* style/hologo.el: Use "wrap region or query for logo" also in
	\[hH]ologoVariant.

2021-03-03  Tassilo Horn  <tsdh@gnu.org>

	Fix wrapping of active region with \[Hh]ologo macros

	* style/hologo.el (LaTeX-hologo--arg-use-region-or-query-logo-name):
	Fix wrapping of logo in active region.

2021-03-02  Tassilo Horn  <tsdh@gnu.org>

	Use active region if it is a logo name.

	* style/hologo.el (LaTeX-hologo--arg-use-region-or-query-logo-name):
	New function for the logo name arg of \hologo and \Hologo.

2021-02-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Enable lexical binding in context-{en,nl}.el

	* context-en.el:
	* context-nl.el:
	Enable lexical binding.
	Update copyright year.

2021-02-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix preview-cache-preamble after region typeset/preview

	* preview.el.in (preview-cache-preamble): Move `setq' for
	`TeX-current-process-region-p' before `let*' so that
	`TeX-command-expand' in `let*' should work correctly.

2021-02-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Enable lexical binding in plain-tex.el

	* plain-tex.el: Enable lexical binding.
	Update copyright year.

2021-02-24  Arash Esbati  <arash@gnu.org>

	* style/geometry.el ("geometry"): Fontify \restoregeometry macro.

2021-02-11  Brian Leung  <leungbk@mailfence.com>

	Deprioritize "\\.drv\\'" in auto-mode-alist

	Guix and Nix have derivation files that look like
	"/gnu/store/.*\\.drv".  To avoid choosing the wrong mode, we prefer to
	use more stringent regexps for those corresponding modes, and add the
	less-stringent regexp here to the end of auto-mode-alist.

	* latex.el (auto-mode-alist): Deprioritize "\\.drv\\'" in
	auto-mode-alist.

2021-02-09  Arash Esbati  <arash@gnu.org>

	Add new style/changes.el

	* Makefile.in (STYLESRC): Add new style.

	* style/changes.el: New file.

2021-02-09  Arash Esbati  <arash@gnu.org>

	Add parsing support to style/comment.el

	* style/comment.el (LaTeX-comment-include-exclude-regexp):
	(LaTeX-comment-package-options): New variables.
	(LaTeX-comment-auto-cleanup): New function for processing parsed
	elements.

2021-02-06  Arash Esbati  <arash@gnu.org>

	Add new style/footnotehyper.el

	* Makefile.in (STYLESRC): Add new style.

	* style/footnotehyper.el ("footnotehyper"): New file.

2021-02-03  Arash Esbati  <arash@gnu.org>

	Add new style/truncate.el

	* Makefile.in (STYLESRC): Add new style.

	* style/truncate.el: New file.

2021-01-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove eol format suffix from coding tag (bug#46117)

	* doc/preview-dtxdoc.pl:
	* tex-jp.el:
	Remove "-unix" suffix from coding: tag for local git repos of git for
	windows which enable autocrlf feature.
	Update copyright year.

2021-01-25  Arash Esbati  <arash@gnu.org>

	Document how to load AUCTeX from a local Git repo

	* doc/install.texi (Advice for non-privileged users): Add
	instructions to use AUCTeX directly out of a local Git repo.

2021-01-24  Arash Esbati  <arash@gnu.org>

	Update style/bigdelim.el to package version 2.6

	* style/bigdelim.el (TeX-arg-bigdelim-brace): Support completion
	for more brace choices.  Insert the choice in braces only if the
	choice doesn't start with a backslash.
	("bigdelim"): Add fontification support.

2021-01-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Prevent inadvertent destruction of list variable

	* latex.el (LaTeX-common-initialization): Apply `copy-sequence' to the
	last argument of `delete-dups'+`append'.

2021-01-20  Arash Esbati  <arash@gnu.org>

	Update style/bigstrut.el to package version 2.6

	* style/bigstrut.el ("bigstrut"): Remove non-existent macro
	\bigstrutsetup.
	Add \bigstrutjot to list of lengths.
	Add fontification support for \bigstrut.
	(TeX-arg-bigstrut): Fix prompt and the usage of
	`TeX-argument-prompt'.  Make the function more AUCTeX standard.

2021-01-20  Arash Esbati  <arash@gnu.org>

	Update style/multirow.el to package version 2.6

	* style/multirow.el ("multirow"): Improve arguments of \multirow
	macro incl. fontification.
	Add \bigstrutjot to list of lengths and not to macros.
	Add \STneed macro depending on supertabular package option.
	(LaTeX-multirow-package-options): Fix package options.

2021-01-19  Arash Esbati  <arash@gnu.org>

	Update style/thmtools.el to package version 0.72

	* style/thmtools.el (LaTeX-arg-thmtools-declaretheorem): Query for
	the optional argument after the mandatory environment name.
	(LaTeX-thmtools-env-label): Use `read-char-choice' instead of
	`read-char'.
	Set `help-form' in the let-binding.
	(LaTeX-thmtools-listoftheorems-key-val): Update key=val's.
	("thmtools"): Fontify also the optional argument after the
	mandatory one.  Keep the old behavior for compatibility.

2021-01-19  Tassilo Horn  <tsdh@gnu.org>

	Signal an error if auto-parser regexp has too many groups

	In (pathological) documents which activate too many styles adding
	entries to TeX-auto-regexp-list, the full regular expression built for
	auto-parsing may contain more groups than emacs supports (which is 255
	at this point of time).  Therefore, signal a clear error in that case
	instead of failing unpredictably by resultant problems.

	Also, fix another spot where duplicate entries could have been added.

	* tex.el (TeX-auto-parse-region): Signal an error if the generated
	auto-parser regexp has more than 255 groups.
	* latex.el (LaTeX-common-initialization): Ensure we don't add
	duplicate entries to TeX-auto-full-regexp-list.

2021-01-19  Tassilo Horn  <tsdh@gnu.org>

	Fix adding duplicates to TeX-auto-regexp-list

	* tex.el (TeX-auto-add-regexp): Check membership with `member' instead
	`memq' because the latter won't work with list-valued entries.

2021-01-15  Arash Esbati  <arash@gnu.org>

	Delete kernel commands from styles

	* style/scrbase.el ("scrbase"):
	* style/scrpage2.el ("scrpage2"): Delete support for macros
	provided by LaTeX kernel.

2021-01-15  Arash Esbati  <arash@gnu.org>

	* style/extramarks.el ("extramarks"): Use reference keyword class.

2021-01-13  Tassilo Horn  <tsdh@gnu.org>

	Fix use-package recipe in install docs (once again)

	* doc/install.texi (Installation): Fix use-package recipe.

2021-01-12  Arash Esbati  <arash@gnu.org>

	Add support for some missing kernel macros

	* font-latex.el (font-latex-built-in-keyword-classes): Add various
	\<sectioning>mark to "reference" class.

	* latex.el (LaTeX-common-initialization): Add support for \...mark
	macros.

2021-01-12  Arash Esbati  <arash@gnu.org>

	Add new style/extramarks.el

	* Makefile.in (STYLESRC): Add new style.

	* style/extramarks.el: New file.

2021-01-12  Arash Esbati  <arash@gnu.org>

	Update style/fancyhdr.el to package version 4.0

	* style/fancyhdr.el (TeX-arg-fancyhdr-place): Rename from
	`TeX-arg-fancyhdr-position'.  Improve list of candidates for
	completion.
	(LaTeX-fancyhdr-fancypagestyle-regexp): New variable for parsing
	user defined pagestyles.
	("fancyhdr"): Update for macros provided by package version 4.0.
	Remove completion support for deprecated macros.
	Remove macros provided by LaTeX kernel.
	Improve fontification support.
	(LaTeX-fancyhdr-package-options): Add new package options.

2021-01-12  Ikumi Keita  <ikumi@ikumi.que.jp>

	Support page(box) options for dvipdfmx in graphicx.el

	* style/graphicx.el (LaTeX-arg-graphicx-includegraphics-key-val):
	Support page(box) options when the document is to be processed by
	dvipdfmx.
	(): Update copyright year.

2021-01-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix off-by-one behavior of preview-latex (bug#39927)

	* preview.el.in (preview-prepare-fast-conversion): Turn newline in
	init string into space so that gs waits subsequent input. This newline
	caused a spurious appearance of gs prompt "GS>".

2021-01-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	Don't use `add-to-list' on lexical vars

	* tex.el (TeX-view-program-list, TeX-view-program-selection):
	(TeX-add-to-alist):
	Don't use `add-to-list' on lexical scope variables.
	* tests/tex/utility.el (TeX-adding-to-alist): New test.
	(): Enable lexical binding.  Update copyright year.

2021-01-09  Tassilo Horn  <tsdh@gnu.org>

	Fix mistake in use-package recipe

	* doc/install.texi (Installation): Fix mistake in use-package recipe.

2021-01-09  Tassilo Horn  <tsdh@gnu.org>

	Fix docstring too wide warnings

	* bib-cite.el (bib-dos-or-os2-variable): Reword/reformat docstring so
	that it's less than 80 chars wide.
	* context-en.el (ConTeXt-project-structure-list-en)
	(ConTeXt-section-block-list-en): Ditto.
	* context-nl.el (ConTeXt-project-structure-list-nl)
	(ConTeXt-section-block-list-nl): Ditto.
	* context.el (ConTeXt-numbered-section-hook)
	(ConTeXt-unnumbered-section-hook): Ditto.
	* tex-buf.el (TeX-check-engine): Ditto.

2021-01-09  Tassilo Horn  <tsdh@gnu.org>

	Add use-package recipe to installation info docs

	* doc/install.texi (Installation): Add use-package recipe.

2021-01-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Adapt preview.el.in for `TeX-translate-location-hook'

	* preview.el.in (preview-parse-messages): Transport the values between
	dynamic scope variables TeX-translate-location-* and corresponding
	lexical scope variables around the call to
	`TeX-translate-location-hook'.
	Update copyright year.

2021-01-08  Tassilo Horn  <tsdh@gnu.org>

	Fix error reported in <87o8hzto7r.fsf@fastmail.fm> on auctex@gnu.org

	* style/polyglossia.el (LaTeX-polyglossia-active-languages): Don't use
	add-to-list on lexical variable.

2021-01-08  Tassilo Horn  <tsdh@gnu.org>

	Declare formerly free vars accessible in TeX-translate-location-hook

	* tex-buf.el (TeX-translate-location-file,TeX-translate-location-offset)
	(TeX-translate-location-line,TeX-translate-location-string)
	(TeX-translate-location-error,TeX-translate-location-context): New
	defvars.
	* tex-buf.el (TeX-find-display-help): Bind them before calling
	TeX-translate-location-hook.
	(TeX-translate-location-hook): Adapt docstring.

2021-01-08  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use proper name rather than obsolete alias

	* latex.el (LaTeX-insert-environment): Use
	`LaTeX-after-insert-env-hook' instead of
	`LaTeX-after-insert-env-hooks'.

2021-01-07  Arash Esbati  <arash@gnu.org>

	Update style/eso-pic.el to package version 3.0a

	* style/eso-pic.el ("eso-pic"): Don't run the style hook for
	`atbegshi' since `eso-pic' doesn't rely on that package anymore.
	(LaTeX-eso-pic-package-options-list): Update package options.

2021-01-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use `write-contents-functions' instead of `write-file-functions'

	* tex.el (VirTeX-common-initialization):
	* latex.el (BibTeX-auto-store):
	Use `write-contents-functions' instead of `write-file-functions' to
	store `TeX-safe-auto-write' because the latter is cleared by C-x
	C-w (write-file).
	* doc/changes.texi (News in 13.0): Mention the bug fix.

2021-01-04  Tassilo Horn  <tsdh@gnu.org>

	Use frame-monitor-attributes for computing DPI if avail (bug#45596)

	* preview.el.in (preview-get-dpi): New defun.
	(preview-get-geometry): Use it for computing the screen DPI (bug#45596)

2021-01-02  Arash Esbati  <arash@gnu.org>

	Remove support for \swshape

	* style/baskervaldx.el ("baskervaldx"): Delete additions for
	\swshape macro which is now part of LaTeX kernel and supported via
	latex.el and font-latex.el.

2020-12-29  Tassilo Horn  <tsdh@gnu.org>

	Convert tabs to spaces in all *.el.in files according to .dir-locals.el

	Convert tabs to spaces in all lisp files according to .dir-locals.el

2020-12-29  Tassilo Horn  <tsdh@gnu.org>

	URI-encode ? in filename to %3F (bug#45510)

	* tex.el (TeX-evince-sync-view-1): Evince's dbus method wants an URI
	where ? is properly encoded as %3F so do so (bug#45510).

2020-12-29  Tassilo Horn  <tsdh@gnu.org>

	Untabify tex.el.

2020-12-27  Arash Esbati  <arash@gnu.org>

	* .dir-locals.el: Add new file.

2020-12-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Indent additional texts

	* latex.el (LaTeX-insert-environment): Indent texts sent after the
	inserted environment.

2020-12-24  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fixup dropping old implementations for viewers

	* tex-buf.el (TeX-output-style-check): Remove function only useful for
	old view implementations.

2020-12-22  Arash Esbati  <arash@gnu.org>

	Lift required GNU Emacs version to 24.3

	* RELEASE (Requirements): Mention that AUCTeX now requires at
	least GNU Emacs 24.3.

	* auctex.el.in: Lift GNU Emacs version to 24.3 and cl-lib to 1.0
	for `Package-Requires' header.

	* configure.ac (EMACS_CHECK_VERSION): Check for 24.3.

	* doc/changes.texi: Add entry for required Emacs version.

	* doc/faq.texi:
	* doc/preview-faq.texi (Requirements): Change tested/required
	Emacs version.

	* tex-site.el.in:
	* tex.el: Consider Emacs' minor version as well before reporting
	an error.

2020-12-22  Ikumi Keita  <ikumi@ikumi.que.jp>

	Delete bogus defvar

	* tex-buf.el: Remove bogus defvar for `compilation-in-progress'. There
	is a bare defvar for it already far above these lines.

2020-12-22  Ikumi Keita  <ikumi@ikumi.que.jp>

	Drop old implementations for viewers

	* tex.el (TeX-expand-list-builtin): Remove entries for "%v" and "%vv".
	(TeX-view-style, TeX-output-view-style): Remove.
	* doc/auctex.texi (Starting Viewers): Remove description about old
	implementations.
	* doc/changes.texi (News in 13.0): Mention the above changes.
	* tex-mik.el: Remove entries for TeX-view-style and
	TeX-output-view-style.

2020-12-21  Tassilo Horn  <tsdh@gnu.org>

	Document lexical-binding changes in context.el.

	* doc/changes.texi: Document lexical-binding changes in context.el.
	* context.el: Don't reference non-existing ConTeXt-section-hook but
	ConTeXt-numbered-section-hook.

2020-12-18  Tassilo Horn  <tsdh@gnu.org>

	Document lexical binding changes.

	* doc/changes.texi: Document lexical binding changes.

2020-12-03  Tassilo Horn  <tsdh@gnu.org>

	Fix compile "Error: symbol-value cannot use lexical var ‘amsenv’"

	* style/empheq.el (LaTeX-empheq-env): Don't call symbol-value on lexical
	variable amsenv.

2020-12-02  Arash Esbati  <arash@gnu.org>

	Add new style/scholax.el

	* Makefile.in (STYLESRC): Add new style.

	* style/scholax.el: New file.

2020-11-10  Arash Esbati  <arash@gnu.org>

	Update style/subfiles.el to package version 2.1

	* style/subfiles.el (LaTeX-subfiles-class-options): Use \' to
	match the empty string at the end of the file extension.
	("subfiles"): Add support for \subfileinclude macro.

2020-10-31  Tassilo Horn  <tsdh@gnu.org>

	Rename LaTeX-dialect to TeX-dialect.

	* tex.el (TeX-dialect): Renamed from LaTeX-dialect and move from latex.el to
	tex.el.
	* doc/auctex.texi: Adapt docs.
	* doc/changes.texi: Mention in changes for AUCTeX 13.
	* style/*.el: Adapt all style files accordingly.

2020-10-25  Ikumi Keita  <ikumi@ikumi.que.jp>

	Ensure the trailing slash for directory

	* tex.el (TeX-parse-path, TeX-strip-extension): Apply
	`file-name-as-directory' for `TeX-macro-global' and
	`TeX-macro-private' in case their entries lack the trailing slash.
	* tex-site.el.in (TeX-auto-global): Delete obsolete sentence.

2020-10-24  Tassilo Horn  <tsdh@gnu.org>

	Delete unused ispell code from 1994.

	* tex.el (ispell-tex-buffer-p): Delete defun.
	(ispell-enable-tex-parser): Don't set undefined variable.

2020-10-23  Arash Esbati  <arash@gnu.org>

	Put point after the graphic file argrument

	* style/graphicx.el (LaTeX-includegraphics-extensions): Delimit
	the regexp with \\' instead of $.
	(LaTeX-arg-includegraphics): Rewrite the function in order to
	comply with AUCTeX insertion hooks.  Put point after the braced
	group once the file argument in inserted into buffer.

2020-10-23  Arash Esbati  <arash@gnu.org>

	Fix insertion of unnecessary backslash

	* style/amsthm.el (LaTeX-arg-amsthm-fontdecl):
	* style/ntheorem.el (LaTeX-arg-ntheorem-fontdecl): Don't insert a
	backslash if the query for font declaration is left empty.

2020-10-23  Arash Esbati  <arash@gnu.org>

	Add new style/appendix.el

	* Makefile.in (STYLESRC): Add new style.

	* style/appendix.el: New file.

2020-10-23  Arash Esbati  <arash@gnu.org>

	* tex-ispell.el: Enable lexical-binding.

2020-10-23  Arash Esbati  <arash@gnu.org>

	Improve style/amsthm.el

	* style/amsthm.el (LaTeX-amsthm-theoremstyle-list): Delete
	variable.
	(LaTeX-arg-amsthm-fontdecl): Adjust `prompt' in
	`TeX-argument-prompt' and don't use the 5. argument of
	`TeX-completing-read-multiple'.
	(LaTeX-amsthm-auto-cleanup): Remove the part for the deleted
	`LaTeX-amsthm-theoremstyle-list'.
	("amsthm"): Use `LaTeX-add-amsthm-newtheoremstyles' for
	predefined styles.
	Adjust the hook for deleted variable.

2020-10-23  Tassilo Horn  <tsdh@gnu.org>

	Enable lexical-binding for texmathp.el

	* texmathp.el (texmathp-compile): Use `push' on places rather than `set' and
	`symbol-value' on locals partly pointing to symbols naming globals.

2020-10-23  Arash Esbati  <arash@gnu.org>

	* style/fancyvrb.el: Replace dynamically bound `optional'.

2020-10-23  Arash Esbati  <arash@gnu.org>

	Update style/fancyvrb.el to package version 3.6

	* style/fancyvrb.el (LaTeX-fancyvrb-key-val-options): Add the
	"reflabel" key.
	(LaTeX-fancyvrb-env-reflabel-key-val)
	(LaTeX-fancyvrb-reftex-label-context-function): New functions.
	(LaTeX-fancyvrb-arg-define-environment): Use
	`LaTeX-fancyvrb-env-reflabel-key-val'.
	(LaTeX-fancyvrb-key-val-label-regexp): New variable added to
	AUCTeX parser.
	("fancyvrb"): Run `font-latex-set-syntactic-keywords' in the hook
	if fontification is enabled.

2020-10-23  Arash Esbati  <arash@gnu.org>

	Add missing argument to function body

	* style/thmtools.el (LaTeX-thmtools-declaretheoremstyle-key-val)
	(LaTeX-thmtools-declaretheorem-key-val): Add the missing `prompt'
	argument.

2020-10-23  Arash Esbati  <arash@gnu.org>

	Remove `TeX-arg-none'

	* style/alphanum.el (TeX-arg-none): Remove function and use
	`TeX-arg-literal' instead.

2020-10-23  Arash Esbati  <arash@gnu.org>

	Adapt styles to lexical-binding

	* style/arabxetex.el ("arabxetex"):
	* style/babel.el ("babel"):
	* style/doc.el ("doc"):
	* style/enumitem.el ("enumitem"):
	* style/exam.el ("exam"):
	* style/floatrow.el ("floatrow"):
	* style/fontspec.el ("fontspec"):
	* style/graphicx.el ("graphicx"):
	* style/hologo.el ("hologo"):
	* style/ltugboat.el ("ltugboat"):
	* style/mdframed.el ("mdframed"):
	* style/menukeys.el ("menukeys"):
	* style/moodle.el ("moodle"):
	* style/natbib.el ("natbib"):
	* style/ntheorem.el ("ntheorem"):
	* style/paracol.el ("paracol"):
	* style/pythontex.el ("pythontex"):
	* style/splitidx.el ("splitidx"):
	* style/tcolorbox.el ("tcolorbox"):
	* style/tex-live.el ("tex-live"):
	* style/thmtools.el ("thmtools"):
	* style/titleps.el ("titleps"):
	* style/titlesec.el ("titlesec"):
	* style/titletoc.el ("titletoc"):
	* style/xcolor.el ("xcolor"): Replace occurrences of dynamically
	bound `optional' with constant nil or t.

	* style/harvard.el ("harvard"): Remove unnecessary quoting of
	`lambda'.

	* style/xcolor.el (LaTeX-xcolor-color-models): Remove unnecessary
	`symbol-value'.

2020-10-23  Arash Esbati  <arash@gnu.org>

	Enable lexical-binding in all style files.

2020-10-23  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use declared dynamic variable in tex-jp

	* tex-jp.el (TeX-expand-list-builtin): Replace former dynamic var
	`pos' with `TeX-expand-pos'.
	(): Enable lexical binding.
	Move `coding' tag to the File Local Variable section at EOF.
	Update copyright year.

2020-10-23  Ikumi Keita  <ikumi@ikumi.que.jp>

	Simplify nested `let's

	* tex-buf.el (TeX-active-master-with-quotes): Simplify nested `let's
	into singe one.

2020-10-23  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make "%o" compatible again with file name with spaces

	* tex-buf.el (TeX-active-master-with-quotes): Rename from
	`TeX--master-or-region-file-with-extra-quotes' and make public.
	Incorporate adjust of `TeX-expand-pos' from `TeX-command-expand'.
	(TeX-command-expand): Simplify.
	* tex.el (TeX-expand-list-builtin): Use renamed function instead of
	`TeX-active-master'.
	* tests/tex/command-expansion.el (TeX-command-expand-skip-file-name):
	Include "%o" in test.
	(TeX-command-expand-file-name-with-spaces): New test.
	(TeX-command-detokenize): Add case where `TeX-master' has space.

2020-10-23  Ikumi Keita  <ikumi@ikumi.que.jp>

	Arrange test condition

	* latex.el (LaTeX-env-args): Just test nil or not since
	`TeX-exit-mark' is now always bound.

2020-10-23  Tassilo Horn  <tsdh@gnu.org>

	Enable lexical-binding for AUCTeX core files

	* tex.el: Enable lexical-binding.
	(TeX-command-text,TeX-command-pos): Moved from tex-buf.el.
	(TeX-expand-pos,TeX-expand-command): New defvars used in place of `pos' and
	`command' in TeX-expand-list{,-builtin} entries.
	(TeX-expand-list-builtin): Use TeX-expand-pos and TeX-expand-command (instead
	of pos and command).  Use TeX-active-master instead of formerly dynamically
	bound `file'.
	(TeX-view-command-raw): Adapt to TeX-command-expand signature change.
	(TeX-exit-mark): New defvar.
	(TeX-parse-macro): Adapt docstring; bind and use TeX-exit-mark instead of
	exit-mark.
	(TeX-last-optional-rejected): New defvar.
	(TeX-parse-arguments): Use TeX-last-optional-rejected instead of
	last-optional-rejected.
	(TeX-parse-argument): Use TeX-exit-mark instead of exit-mark.
	(TeX-argument-insert): Use TeX-exit-mark and TeX-last-optional-rejected instead
	of the former unprefixed variables.
	(TeX-safe-auto-write,TeX-auto-untabify,TeX-auto-parse-region,TeX-verbatim-p)
	(TeX-submit-bug-report): Prefix unused var with _.
	(TeX-mode-specific-command-menu-entries): Don't bind `file'.
	(TeX-doc): Remove unused var `doc'.
	(TeX-run-ispell): Remove unused var `found'.
	(TeX-ispell-document): Use `when' instead of `if' with `progn'.
	* tex-buf.el: Enable lexical-binding.
	(TeX-command-expand): Remove file argument but use TeX-active-master instead.
	(TeX-command): Rename file argument to file-fn; adapt to TeX-command-expand
	signature change.
	(TeX--master-or-region-file-with-extra-quotes): Remove file-fn argument.
	* latex.el: Enable lexical-binding.
	(LaTeX-title,LaTeX-name,LaTeX-level,LaTeX-done-mark,LaTeX-toc): New defvars.
	(LaTeX-section): Bind them.
	(LaTeX-section-hook): Adapt docstring to the new defvars.
	(LaTeX-section-section): Ditto, and use the new defvars.
	(LaTeX-section-heading,LaTeX-section-title,LaTeX-section-toc,LaTeX-section-label):
	Use the new defvars.
	(LaTeX-env-args): Use TeX-exit-mark instead of exit-mark.
	(TeX-arg-index): Prefix unused argument args with _.
	(TeX-arg-cite): Prefix unused argument definition with _.
	(LaTeX-mark-environment,LaTeX-forward-paragraph,LaTeX-backward-paragraph)
	(LaTeX-narrow-to-environment): Use _ for unused dotimes counter variable.
	(LaTeX-check-insert-macro-default-style): Use TeX-last-optional-rejected
	instead of last-optional-rejected.
	* context.el: Enable lexical-binding.
	(ConTeXt-title,ConTeXt-name,ConTeXt-level,ConTeXt-done-mark,ConTeXt-reference):
	New defvars.
	(ConTeXt-section): Bind them.
	(ConTeXt-numbered-section-hook): Adapt docstring to the new defvars.
	(ConTeXt-unnumbered-section-hook): Ditto.
	(ConTeXt-numbered-section-heading,ConTeXt-unnumbered-section-heading)
	(ConTeXt-section-section,ConTeXt-section-ref): Use the new defvars.
	* preview.el.in (preview-generate-preview): Remove region-p argument.
	(preview-start-dvipng,preview-start-dvips)
	(preview-cache-preamble): Adapt to TeX-command-expand and
	preview-generate-preview signature change.
	(preview-region, preview-document): Ditto.
	* style/bicaption.el (LaTeX-arg-bicaption-bicaption): Use
	TeX-last-optional-rejected instead of last-optional-rejected.
	* style/booktabs.el ("booktabs"): Menion TeX-last-optional-rejected in comment.
	* style/caption.el (LaTeX-arg-caption-captionbox): Use
	TeX-last-optional-rejected instead of last-optional-rejected.
	* style/color.el (TeX-arg-color,(TeX-arg-color-fcolorbox): Use
	TeX-last-optional-rejected instead of last-optional-rejected.
	* style/exam.el: Enable lexical-binding.
	(LaTeX-exam-insert-item): Use LaTeX-current-environment instead of dynamically
	bound `environment'.
	* style/floatrow.el (LaTeX-floatrow-arg-floatbox): Use
	TeX-last-optional-rejected instead of last-optional-rejected.
	* style/ifluatex.el (LaTeX-ifluatex-set-TeX-exit-mark): Use TeX-exit-mark
	instead of exit-mark.
	* style/xcolor.el (TeX-arg-xcolor-definecolor,TeX-arg-xcolor-definecolorset):
	(TeX-arg-xcolor,TeX-arg-xcolor-fcolorbox): Use TeX-last-optional-rejected
	instead of last-optional-rejected.
	* tests/japanese/preview-latex.el (japanese-preview-preserve-kanji-option2)
	(japanese-preview-preserve-kanji-option3): Adapt to TeX-command-expand
	signature change.
	* tests/tex/command-expansion.el (TeX-command-expansion)
	(TeX-command-expansion-errors,TeX-command-detokenize)
	(TeX-command-expand-skip-file-name,TeX-command-expand-active-master): Adapt to
	TeX-command-expand signature change.
	* doc/auctex.texi (Sectioning): Describe LaTeX-level, LaTeX-name, LaTeX-title,
	LaTeX-toc, and LaTeX-done-mark instead of the former unprefixed vars.

2020-10-18  Mosè Giordano  <mose@gnu.org>

	* Version 12.3 released.

2020-10-18  Mosè Giordano  <mose@gnu.org>

	Mark default argument to `LaTeX-arg-polyglossia-lang' as optional

	* style/polyglossia.el (LaTeX-arg-polyglossia-lang): The `default' argument
	  isn't currently used, mark it as ignored.

2020-10-10  Mosè Giordano  <mose@gnu.org>

	Prepare for upcoming release

2020-08-28  Ikumi Keita  <ikumi@ikumi.que.jp>

	Simplify mode line for emacs 27

	* tex-buf.el: Don't add an entry in `minor-mode-alist' for
	`compilation-in-progress'. In emacs 27, compile.el adds a similar
	entry in `mode-line-modes'.

2020-08-17  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix document

	* doc/auctex.texi (Fontification of math): Delete incorrect
	description.

2020-08-02  Ikumi Keita  <ikumi@ikumi.que.jp>

	Restore all math environments in texmathp.el

	* texmathp.el (texmathp-tex-commands-default): Restore all math
	environments from style files. The idea to update t-t-c-d by style
	files afterwards fails when texmathp is used solely in external
	packages like org mode.
	* style/amsmath.el:
	* style/breqn.el:
	* style/empheq.el:
	* style/mathtools.el:
	Adjust in accord with the above change.
	* doc/changes.texi: Delete relevant entry.

2020-08-02  Ikumi Keita  <ikumi@ikumi.que.jp>

	Prepare for pdf output for PSTricks documents

	* style/pstricks.el ("pstricks"): Prepare for pdf output rather than
	turn off PDF mode.
	(): Update copyright year.
	* doc/changes.texi: Mention above change.

2020-07-28  Arash Esbati  <arash@gnu.org>

	Add an extra check for tex-buf.el in some style hooks

	* style/arabxetex.el ("arabxetex"):
	* style/bidi.el ("bidi"):
	* style/fontspec.el ("fontspec"):
	* style/polyglossia.el ("polyglossia"): Check if "tex-buf.el" is
	loaded and require it otherwise.  `TeX-check-engine-add-engines'
	is defined in "tex-buf.el" and the hook would exit too early if
	the library isn't loaded.

2020-07-24  Ikumi Keita  <ikumi@ikumi.que.jp>

	Merge prv-emacs.el into preview.el.in

	* preview.el.in: Merge all contents of prv-emacs.el.
	* prv-emacs.el: Delete.
	* Makefile.in:
	* configure.ac:
	Drop prv-emacs.el.

2020-07-22  Arash Esbati  <arash@gnu.org>

	Treat \choice like \item

	* style/exam.el ("exam"): Add "choice" to `LaTeX-item-regexp'.
	Simplify regexp for "subpart" and "subsubpart".

2020-07-19  Arash Esbati  <arash@gnu.org>

	Update style/csquotes.el to package version 5.2j

	* style/csquotes.el: Track changes in package version 5.2j.
	Remove deprecated macros, improve query for language argument.
	Add keyval query of package options.
	(LaTeX-csquotes-insert-environment): Remove function and use
	`LaTeX-env-args' instead.

2020-07-13  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add support of \tag for texmathp

	* style/amsmath.el (): Add entries for \tag and \tag* to
	`texmathp-tex-commands-default'.

2020-07-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Cater for case where fontification match goes over limit

	* font-latex.el (font-latex-match-quotation): Cater for case
	where fontification match goes over limit.
	Drop `string-make-multibyte'. It's no longer necessary because
	all supported emacsen handle multibyte strings well enough.
	(font-latex--updated-region-end): Adjust comments.

2020-07-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix previous commit and add new test

	* font-latex.el (font-latex-extend-region-backwards-quotation): Move
	the point back to the correct position when the inner loop search
	fails.
	* tests/latex/font-latex-test.el
	(font-latex-extend-region-backwards-quotation): New test.

2020-07-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Don't extend font lock region too eagerly (bug#42267)

	* font-latex.el (font-latex-extend-region-backwards-quotation): If
	there is no matching open quote, don't extend the font lock region.

2020-07-03  Arash Esbati  <arash@gnu.org>

	Add short verb characters to `ispell-tex-skip-alist'

	* style/shortvrb.el ("shortvrb"): Add entries in
	`LaTeX-shortvrb-chars to `ispell-tex-skip-alist' in order to skip
	verbatim content during spell checking.

2020-07-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Ajust document

	* doc/preview-latex.texi (Key bindings and user-level lisp functions):
	* preview.el.in (preview-at-point):
	Delete mention about zmacs-regions.
	* doc/auctex.texi (Known problems): Delete comment which is no longer
	valid because the current highlighting of $...$ is search-based, not
	syntactic.

2020-07-01  Arash Esbati  <arash@gnu.org>

	Support \newblock macro

	* latex.el (LaTeX-common-initialization): Add entry for \newblock
	marco.
	Add "bibindent" to list of known lengths.
	(LaTeX-paragraph-commands-internal): Add "newblock".

2020-06-30  Ikumi Keita  <ikumi@ikumi.que.jp>

	Get rid of gabage in generated texi file

	* doc/preview-dtxdoc.pl (MAIN): Add rule to delete dtx comment ^^A.
	(): Add coding tag. Update copyright year.

2020-06-28  Arash Esbati  <arash@gnu.org>

	Update style/xparse.el to package dated 2020-03-06

	* style/xparse.el: Update style to package version 2020-03-06
	incl. auto-parsing capabilities.  Fix fontification of provided
	macros.

2020-06-27  Tassilo Horn  <tsdh@gnu.org>

	Document deprecation of font-latex-update-font-lock

	* doc/changes.texi: Document deprecation of font-latex-update-font-lock.

2020-06-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Accommodate preview.dtx to new font-latex.el

	* latex/preview.dtx: Add "^^A$" so that |$| doesn't mess up the
	highlighting of TeX codes at later part.
	* doc/auctex.texi: Add mention about usage of "^^A$" in docTeX
	documents.

2020-06-19  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add TODO item about remove-style feature

	* doc/todo.texi (Mid-term Goals): Add an item about remove-style
	feature.
	* doc/changes.texi (News in 12.3): Fix typo.

2020-06-18  Ikumi Keita  <ikumi@ikumi.que.jp>

	Improve conformance to code conventions, and documents

	* font-latex.el (font-latex-update-math-env): Rename by changing "--"
	to "-" in function name.
	Don't alter user customize option `font-latex-math-environments'. In
	order to achieve that, use always `texmathp-tex-commands1' for
	input and omit argument LIST.
	* style/empheq.el: Arrange in accord with the above changes.
	* style/amsmath.el:
	* style/breqn.el:
	* style/mathtools.el:
	Arrange in accord with the above changes.
	Use `cl-pushnew' instead of `add-to-list' and require cl-lib in order
	to do that.
	* doc/changes.texi (News in 12.3):
	* texmathp.el:
	Mention change about support for AMS-LaTeX and packages mathtools,
	empheq and breqn.

2020-06-17  Tassilo Horn  <tsdh@gnu.org>

	Don't call TeX-remove-style in TeX-arg-document.

	* latex.el (TeX-arg-document): Don't call TeX-arg-document.

2020-06-17  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use constant regexp to fontify math environments

	* font-latex.el (font-latex--match-math-envII-regexp): New internal
	variable to store regexp to search math environments such as
	"equation".
	(font-latex-match-math-envII): Use it.
	(font-latex--update-math-env): New function to update
	`font-latex-math-environments' and build
	`font-latex--match-math-envII-regexp' from it.
	(font-latex-math-environments-from-texmathp): Remove.
	(font-latex-math-environments): Change default value to nil and
	initialize at top level by new function.
	* style/breqn.el:
	* style/empheq.el:
	* style/mathtools.el:
	Arrange in accord with the above change.
	* style/amsmath.el:
	Arrange in accord with the above change.
	Add fontification rule for \boxed{}.
	* doc/auctex.texi:
	Add instruction to convert customization.

2020-06-16  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix regression of font lock

	* font-latex.el (font-latex-match-math-envII): Store the position of
	"\begin{foo}" as (match-beginnig 0) so that `font-lock-multiline' text
	property covers it. Store the range of math expression as
	subexpression 1.
	(font-latex-make-user-keywords): Arrange in accord with the above
	change.

2020-06-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix typos

	* doc/changes.texi (News in 12.3):
	* tests/latex/fontification-general.tex (AUCTeX fontification):
	Fix typos.

2020-06-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	Update documents

	* doc/auctex.texi (Fontification of math):
	* doc/changes.texi (News in 12.3):
	* font-latex.el (font-latex-math-environments):
	Document that variable `font-latex-math-environments' is no longer
	suitable for personal customization and recommend to use
	`texmathp-tex-commands' instead.
	* tests/latex/fontification-general.tex: Mention new function
	`font-latex-extend-region-backwards-math'

2020-06-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	* texmathp.el: Add comment about additional bug.

2020-06-14  Ikumi Keita  <ikumi@ikumi.que.jp>

	Recover compatibility for older emacsen

	* font-latex.el (font-latex-fontify-region): Add check for return
	value from `font-lock-default-fontify-region'.

2020-06-14  Ikumi Keita  <ikumi@ikumi.que.jp>

	Reconsider region extension

	* font-latex.el (font-latex-fontify-region): Consider cases that
	`font-lock-extend-region-functions' extends the region inside
	`font-lock-default-fontify-region'. Use the return value from it to
	construct the correct region.
	(font-latex-match-math-env):
	(font-latex-match-math-envII):
	(font-latex-match-dollar-math):
	Raise `font-latex--updated-region-end' to at least LIMIT when
	necessary.
	(font-latex--updated-region-end): Fix comments.

2020-06-14  Ikumi Keita  <ikumi@ikumi.que.jp>

	Delete overhead in extending font lock range of math expression

	* font-latex.el (font-latex-math-environments-from-texmathp): New
	helper function.
	(font-latex-math-environments): Take default value using the above
	function.
	(font-latex-extend-region-backwards-math): Rename from
	`font-latex-extend-region-backwards-dollar-math' and include the
	functionality of `font-latex-extend-region-backwards-math-env' and
	`font-latex-extend-region-backwards-math-envII'.
	(font-latex-extend-region-backwards-math-env):
	(font-latex-extend-region-backwards-math-envII):
	Remove.
	(font-latex-setup): Simplify according to the above change.
	* texmathp.el (texmathp-tex-commands-default): Move entries not in
	standard LaTeX to the respective style files.
	* style/amsmath.el ():
	* style/breqn.el ():
	* style/empheq.el ():
	* style/mathtools.el ():
	Add package specific entries to `texmathp-tex-commands-default' and
	take additions for `font-latex-math-environments' from it rather than
	adding constant entries.

2020-06-14  Ikumi Keita  <ikumi@ikumi.que.jp>

	Update region extension in font-latex.el

	* font-latex.el (font-latex--updated-region-end): New variable to
	record the end of the region that fontification actually took place.
	(font-latex-fontify-region): New function to utilize it.
	(font-latex-setup): Assign it to `font-lock-fontify-region-function'.
	(font-latex-match-math-env): Search closing tag beyond limit honoring
	`font-latex-multiline-boundary'.
	Use new variable.
	(font-latex-match-math-envII):
	(font-latex-match-dollar-math):
	Use new variable.

2020-06-14  Uwe Brauer  <oub@mat.ucm.es>

	Add support for algopseudocde style

	* Makefile.in (STYLESRC): Add algopseudocde style

	* style/algpseudocode.el: Add support for the algopseudocde (algorithmcx)
		style

2020-06-14  Uwe Brauer  <oub@mat.ucm.es>

	Add support for algorithm style

	* Makefile.in (STYLESRC): Add algorithm style

	* style/algorithm.el: Add support for the algorithm style

2020-06-13  Ikumi Keita  <ikumi@ikumi.que.jp>

	Ignore 3 consective $'s properly

	* font-latex.el (font-latex-match-dollar-math): Ignore 3 or more
	consecutive $'s when searching opening of $...$ or $$...$$, instead of
	stopping to return nil.
	* tests/latex/font-latex-test.el: New test.

2020-06-11  Tassilo Horn  <tsdh@gnu.org>

	Trigger refontification in font-latex-add-to-syntax-alist.

	* font-latex.el (font-latex-add-to-syntax-alist): Trigger refontification.

2020-06-11  Tassilo Horn  <tsdh@gnu.org>

	Omit hard font-lock reset also in font-latex-add-to-syntax-alist

	* font-latex.el (font-latex-add-to-syntax-alist): Don't nilify
	font-lock-set-defaults but adjust font-lock-syntax-table directly as suggested
	by Ikumi Keita on auctex-devel.

2020-06-10  Tassilo Horn  <tsdh@gnu.org>

	Obsolete font-latex-update-font-lock (bug#37945)

	* font-latex.el (font-latex-add-keywords): Don't call
	font-latex-update-font-lock but font-lock-flush.
	(font-latex-update-font-lock): Make obsolete and emit a warning when called.
	* style/alltt.el: Adapt, i.e., don't call font-latex-update-font-lock but maybe
	font-latex-set-syntactic-keywords.
	* style/beamer.el: Dito.
	* style/comment.el: Dito.
	* style/expl3.el: Dito.
	* style/fancyhdr.el: Dito.
	* style/fancyvrb.el: Dito.
	* style/fvextra.el: Dito.
	* style/hyperref.el: Dito.
	* style/listings.el: Dito.
	* style/ltxguide.el: Dito.
	* style/minted.el: Dito.
	* style/pythontex.el: Dito.
	* style/revtex4-2.el: Dito.
	* style/tex-live.el: Dito.
	* style/url.el: Dito.
	* style/verbatim.el: Dito.

2020-06-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	* doc/changes.texi: Delete words inappropriate for raw file.

2020-06-08  Ikumi Keita  <ikumi@ikumi.que.jp>

	Complement document

	* doc/changes.texi: Mention workaround for new incompatibility.
	* doc/auctex.texi: Add missing entry to TOC.

2020-06-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	* doc/changes.texi (News in 12.3): Add news about fix of bug#33139.

2020-06-02  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use search-based fontification for $...$ (bug#33139)

	It turned out that using "text quotes" syntax for "$" in
	`font-lock-syntax-table' sometimes leads to scrambled fontification
	about in-line math $...$ (bug#33139). That's because conflicting
	results of `syntax-ppss' are compiled into syntax-ppss cache as
	explained in:
	https://lists.gnu.org/archive/html/emacs-devel/2020-05/msg02725.html
	We, Keita, Tassilo and Arash discussed this issue and decided to use
	search-based fontification for $...$ since syntactic fontification for
	$...$ doesn't seem prospective with regard to this bug.

	* font-latex.el (font-latex-match-dollar-math):
	(font-latex-find-dollar-math,font-latex-extend-region-backwards-dollar-math):
	New functions to do search-based fontification for $...$.
	Fontification facility for $$...$$ is merged into them.
	(font-latex-make-user-keywords,font-latex-setup): Use new functions.
	(font-latex-syntax-alist): Don't change syntax of "$" during font lock.
	(font-latex-syntactic-face-function): Simplify.

2020-05-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Simplify regexp in texmathp.el

	* texmathp.el (texmathp-compile): Simplify regexp. In [^...] backslash
	and dollar have no special meaning so they can (should) be raw.

2020-05-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	Don't make TeX-remove-style-hook buffer-local.

	* tex.el (TeX-remove-style-hook): Not buffer-local anymore.

2020-05-28  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix false negative of texmathp (bug#41559)

	* texmathp.el (texmathp-compile): Fix `texmathp-onoff-regexp' to allow
	switch to begin at (point-min).
	Use `regexp-opt' instead of `mapconcat'+`regexp-quote'.
	(texmathp): Use `>=' instead of `>' so that match is updated even when
	arg-on or sw-on begins at (point-min).
	* tests/latex/texmathp-test.el: New test.

2020-05-25  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix regression of unfontify-region

	* font-latex.el (font-latex-unfontify-region): Restore `invisible' as
	removed property. My commit on Jan 7 was partially wrong. It kept "^"
	and "_" invisible even when commented out if
	`font-latex-fontify-script' is `invisible'.

2020-05-22  Arash Esbati  <arash@gnu.org>

	Fontify content of comment environment

	* style/verbatim.el ("verbatim"): Add fontification support for
	comment environment.  Delete unnecessary `function' in the hook.

2020-05-17  Tassilo Horn  <tsdh@gnu.org>

	Empty commit fixing ChangeLog.

	* font-latex.el (font-latex-syntax-alist): This variable has not been deleted
	as suggested by the previous entry.
	(font-latex-extend-region-functions): Delete defvar.  Now set via
	`font-lock-defaults'.

2020-05-17  Tassilo Horn  <tsdh@gnu.org>

	Modernize font-latex.el

	- Use a syntax-propertize-function.
	- Use normal font-lock-extend-region-functions.
	- Add a function to syntax-propertize-extend-region-functions.
	- Use lexical-binding.

	* font-latex.el: Use lexical-binding.
	(font-latex-syntax-alist): Delete defvar.  Now set via `font-lock-defaults'.
	(font-latex-syntax-propertize-function): New defun being set as
	`syntax-propertize-function'.
	(font-latex-extend-region-backwards-command-with-args,
	font-latex-extend-region-backwards-command-in-braces,
	font-latex-extend-region-backwards-math-env,
	font-latex-extend-region-backwards-math-envII,
	font-latex-extend-region-backwards-quotation): Convert to normal
	`font-lock-extend-region-functions'.
	(font-latex-sp-extend-region-backwards-verb-env): New defun used in
	`syntax-propertize-extend-region-functions'.
	(font-latex-setup): Set `font-lock-extend-region-functions',
	`syntax-propertize-extend-region-functions', and `syntax-propertize-function'
	via `font-lock-defaults'.
	(font-latex-jit-lock-force-redisplay, font-latex-fontify-region): Delete
	defuns.
	(font-latex-unfontify-region): Remove unused lexical variable.
	(font-latex-script-char): Mark argument as ignored to silence the
	byte-compiler.

2020-05-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Update all mode lines

	* tex-buf.el (TeX-command-sentinel): Supply argument t for
	`force-mode-line-update' and discard useless `with-current-buffer'.
	* preview.el.in: Replace all
	`(set-buffer-modified-p (buffer-modified-p))' with
	`(force-mode-line-update)' and remove `sit-for' calls accompanying
	them.

2020-04-20  Arash Esbati  <arash@gnu.org>

	Update style/breqn.el to package version 0.98j

	* style/breqn.el (LaTeX-breqn-key-val-options): Delete no-op keys
	"background" and "color".
	(LaTeX-breqn-key-val-options-local): Delete now unneeded variable,
	also from the style hook.
	(LaTeX-breqn-env): Use `LaTeX-breqn-key-val-options' instead of
	`LaTeX-breqn-key-val-options-local'.
	(LaTeX-breqn-update-color-keys): Delete function and entry for
	`TeX-auto-cleanup-hook'.

2020-04-11  Tassilo Horn  <tsdh@gnu.org>

	Fix some regexp issues reported by relint.

	* latex.el (LaTeX-209-to-2e): Fix regexp issues reported by relint.
	* tex-buf.el (LaTeX-warnings-regexp, TeX-LaTeX-sentinel, TeX-parse-error):
	Dito.

2020-04-09  Pieter Pareit  <pieter.pareit@gmail.com>  (tiny change)

	Fix y-or-n-p query prompts

	* style/prosper.el (LaTeX-prosper-insert-slide): Fix query prompt.
	("prosper"): Delete unnecessary (funtion ...) in the hook.

	* tex-buf.el (TeX-check-engine):
	* tex-wizard.el (TeX-wizard): Fix query prompt.

2020-04-09  Arash Esbati  <arash@gnu.org>

	* doc/changes.texi: Document latest changes.

2020-04-08  Arash Esbati  <arash@gnu.org>

	Track LaTeX kernel changes for textcomp package

	* font-latex.el (font-latex-built-in-keyword-classes): Add entry
	for \legacyoldstylenums to type-command class.

	* latex.el (LaTeX-common-initialization): Move all entries from
	textcomp.el into latex.el since the macros are part of kernel with
	2020-02-02 release.
	Add support for \legacyoldstylenums.

	* style/textcomp.el: Move all entries to latex.el.
	(LaTeX-textcomp-package-options): Update options.

2020-04-07  Arash Esbati  <arash@gnu.org>

	Load caption style when asking for bicaption package options

	* style/bicaption.el (LaTeX-bicaption-package-options): Load
	"caption" style when making the query for package options.

2020-04-06  Arash Esbati  <arash@gnu.org>

	Load caption style before asking for package options

	* style/subcaption.el (LaTeX-subcaption-package-options): Load
	"caption" style in order to make `LaTeX-caption-key-val-options'
	defined when calling the function.  (Emacs bug#40464)

2020-04-05  Ikumi Keita  <ikumi@ikumi.que.jp>

	* preview.el.in (preview-gs-open): Use wrapper function.

2020-03-29  Arash Esbati  <arash@gnu.org>

	Add new style/tex-live.el

	* Makefile.in (STYLESRC): Add new style.

	* style/tex-live.el: New file.

2020-03-26  Arash Esbati  <arash@gnu.org>

	Update style/listings.el

	* style/listings.el (LaTeX-listings-key-val-options): Add
	"consecutivenumbers" key.
	("listings"): Add \lstlistingnamestyle and \thelstlisting macros.

2020-03-26  Arash Esbati  <arash@gnu.org>

	Add new style/overpic.el

	* Makefile.in (STYLESRC): Add new style.

	* style/overpic.el: New file.

2020-03-23  Arash Esbati  <arash@gnu.org>

	Fix regexp for parsing optional arguments

	* latex.el (LaTeX-auto-minimal-regexp-list):
	(LaTeX-auto-class-regexp-list): Fix regexp for parsing optional
	argument of \usepackage, \RequirePackage and \LoadClass.

2020-02-14  Arash Esbati  <arash@gnu.org>

	Add new style/ltxguide.el

	* Makefile.in (STYLESRC): Add new style.

	* style/ltxguide.el: New file.

2020-01-25  Uwe Brauer  <oub@mat.ucm.es>

	Add support for some missing environments

	* style/exam.el (LaTeX-exam-insert-item):
	("exam"): Add support for various "choices" and "checkboxes"
	environments.

	("exam"): Append the entries added to `LaTeX-item-list'.
	Enter a space in the buffer after the \choice macro.

2020-01-25  Arash Esbati  <arash@gnu.org>

	Add fontification support \textnormal macro

	* font-latex.el (font-latex-built-in-keyword-classes): Add
	entry for \textnormal to "type-command" class.

2020-01-25  Arash Esbati  <arash@gnu.org>

	* doc/auctex.texi (Font Specifiers): Document new font macros.

2020-01-18  Arash Esbati  <arash@gnu.org>

	Move customizable variable into tex-style.el

	* style/shortvrb.el: Move definition of `LaTeX-shortvrb-chars'
	into `tex-style.el'.
	Delete check for function `font-latex-set-syntactic-keywords' and
	check for feature font-latex instead.

	* tex-style.el (LaTeX-shortvrb-chars): Add entry for
	`LaTeX-shortvrb-chars'.

2020-01-18  Arash Esbati  <arash@gnu.org>

	Add new font macros in the related menus

	* latex.el (LaTeX-mode-menu): Add new entries for new kernel font
	macros.  Reorder the entries in groups family, series, shapes and
	miscellaneous.

2020-01-11  Arash Esbati  <arash@gnu.org>

	Add new style/revtex4-2.el

	* Makefile.in (STYLESRC): Add new style.

	* style/revtex4-2.el: New file.

	* tex-style.el (LaTeX-write18-enabled-p): Delete * and whitespace
	in docstring.
	Indent comment.
	Add customize entries for revtex4-2.el.

2020-01-08  Arash Esbati  <arash@gnu.org>

	Adjust style/fontaxes.el to LaTeX kernel

	* style/fontaxes.el ("fontaxes"): Comment out entries for macros
	which are now provided by LaTeX kernel.  Also remove fontification
	support.

2020-01-08  Arash Esbati  <arash@gnu.org>

	Improve support for extended NFSS macros

	* font-latex.el (font-latex-built-in-keyword-classes): Move
	entries for \normalfont and \normalshape to `function' class.
	Add \textssc to `bold-command' and \sscshape to `bold-declaration'
	class.

	* latex.el (LaTeX-common-initialization): Add entries for `spaced
	small caps' macros \sscshape and \textssc.  \textssc is not part
	of `LaTeX-font-list' yet.

2020-01-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for older emacsen

	According to NEWS.22, `font-lock-extra-managed-props' is available in
	all supported emacsen.

	* font-latex.el (font-latex-script,font-latex-script-char): Remove
	`boundp' test for `font-lock-extra-managed-props'.
	(font-latex-unfontify-region): Don't play with `invisible' text
	property because it is now handled by font-lock thanks to
	`font-lock-extra-managed-props'.

2020-01-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	Don't use obsolete variable

	According to NEWS.20, `font-lock' no longer supports
	`font-lock-comment-start-regexp'.

	* font-latex.el (defvar): Remove `defvar' for
	`font-lock-comment-start-regexp'.
	(font-latex-setup): Don't include `font-lock-comment-start-regexp' in
	`font-lock-defaults'.

2020-01-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for older emacsen

	Since `font-lock-multiline' is available in all supported emacsen, we
	no longer need `font-latex-multiline'.

	* font-latex.el (font-latex-setup): Remove `boundp' check.
	(font-latex-unfontify-region): Delete unnecessary code.
	(font-lock-after-change-function): Delete obsolete advice.
	(font-latex-put-multiline-property-maybe): Remove.
	(font-latex-match-command-with-arguments):
	(font-latex-match-command-in-braces):
	(font-latex-match-math-env):
	(font-latex-match-math-envII):
	(font-latex-match-quotation):
	Remove call on `font-latex-put-multiline-property-maybe'.

2020-01-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	Delete obsolete comment

	* font-latex.el: Delete obsolete comment.  `font-latex-do-multi-line'
	was removed in 2007.

2020-01-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add changelog for my previous bug fix

	* doc/changes.texi (News in 12.3): Add a new entry for bug fix of
	`LaTeX-insert-environment' (C-c C-e).

2020-01-05  Arash Esbati  <arash@gnu.org>

	Support extended NFSS shapes with 2020-02-02 LaTeX kernel

	* font-latex.el (font-latex-built-in-keyword-classes): Add
	\textulc and \textsw to `bold-command' class, the respective
	declarations to `bold-declaration'.
	Add reset \normalfont and \normalshape to `type-declaration'
	class.

	* latex.el (LaTeX-font-list): Add the macros \textulc and \textsw
	and bind the to C-l and C-w respectively.
	(LaTeX-common-initialization): Add the matching font declarations
	\ulcshape and \swshape.  Add user level reset macros \normalfont
	and \normalshape.

2020-01-05  Arash Esbati  <arash@gnu.org>

	Update style/fbox.el to package version 0.04

	* style/fbox.el: Add support for \fparbox macro.

2020-01-05  Arash Esbati  <arash@gnu.org>

	Fix handling of LaTeX font declaration macros

	* latex.el (LaTeX-common-initialization): Delete unnecessary and
	duplicate entry for picture environment.
	Add `-1' to LaTeX font declaration macros in order to work
	correctly on active regions.

2020-01-05  Arash Esbati  <arash@gnu.org>

	Delete insertion of wrong dollar sign

	* tex.el (TeX-insert-dollar): Remove insertion of wrong `$' as
	reported here:
	https://lists.gnu.org/archive/html/auctex-devel/2020-01/msg00002.html

2020-01-04  Arash Esbati  <arash@gnu.org>

	Update Pygments styles to version 2.5.2

	* style/minted.el (LaTeX-minted-key-val-options): Update values of
	"style" to styles provided by Pygments version 2.5.2.

2019-12-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Improve environment insertion (bug#35284)

	* latex.el (LaTeX-insert-environment): Place the point and the mark at
	appropriate place.
	* tests/latex/latex-test.el (LaTeX-insert-environment-with-active-region):
	New test.

2019-12-19  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use pdf rather than dvi for preview package document

	* latex/Makefile.in: Generate preview.pdf with full contents and use
	it instead of preview.dvi.

2019-12-14  Ikumi Keita  <ikumi@ikumi.que.jp>

	Adjust Makefile clean targets

	* Makefile.in:
	* doc/Makefile.in:
	* latex/Makefile.in:
	Adjust clean targets

2019-12-08  Arash Esbati  <arash@gnu.org>

	* font-latex.el (font-latex-setup): Remove XEmacs compat code.

2019-12-07  Arash Esbati  <arash@gnu.org>

	Update style/caption.el to package version 3.4a

	* style/caption.el (LaTeX-caption-key-val-options): Add values
	autodot and unnumbered to labelformat key.
	Remove wrong ContinuedFloat value from type key.
	("caption"): Delete entries for ContinuedFloat.
	Add fontification support for \continuedfloat macro.

2019-12-06  Ikumi Keita  <ikumi@ikumi.que.jp>

	Update menu in proper timing (bug#38058)

	* tex-buf.el (TeX-command-sentinel): Do `force-mode-line-update' in
	the command buffer so that "Next Error" item will appear in the menu
	bar just after compilation.
	Replace all `(set-buffer-modified-p (buffer-modified-p))' with
	`(force-mode-line-update)'
	(TeX-run-command): Remove `sit-for' call which is no longer
	necessary.

2019-11-16  Arash Esbati  <arash@gnu.org>

	Update style/ltugboat.el to class version 2.22

	* style/ltugboat.el ("ltugboat"): Add new abbreviation macros.

2019-11-08  Arash Esbati  <arash@gnu.org>

	Add new style/fbox.el

	* Makefile.in (STYLESRC): Add new style.

	* style/fbox.el: New file.

2019-10-30  Mosè Giordano  <mose@gnu.org>

	* Version 12.2 released.

2019-10-29  Mosè Giordano  <mose@gnu.org>

	Prepare for upcoming release

	* RELEASE: Update version number, release notes and list of contributors.
	* configure.ac: Update version number.
	* doc/auctex.texi: Update copyright years.
	* doc/changes.texi: Mention generic bug fixes.
	* doc/tex-ref.tex:
	* latex/preview.dtx: Update version number and copyright years

2019-10-26  Arash Esbati  <arash@gnu.org>

	Add new style/xkcdcolors.el

	* Makefile.in (STYLESRC): Add new style.

	* style/xkcdcolors.el: New file.

2019-10-26  Arash Esbati  <arash@gnu.org>

	Add check for empty overlay

	* tex-fold.el (TeX-fold-hide-item): Add an extra check to make
	sure that the function runs when overlay start and end are
	non-nil.  What is done in the end of function isn't useful with
	evaporated overlays and used to cause bugs because `overlay-start'
	and `overlay-end' return nil for such overlays, and functions such
	as `TeX-fold-overfull-p` try to move point to the
	overlay-end. (bug#37337)

2019-10-20  Arash Esbati  <arash@gnu.org>

	* style/amsmath.el ("amsmath"): Improve query strings.

2019-10-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	multi-prompt.el, style/beamer*.el: Get copyright just right

2019-10-18  Arash Esbati  <arash@gnu.org>

	* doc/changes.texi: Mention changes in News.

2019-10-18  Arash Esbati  <arash@gnu.org>

	Add final adjustments for LaTeX 2019-10-01

	* latex.el (LaTeX-env-contents): Adjust function to LaTeX kernel
	2019-10-01 release.  Remove check for usage within preamble only.
	Add query for optional argument with completion.
	(LaTeX-verbatim-environments):
	(LaTeX-indent-environment-list): Add filecontents(*) environments.

	* style/amsmath.el ("amsmath"): Add support for \overunderset
	macro.  Delete unnecessary `function' before `lambda'.  Re-indent
	the code.

2019-10-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	Change default for new Ghostscript

	* preview.el.in (preview-pdf-color-adjust-method): Change the default
	value to t and adjust doc string.
	* doc/preview-problems.texi (No images are displayed with gs 9.27 and
	earlier): Adjust its contents in line with the above change and change
	the title from "... newer".

2019-10-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix for revised file access controls of gs (bug#37719)

	* preview.el.in (preview-prepare-fast-conversion): Add commands for
	revised file access controls introduced after gs 9.27.
	(preview-gs-restart): Use "-d" option instead of "-s" because the
	former does not accept "%d" in OutputFile parameter.
	Don't wrap the file name into parentheses in line with this change.
	(preview-gs-flag-error): Adjust the reconstructed gs command line
	argument so that it matches with the above change.
	Add comments about limitations of this function.

2019-10-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	* preview.el.in (preview-undump-replacements): Fix last commit.

2019-10-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix preview-latex for TeXLive 2019 update

	* preview.el.in (preview-LaTeX-command, preview-undump-replacements):
	Remove the brace around the argument of \input.

2019-09-23  Arash Esbati  <arash@gnu.org>

	Add fontification support for ragged2e macros

	* style/ragged2e.el ("ragged2e"): Add provided macros to function
	keywords class.  This is in line with decision in `font-latex.el'
	for corresponding kernel macros.

2019-09-22  Arash Esbati  <arash@gnu.org>

	Delete \Ref and \labelformat from varioref.el

	* style/varioref.el ("varioref"): Delete \Ref and \labelformat
	from style hook and fontification support.

2019-09-22  Arash Esbati  <arash@gnu.org>

	* latex.el (LaTeX-common-initialization): Add \Ref to `TeX-complete-list'.

2019-09-22  Arash Esbati  <arash@gnu.org>

	Support new kernel macros \Ref and \labelformat

	* font-latex.el (font-latex-built-in-keyword-classes): Add \Ref to
	reference and \labelformat to function class.

	* latex.el (LaTeX-common-initialization): Add support for \Ref and
	\labelformat which are part of LaTeX kernel 2019-10-01 release.

2019-09-18  Arash Esbati  <arash@gnu.org>

	Update style/subcaption.el to package version 1.3

	* style/subcaption.el ("subcaption"): Add support for \subfloat
	macro.

2019-09-18  Arash Esbati  <arash@gnu.org>

	Update style/varioref.el to package version 1.6b

	* style/varioref.el ("varioref"): Rearrange macros acc. to the
	manual.  Add missing starred version of \Vref.  Add fontification
	support for \labelformat.
	(LaTeX-varioref-package-options): Update package options.

2019-09-14  Arash Esbati  <arash@gnu.org>

	Improve detecting of rejected optional arguments

	* style/bicaption.el (LaTeX-arg-bicaption-bicaption):
	* style/caption.el (LaTeX-arg-caption-captionbox):
	* style/floatrow.el (LaTeX-floatrow-arg-floatbox):
	* style/xcolor.el (TeX-arg-xcolor-fcolorbox): Add an additional
	check for detecting if last optional argument was rejected.

2019-09-08  Arash Esbati  <arash@gnu.org>

	Add new style/multitoc.el

	* Makefile.in (STYLESRC): Add new style.

	* style/multitoc.el: New file

2019-08-31  Arash Esbati  <arash@gnu.org>

	Make "PDF Tools" viewer available under Windows and macOS

	* tex.el (TeX-view-program-list-builtin): Make entry for "PDF
	Tools" available under Windows and macOS.  (bug#37152)

	* doc/changes.texi: Mention availability of "PDF Tools" under
	Windows and macOS in `TeX-view-program-list-builtin'.

	* doc/install.texi (Prerequisites): Replace "Mac OS X" with
	"macOS".

2019-08-22  Arash Esbati  <arash@gnu.org>

	Add new style/ltugboat.el

	* Makefile.in (STYLESRC): Add new style.

	* style/ltugboat.el: New file.

2019-08-22  Arash Esbati  <arash@gnu.org>

	Add new style/changelog.el

	* Makefile.in (STYLESRC): Add new style.

	* style/changelog.el: New file.

2019-08-22  Arash Esbati  <arash@gnu.org>

	Support explicitly numbered group contructs

	* latex.el (LaTeX-extract-key-value-label): Add an optional
	argument for explicitly numbered group contructs.

2019-08-22  Arash Esbati  <arash@gnu.org>

	* doc/changes.texi: Mention fontification improvement for biblatex.

2019-08-21  Arash Esbati  <arash@gnu.org>

	* context.el (ConTeXt-environment): Fix docstring.

2019-08-21  Arash Esbati  <arash@gnu.org>

	Fix lisp example for `TeX-electric-math'

	* doc/auctex.texi (Quotes): Use `make-local-variable' instead of
	`make-variable-buffer-local' in lisp example for init file.  (bug#37124)

2019-08-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Restore syntax fontify in Texinfo mode

	* tex-info.el (TeX-texinfo-mode): Set `syntax-propertize-function',
	mimicking texinfo.el.  Now comments in Texinfo mode buffer are
	displayed with comment face again.

2019-08-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Reduce unnecessary local variable safety inquiry

	* tex.el (TeX-add-local-master): Call major mode function only when
	necessary.

2019-08-18  Arash Esbati  <arash@gnu.org>

	Update style/titlesec.el to package version 2.11

	* style/titlesec.el ("titlesec"): Add \nostruts macro.
	(LaTeX-titlesec-package-options): Add `nostruts' option.

2019-08-17  Arash Esbati  <arash@gnu.org>

	Update style/thmtools.el to package version 67

	* style/thmtools.el (LaTeX-thmtools-declaretheoremstyle-regexp)
	(LaTeX-thmtools-declaretheorem-regexp): Use the function
	`LaTeX-extract-key-value-label' to build the regexp.
	(LaTeX-thmtools-listoftheorems-key-val): Add new key `title'.
	(LaTeX-thmtools-package-options): Add new variable.

2019-08-17  Arash Esbati  <arash@gnu.org>

	Update style/fvextra.el to package version 1.4

	* style/fvextra.el (LaTeX-fvextra-key-val-options): Add new keys.
	("fvextra"): Add new macros.  Add fontification support for
	\EscVerb macro.

2019-08-15  Arash Esbati  <arash@gnu.org>

	Update style/paracol.el to package version 1.35

	* style/paracol.el: Add macro \definecolumnpreamble and the length
	\belowfootnoteskip.

2019-07-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Change color adjustment method (bug#35571, bug#35696, bug#36039)

	* preview.el.in (preview-pdf-color-adjust-method): New option.
	(preview-pdf-color-string): Use new code using DELAYBIND feature when
	the new option is t.
	(preview-gs-color-string): Add new optional argument to suppress code
	for explicit colors.
	(preview-gs-open): Don't adjust color when the latex command produces
	PDF and `preview-pdf-color-adjust-method' is nil.
	(preview-pdf2dsc-sentinel): Add "-dDELAYBIND" option to gs invocation
	when `preview-pdf-color-adjust-method' is t.
	* doc/changes.texi: Add a new entiry.
	* doc/preview-problems.texi: Add a section to explain how to do with
	the case no images are displayed with gs 9.27 and newer.

2019-07-16  Ikumi Keita  <ikumi@ikumi.que.jp>

	Enhance support for file names with spaces

	* tex-buf.el (TeX-run-compile): Add an entry for file name with spaces
	to localized `compilation-error-regexp-alist'.

2019-07-14  Arash Esbati  <arash@gnu.org>

	Update style/AnonymousPro.el to package version 2.2

	* style/AnonymousPro.el (LaTeX-AnonymousPro-package-options): Add
	the `scaled' key.

2019-06-27  Ikumi Keita  <ikumi@ikumi.que.jp>

	Conform to `delete-selection-mode' (bug#36385)

	* latex.el (LaTeX-insert-left-brace): Put `delete-selection' property
	which obeys that of `self-insert-command' when
	`LaTeX-electric-left-right-brace' feature is inactive.

2019-06-14  Arash Esbati  <arash@gnu.org>

	Support cleveref labels

	* style/cleveref.el (TeX-arg-cleveref-crossref-type): New
	function.
	(LaTeX-cleveref-label-regexp): New variable for parsing \label
	macros with an optional argument.
	("cleveref"): Add missing package macros.
	Update expert commands and fontification.
	Update `reftex-label-regexps' enabling RefTeX to handle \label
	with an optional argument as well.
	Update description line and add Commentary section.  (bug#36111)

2019-05-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make navigation function robust

	* tex.el (TeX-find-macro-end-helper): Cater for corner case that the
	`while' loop is exited or skipped.
	* tests/tex/navigation.el: Add new test.

2019-05-20  Arash Esbati  <arash@gnu.org>

	Update style/babel.el to package version 3.31

	* style/babel.el (LaTeX-babel-language-list): Add azerbaijani and
	remove frenchb.
	(LaTeX-babel-babelprovide-key-val-options): New variable.
	(LaTeX-babel-babeltags-regexp, LaTeX-babel-cleanup-babeltags): Add
	parsing support for \babeltags macro.
	(LaTeX-babel-babelfont-regexp, LaTeX-babel-cleanup-babelfont): Add
	parsing support for \babelfont macro.
	(TeX-arg-babel-lang): Use the arguments optional and prompt
	properly.
	("babel"): Add missing macros incl. fontification.
	(LaTeX-babel-package-options): Add missing package options.

2019-05-17  Tassilo Horn  <tsdh@gnu.org>

	Fix autoload generation code (bug#35758)

	* Makefile.in (AUTOLOAD,PREVIEW_AUTOLOAD): Use arg instead of
	  generated-autoload-file (bug#35758).

2019-05-17  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix regression

	* latex.el (LaTeX-arg-usepackage-insert, LaTeX-arg-usepackage): Move
	`TeX-run-style-hooks' from `LaTeX-arg-usepackage' to
	`LaTeX-arg-usepackage-insert'.  Due to my commit "Defer running style
	hook until options are given actually", style hooks associated with
	\usepackage were not run when the document is newly created with
	`LaTeX-env-document'.

2019-05-17  Arash Esbati  <arash@gnu.org>

	Load hyperref.el in `LaTeX-beamer-class-options'

	* style/beamer.el (LaTeX-beamer-class-options): Load "hyperref.el"
	in order to have `LaTeX-hyperref-package-options-list' defined
	when the document class is requested and the style hook hasn't run
	yet.  (bug#35649)

2019-05-12  Arash Esbati  <arash@gnu.org>

	Improve style/mflogo.el

	* style/mflogo.el ("mflogo"): Ask for Text when \textlogo is
	invoked.  Change \logofamily into a declaration.  Add missing
	macros \MF and \MP.  Adjust fontification for \textlogo and
	\logofamily.

2019-05-12  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix last commit

	* tex-buf.el (TeX-command-expand): Redefine the value of `file' just
	once per call of `TeX-command-expand'.  Previous code could give
	spurious quote when the given command string contains more than one
	"%" expanders tied with the symbol `file'.

2019-05-12  Ikumi Keita  <ikumi@ikumi.que.jp>

	Stop depreciated usage of undeclared dynamic variable

	* tex-buf.el (TeX--master-or-region-file-with-extra-quotes): Redefine
	as template.  On accepting one of `TeX-master-file', `TeX-region-file'
	or `TeX-active-master' as its first argument, it becomes a wrapper for
	those three, like previous definition.
	(TeX-command-expand): Arrage in accord with the above change.
	With these two changes, we no longer need implicit dynamic binding of
	non-special variable `orig-file'.
	* tex.el (TeX-expand-list-builtin): Update supplementary comment for
	"%T".

2019-05-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	* tex-jp.el (AUCTeX-jp): Add keyword :link to info node.

2019-05-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix treatment of class and package options

	* preview.el.in (preview-auctex-font-size): Consult
	`LaTeX-provided-{class,package}-options' instead of
	`(TeX-style-list)'.  This function has been accidentally disabled
	since AUCTeX began not to include the class and package options into
	the styles.  Similar problem with bug#25563.
	* latex.el (LaTeX-match-class-option): Update doc string because the
	above change depends on its implicit behavior.

2019-05-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove obsolete codes

	* preview.el.in (preview-mouse-open-eps): Remove xemacs compatibility
	code.
	Don't use obsolete variable `default-major-mode'.

2019-05-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for xemacs

	* prv-emacs.el (preview-compatibility-macros): Remove.
	* preview.el.in (eval-when-compile,makunbound): Remove useless
	codes.

2019-05-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for xemacs

	* prv-emacs.el (preview-mark-active): Remove.
	(): Update Copyright year.
	* preview.el.in (LaTeX-preview-setup): Remove the above macro.
	(): Update Copyright year.

2019-05-08  Mohammad Hossein Bateni  <bateni@google.com>

	Allow the user to customize which TeX commands are available in each mode.

	Commands such as Biber, DVI2PS, PS2PDF, Index, etc. are not useful in
	ConTeXt.  ConTeXt generates a PDF directly and has its own indexing
	mechanism.

	In Mark IV (which has been the preferred version for over a decade and
	is actively developed), a new bibliography package is also available,
	which can process old bibtex files as well.  So there is no need for
	BibTeX.

	Having so many commands in context-mode clutters the menus.  In the
	definition of TeX-command-list, we either provide a list of relevant
	modes, or set the value to `t' indicating that this command should
	always be available.  In the latter case, the user cannot customize
	it.  Here we provide sensible defaults as well as the ability for the
	user to customize.

	* tex.el (TeX-command-list): Hide by default some commands from context-mode.

2019-04-23  Arash Esbati  <arash@gnu.org>

	Add new function `LaTeX-extract-key-value-label'

	* latex.el (LaTeX-extract-key-value-label): Add new utility
	function to return a regexp string to extract label value in an
	optional key=val argument.

	* style/breqn.el (LaTeX-breqn-key-val-label-regexp):
	* style/listings.el (LaTeX-listings-key-val-label-regexp)
	(LaTeX-listings-auto-cleanup): Use
	`LaTeX-extract-key-value-label'.
	Delete now unused variable `LaTeX-listings-key-val-label-extract'.

2019-04-20  Arash Esbati  <arash@gnu.org>

	Add support for ChangeLog entries for LaTeX files

	* tex.el (TeX-current-defun-name): New function returning the name
	of current sectioning command when `C-x 4 a' is invoked.

	* latex.el (LaTeX-common-initialization): Set a local version
	`add-log-current-defun-function' to `TeX-current-defun-name'.

2019-04-19  Arash Esbati  <arash@gnu.org>

	* style/xparse.el ("xparse"): Fix fontification of alternatives.

2019-04-17  Ikumi Keita  <ikumi@ikumi.que.jp>

	Reset `TeX-PDF-from-DVI' if xetex engine is in use

	* tex.el (TeX-engine-set): Reset `TeX-PDF-from-DVI' when the new
	engine is `xetex'.  Fix bug#34593.

2019-04-13  Arash Esbati  <arash@gnu.org>

	Update keywords to biblatex v3.12

	* font-latex.el (font-latex-built-in-keyword-classes): Update
	biblatex keywords.  For qualified lists, fontify at least 2
	mandatory arguments.

2019-04-11  Arash Esbati  <arash@gnu.org>

	* tex-info.el (TeX-texinfo-mode): Set `add-log-current-defun-function' locally.

2019-04-06  Ikumi Keita  <ikumi@ikumi.que.jp>

	Elaborate LaTeX math insertion command

	* latex.el (LaTeX-math-insert): Put the point after the closing dollar
	sign when appropriate.  This fixes bug#35128.
	In addtion, wrap the text in the active region suitably.

2019-04-05  Arash Esbati  <arash@gnu.org>

	Fix handling of function entries in `TeX-complete-list'

	* tex.el (TeX-complete-symbol): Check if the fourth argument of
	entry in `TeX-complete-list' is a list and eval it.  (Bug#35074)

2019-03-16  Arash Esbati  <arash@gnu.org>

	Improve fontification of \href macro

	* style/hyperref.el ("hyperref"): Add "href" to
	`LaTeX-verbatim-macros-with-braces-local'.
	Check for feature font-latex and not for functions.
	Declare and use `font-latex-update-font-lock' instead of
	`font-latex-set-syntactic-keywords'.

2019-03-09  Tassilo Horn  <tsdh@gnu.org>

	Support up to 12 command arguments.

	* font-latex.el (font-latex-keyword-matcher): Support up to 12 command
	  arguments.

2019-03-04  Arash Esbati  <arash@gnu.org>

	Fix fontification of simple macros

	* font-latex.el (font-latex-match-simple-command): Change second
	part of regexp in order to be less greedy.  This function now
	fontifies only letters and characters defined in
	`font-latex-match-simple-include-list' (bug#34712).
	(font-latex-match-simple-include-list): New variable.

	* style/expl3.el ("expl3"): Add "_" and ":" to
	`font-latex-match-simple-include-list'.

2019-02-24  Tassilo Horn  <tsdh@gnu.org>

	New styles for beamerarticle & beamerswitch triggering beamer

	* style/beamerarticle.el: New style.
	* style/beamerswitch.el: New style.
	* Makefile.in (STYLESRC): Enable them.

2019-02-11  Arash Esbati  <arash@gnu.org>

	* style/listings.el: Require tex.el.

2019-02-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* auctex.el: Add requireds, keywords, and trailer

	(cherry picked from commit 0c8d6703d16097eb64f014c56e4135a5a1f9600f)

2019-02-08  Arash Esbati  <arash@gnu.org>

	Delete auctex-pkg.el which is not needed for ELPA releases

2019-02-08  Arash Esbati  <arash@gnu.org>

	Add dependencies file auctex-pkg.el

	* auctex-pkg.el: Add new file containing AUCTeX's dependencies for
	ELPA releases.

2019-02-02  Arash Esbati  <arash@gnu.org>

	Improve indenting and filling in "Form" environments

	* style/hyperref.el ("hyperref"): Add the "Form" environment to
	`LaTeX-document-regexp'.

2019-01-12  Arash Esbati  <arash@gnu.org>

	Add support for w and W column specifiers

	* style/array.el ("array"): Add column specifiers w and W to
	`LaTeX-array-column-letters'.

	* doc/changes.texi: Mention that counting columns is supported
	only if the align parameter is enclosed in braces.

2019-01-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove combatibility code for older emasen

	* tex.el (put): Don't put unnecessary property on
	`TeX-source-correlate-mode'.
	(TeX-clean): Remove fallback code for emacs 21.

2019-01-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for older emacsen

	* font-latex.el (put):
	* tex-style.el (put):
	Use `booleanp' instead of `TeX-booleanp'.
	* tex.el (put): Use `booleanp' instead of `TeX-booleanp'.
	(TeX-booleanp): Remove.

2019-01-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for older emacsen

	* context.el (ConTeXt-mode-common-initialization):
	* latex.el (TeX-latex-mode):
	* plain-tex.el (TeX-plain-tex-mode, ams-tex-mode):
	* tex-info.el (TeX-texinfo-mode):
	Use `run-mode-hooks' instead of `TeX-run-mode-hooks'.
	* tex.el (TeX-run-mode-hooks): Remove.

2019-01-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix test conditions on w32

	* tests/tex/command-expansion.el (TeX-command-detokenize): Correct
	`system-type' for w32.
	(TeX-command-expand-skip-file-name, TeX-command-expand-active-master):
	Skip tests on w32.

2019-01-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	Override some bindings in `TeX-mode-map' in Texinfo mode

	* tex-info.el (Texinfo-mode-map): Bind `self-insert-command' to
	"$", "^", "_" and "\" because they are normal characters in Texinfo
	documents.
	Bind `TeX-insert-backslash' to "@" so that users benefit from
	`TeX-electric-macro' even in Texinfo mode.
	* tex.el (TeX-electric-escape): Update doc string.
	* doc/auctex.texi (Completion): Update description.
	* doc/changes.texi (News in 12.2): Mention the above changes.

2019-01-06  Arash Esbati  <arash@gnu.org>

	Update style/enumitem.el to package version 3.6

	* style/enumitem.el (LaTeX-enumitem-key-val-options): Update
	key=val options to v3.6.
	(LaTeX-enumitem-auto-cleanup): Use sharp-quote notation.
	("enumitem"): Query for trivlist environment depending of package
	option.
	Add macro \Drawenumitemlabel and length \labelitem.
	(LaTeX-enumitem-package-options): Update package options.

2019-01-02  Arash Esbati  <arash@gnu.org>

	Skip macros and environments from pythontex

	* tex-ispell.el (TeX-ispell-skip-cmds-list): Add document macros
	of pythontex package.
	(TeX-ispell-skip-envs-list): Add environments provided by
	pythontex package.
	Add general verbatim macros.

2018-12-15  Arash Esbati  <arash@gnu.org>

	Improve completion for \url between url.el and hyperref.el

	* style/hyperref.el ("hyperref"): Comment the entry for "url"
	since the completion is provided via url.el.

	* style/url.el ("url"): Add a conditional to "url" in order to
	check if hyperref.el is loaded and then supply the argument in
	braces.
	Also check for hyperref.el. before adding "url" to
	`LaTeX-verbatim-macros-with-delims-local'.

2018-12-14  Arash Esbati  <arash@gnu.org>

	Add new style/pythontex.el

	* Makefile.in (STYLESRC): Add new style.

	* style/pythontex.el: New file.

2018-12-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Drop xemacs support and mule check from configure and Makefile

	* aclocal.m4:
	* configure.ac:
	* doc/Makefile.in: Drop xemacs support and mule check.
	* Makefile.in: Merge mule file into main files.
	Drop xemacs support.
	* prv-install.el: Remove.

2018-12-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix document

	* doc/auctex.texi (Completion): Correct wrong description and typo.
	(Cleaning): Add mention about variables related to AmSTeX mode.

2018-12-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use ASCII apostrophe in code expample

	* doc/auctex.texi (): (I/O Correlation): Use APOSTROPHE(U+0027) rather
	than RIGHT SINGLE QUOTATION MARK(U+2019) in code example.
	Add coding tag in Local Variables section.

2018-12-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	Redefine support for \url in hyperref

	* style/hyperref.el ("hyperref"): Override the entry for \url macro in
	url.el because hyperref.sty redefines the macro.

2018-12-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	Revise description about CJK support

	* doc/auctex.texi (Internationalization): Revise description about CJK
	support in Emacs and TeX.
	(Japanese): Fix typo and add index entries.

2018-12-06  Arash Esbati  <arash@gnu.org>

	Improve handling of `TeX-insert-macro-default-style' in styles

	* latex.el (LaTeX-check-insert-macro-default-style): Add new
	macro.  This macro is intended for more complex functions in style
	files querying multiple optional and mandatory arguments and
	obeying the values of `TeX-insert-macro-default-style' and
	`current-prefix-arg'.

	* tex.el (TeX-parse-arguments): Add a comment about the new macro.

	* style/bicaption.el (LaTeX-arg-bicaption-bicaption):
	* style/caption.el (LaTeX-arg-caption-captionbox):
	* style/color.el (TeX-arg-color, TeX-arg-color-fcolorbox):
	* style/floatrow.el (LaTeX-floatrow-arg-floatbox):
	* style/xcolor.el (TeX-arg-xcolor-definecolor)
	(TeX-arg-xcolor-definecolorset, TeX-arg-xcolor)
	(TeX-arg-xcolor-fcolorbox): Use
	`LaTeX-check-insert-macro-default-style'.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for older emacsen

	* tex.el: Remove XEmacs compatibility definitions for
	`TeX-read-string', `TeX-active-mark', `TeX-activate-region',
	`line-beginning-position', `line-end-position' and
	`TeX-overlay-prioritize'.
	(TeX-activate-region): Remove compatibility code for older emacsen.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove TeX-maybe-remove-help, TeX-menu-with-help

	* tex.el (TeX-maybe-remove-help, TeX-menu-with-help): Remove.
	(TeX-mode-specific-command-menu-entries, TeX-fold-menu)
	(TeX-common-menu-entries):
	* context.el:
	* latex.el:
	* plain-tex.el:
	* tex-buf.el:
	* tex-info.el:
	Remove `TeX-menu-with-help' and fix indent.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove TeX-mark-active

	* tex.el (TeX-mark-active): Remove.
	(TeX-mode-specific-command-menu-entries):
	* style/dinbrief.el (LaTeX-dinbrief-insert)
	(LaTeX-dinbrief-env-recipient):
	Use the variable `mark-active' directly instead of the function
	`TeX-mark-active'.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove TeX-replace-regexp-in-string

	* tex.el (TeX-replace-regexp-in-string): Remove.
	* latex.el:
	* style/empheq.el:
	* style/floatrow.el:
	* style/tcolorbox.el:
	* style/xcolor.el:
	Use `replace-regexp-in-string' instead of
	`TeX-replace-regexp-in-string'.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use `write-file-functions'

	* tex.el (VirTeX-common-initialization):
	* latex.el (BibTeX-auto-store):
	Use `write-file-functions' instead of obsolete
	`local-write-file-hooks' and `write-file-hooks'.  Also, use local hook.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility face

	* tex-buf.el (TeX-error-description-error)
	(TeX-error-description-warning, TeX-error-description-tex-said):
	Remove compatibility alternatives in `defface'.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove XEmacs compatibility code in tex-bar.el

	* tex-bar.el (TeX-bar-TeX-buttons, TeX-bar-LaTeX-buttons): Remove
	Emacs/XEmacs choice of buttons.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	* tex-buf.el (TeX-special-mode): Use `define-derived-mode'.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for older emacsen

	* font-latex.el (font-latex-after-hacking-local-variables): Remove
	fallback code for case `file-local-variables-alist' isn't available.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for older emacsen

	* font-latex.el (font-latex-doctex-^^A): Remove fallback for case
	`string-to-syntax' isn't available.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility code for older emacsen

	* latex.el (LaTeX-fill-region-as-para-do): Drop fallback for case
	`fill-delete-prefix' isn't available.

2018-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Adjust autoload cookie

	* tex-fold.el (TeX-fold-mode): Set autoload cookie directly to
	`define-minor-mode'.

2018-12-02  Arash Esbati  <arash@gnu.org>

	Remove unnecessary parentheses

	* style/geometry.el ("geometry"):
	* style/graphicx.el ("graphicx"): Remove unnecessary parentheses
	in option management.

2018-11-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove compatibility codes for older emacsen

	* tex-info.el (when, TeX-texinfo-mode):
	* tex.el (TeX-documentation-texdoc):
	* plain-tex.el (TeX-plain-tex-mode):
	* preview.el.in (preview-counter-find):
	Remove compatibility codes for older emacsen.

2018-11-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use `declare-function' without `fboundp' test

	* latex.el:
	* tex-info.el:
	Use `declare-function' without `fboundp' test.

2018-11-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove references to older emacsens in comments and doc strings

	* bib-cite.el:
	* font-latex.el:
	* tex-fold.el:
	* tex-style.el:
	* style/graphicx.el
	Remove references on older emacsens in comments and doc strings

2018-11-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove references to XEmacs from the manual

	* RELEASE (): Delete the words "or XEmacs" and fill the paragraph.
	* doc/install.texi (Configure): Delete redundant line and words.

2018-11-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Clean up remnants of previous removal of compatibility codes

	* tex.el (TeX-mode-specific-command-menu): Delete irrelevant comment.
	* latex.el (LaTeX-indent-line): Clear out unused lines.

2018-11-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add suggestions for non-privileged installation

	* doc/install.texi (Configure): Reorganize a paragraph and add @ref's.
	(Installation for non-privileged users): Add paragraphs to suggest to
	supply options "--with-lispdir" and "--with-texmf-dir" etc. to
	configure when installing AUCTeX under the user's home directory.

2018-11-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Defer running style hook until options are given actually

	* latex.el (LaTeX-arg-usepackage-read-packages-with-options): Don't
	run the style hooks before reading package options, just load the
	style files for completion of package options.
	(LaTeX-arg-usepackage): Run style hooks actually after the package
	options are given.
	(TeX-arg-document): Don't run the style hooks before reading class
	options, just load the style file for completion of class options.
	The style hooks are run afterward by `TeX-update-style' anyway.
	* style/exam.el ("exam"): Prepare `LaTeX-exam-class-options' to have
	its full values outside the style hook along with the above idea.
	* style/mathtools.el ("mathtools"):
	* style/empheq.el ("empheq"):
	* style/graphics.el ("graphics"): Set `LaTeX-*****-package-options'
	outside the style hook along with the above idea.

2018-11-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix not to run wrong style hooks

	* tex.el (TeX-style-hook-dialect-weight-alist): Add entry for
	pseudo-dialect `:classopt'.
	(TeX-style-hook-dialect): Add description for `:classopt' in doc
	string.
	* latex.el (LaTeX-common-initialization): Assign style hooks for
	class options into pseudo-dialect `:classopt'.
	Don't set `TeX-PDF-from-DVI' in XeLaTeX document.
	(TeX-latex-mode): Run style hooks for class options in
	`TeX-update-style-hook', without altering `TeX-active-list'.
	* style/geometry.el ("geometry"):
	* style/graphicx.el ("graphicx"): Don't set `TeX-PDF-from-DVI' in
	XeLaTeX document.
	* style/hyperref.el ("hyperref"): Set `TeX-PDF-from-DVI' to "Dvipdfmx"
	when package option "dvipdfmx" is given for non-XeLaTeX document.
	* tests/latex/latex-test.el (LaTeX-style-hook-with-class-option):
	Refine tests.
	* doc/auctex.texi (Simple Style): Add descriptions for available
	dialects including `:classopt'.

2018-11-24  Arash Esbati  <arash@gnu.org>

	Add new style/dashundergaps.el

	* Makefile.in (STYLESRC): Add new style.

	* style/dashundergaps.el: New file.

2018-11-16  Arash Esbati  <arash@gnu.org>

	Improve behavior of `TeX-arg-beamer-overlay-spec'

	* style/beamer.el (TeX-arg-beamer-overlay-spec): Use
	`TeX-argument-insert' in the body of the function and respect the
	OPTIONAL argument.
	("beamer"): Enclose all occurrences of
	`TeX-arg-beamer-overlay-spec' in brackets in order to mark them as
	optional.

2018-11-16  Arash Esbati  <arash@gnu.org>

	style/enumitem.el ("enumitem"): Use `TeX-argument-prompt' for query.

2018-11-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	Surround both \langle and \rangle with math delimiter

	* latex.el (LaTeX-math-insert): Typing "C-u ` (" used to result in
	"$\langle$\rangle" when `LaTeX-math-mode' and
	`LaTeX-electric-left-right-brace' are enabled.  Fix this to insert
	"$\langle\rangle$" instead.

2018-11-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	Set `TeX-command-buffer' always (bug#33377)

	* tex-buf.el (TeX-command): Make sure to set `TeX-command-buffer'
	always.

2018-11-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	Adjust preview-latex in case sub file isn't in master directory

	* preview.el.in (preview-dvips-abort):
	(preview-gs-dvips-sentinel):
	(preview-dvipng-place-all): Make sure directory part of dvi file to be
	deleted is removed because deletion takes place in master directory.
	(preview-start-pdf2dsc): Make sure directory part of pdf file is
	removed so that path for later use is constructed correctly.
	(preview-cache-preamble):
	(preview-region):
	(preview-document): Retain directory part of the file name to be
	passed to `preview-generate-preview' because `TeX-run-command' in
	`TeX-inline-preview-internal' doesn't recognize the right path
	otherwise.
	(preview-generate-preview): Adjust in accord with the above change.

2018-11-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Don't block emacs during viewing document

	* tex.el (TeX-documentation-texdoc): Use asynchronous proces not to
	block emacs during viewing document.
	Supply "%s" to `message' argument in case the shell output contains
	accidental %-sequence.

2018-11-02  Arash Esbati  <arash@gnu.org>

	* style/fancyvrb.el (LaTeX-fancyvrb-key-val-options): Add vspace key.

2018-10-31  Arash Esbati  <arash@gnu.org>

	Improve style/fancyvrb.el

	* style/fancyvrb.el (LaTeX-fancyvrb-arg-define-macro): Refactor
	code. Cater for starred version of user defined macros.  Add
	missing `,' in backquote constructs.
	(LaTeX-fancyvrb-arg-define-environment): Refactor code.
	("fancyvrb"): Add \Verb* macro incl. fontification.

2018-10-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Deal with space in path of MikTeX gs executable (Bug#32251)

	* preview.el.in (preview-gs-command): Wrap gs with
	`shell-quote-argument' in case it has space in its path.

2018-10-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Change regexp for clarity

	* preview.el.in (preview--decode-^^ab): Change regexp "[\x00-\xFF]+" to
	"[^[:multibyte:]]+" for clarity that it matches raw 8-bit bytes.

2018-10-30  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make style hooks associated with class options valid again

	* latex.el (TeX-latex-mode): Add a function on `TeX-update-style-hook'
	to run style hooks associated with class options.
	(LaTeX-common-initialization): Set `TeX-PDF-from-DVI' to suitable
	value when a class option "dvips" or "dvipdfmx" is given.
	* style/geometry.el ("geometry"):
	* style/graphicx.el ("graphicx"): Set `TeX-PDF-from-DVI' to "Dvipdfmx"
	when a package option "dvipdfmx" is given.
	* tests/latex/latex-test.el (LaTeX-style-hook-with-class-option): New
	test.

2018-10-30  Ikumi Keita  <ikumi@ikumi.que.jp>

	Deal with partial ^^-quoting in preview-latex

	If latex outputs a multibyte character as a mixture of raw 8-bit byte
	and byte with ^^-quoting, we have to decode them as a whole.

	* preview.el.in (preview--decode-^^ab): Include raw 8-bit bytes which
	already exist in the string as well when decoding with the given
	coding system.
	* tests/latex/preview-latex-test.el: New test.

2018-10-20  Arash Esbati  <arash@gnu.org>

	Extract caption for RefTeX's label context

	* style/listings.el (LaTeX-listings-reftex-label-context-function):
	New function.  Extract the caption in the optional argrument of
	the lstlisting environment and return it as a string for the
	context of a label.

2018-09-07  Arash Esbati  <arash@gnu.org>

	Update style/lettrine.el to package version 2.21

	* style/lettrine.el (LaTeX-lettrine-key-val-options): Delete
	"Vone" option.
	("lettrine"): Delete \LettrineVonefalse macro.

2018-08-25  Arash Esbati  <arash@gnu.org>

	Update style/lettrine.el to package version 2.1

	* style/lettrine.el (LaTeX-lettrine-key-val-options): Add new keys
	"Vone" and "refstring".
	("lettrine"): Add new macros, minor rearrangements.

2018-08-09  Arash Esbati  <arash@gnu.org>

	Update style/lettrine.el to package version 2.01

	* style/lettrine.el (LaTeX-lettrine-key-val-options): Update
	key=val options.
	("lettrine"): Use correct functions on counters and
	lengths/dimensions provided by lettrine.sty.
	Add support for missing macros.

2018-08-09  Arash Esbati  <arash@gnu.org>

	Add new style/ocg-p.el and style/ocgx.el

	* Makefile.in (STYLESRC): Add new styles.

	* style/ocg-p.el:
	* style/ocgx.el: New files.

2018-07-17  Arash Esbati  <arash@gnu.org>

	Add \eqref to RefTeX's reference styles

	* style/amsmath.el ("amsmath"): Add \eqref to
	`reftex-ref-style-alist' when RefTeX is loaded and activate the
	reference style.

2018-07-12  Arash Esbati  <arash@gnu.org>

	Add new style/thmtools.el and style/thm-restate.el

	* Makefile.in (STYLESRC): Add new styles.

	* style/thmtools.el:
	* style/thm-restate.el: New files.

2018-07-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix regression of `TeX-view'

	* tex-buf.el (TeX-active-master): Add dummy argument for
	compatibility.  In `TeX-view', `TeX-commmand' is called with
	`TeX-active-master', so the `file' argument is `TeX-active-master'
	in subsequent call of `TeX-command-expand'.  In that case,
	`TeX--master-or-region-file-with-extra-quotes' calls
	`TeX-active-master' with three arguments.
	(TeX--master-or-region-file-with-extra-quotes): Adapt doc string.
	* tex.el (TeX-expand-list-builtin): Adapt comment.
	* tests/tex/command-expansion.el (TeX-command-expand-active-master):
	New test.

2018-07-07  Arash Esbati  <arash@gnu.org>

	Add new style/marginnote.el

	* Makefile.in (STYLESRC): Add new style.

	* style/marginnote.el: New file.

2018-07-05  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix possible endless loop

	* tex.el (TeX-expand-list-builtin): Use symbol `file' for the entry
	"%T" so that special treatment for `file' about advancing matching
	position in `TeX-command-expand' takes effect.
	* tests/tex/command-expansion.el (TeX-command-expand-skip-file-name):
	New test.

2018-06-17  Ikumi Keita  <ikumi@ikumi.que.jp>

	Adjust test for known emacs bug

	* tests/latex/latex-test.el (LaTeX-includegraphics-extensions): Mark
	emacs 26.1 as expected failure.

2018-06-04  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make preamble caching robust to LuaLaTeX and (u)pLaTeX

	* preview.el.in (preview-cache-preamble): Modify .ini code so that
	LaTeX variants even without \pdfoutput can read unusual file names
	(with space or non-ascii character, or both) when preamble cache is
	enabled.  The modified .ini code is kindly provided by jfbu
	<jfbu@free.fr>.
	(preview-dump-replacements, preview-undump-replacements): Add
	-file-line-error option to the undump- variable so that AUCTeX can
	analyse the output from lualatex even with file name with space.
	It turned out that -kanji option is needed for platex even when
	dumping format file if the preamble contains Japanese characters.
	Thus modify the both variables so that -kanji option, if any, is
	retained.
	(TeX-inline-preview-internal): Revert the additional post process of
	the command line string introduced last year by me because it is no
	longer necessary by the above change on
	`preview-undump-replacements'.  Though this change disables -jobname
	option again when lualatex is used with preamble cache, it would be
	fine because that concerns only very old lualatex binaries and that
	had always been the state before my commit just a year ago.
	The above three modifications fix bug#31685 and bug#31686.
	* tests/japanese/preview-latex.el
	(japanese-preview-preserve-kanji-option2): Arrange with the above
	change.
	(japanese-preview-preserve-kanji-option3): New test.
	(japanese-preview-error-quote-shift-jis): Remove spurious backslash.
	* doc/preview-latex.texi (Key bindings and user-level lisp functions):
	Add description about restriction of preamble cache on LaTeX variants.

2018-06-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Raise robustness of call of dvipng command

	* preview.el.in (preview-dvipng-command): Remove spurious quotes which
	cause error for file names with space.  (bug#31684)
	(preview-dvipng-color-string): Replace single quotes with double
	quotes for w32 users.
	* doc/preview-latex.texi: (The preview images): Add warning that
	(u)pLaTeX is not compatible with dvipng.

2018-05-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add note and test about the change involving non-ascii file name

	* doc/changes.texi (News in 12.2): Add note that support for standard
	LaTeX without e-TeX extension is now very limited.
	* tests/tex/command-expansion.el (TeX-command-detokenize): New test to
	check whether \input and \detokenize are supplied when necessary.

2018-05-28  Ikumi Keita  <ikumi@ikumi.que.jp>

	TL 2018 non-ascii file name fix for preview-latex

	* preview.el.in (preview-LaTeX-command): Wrap file name after implicit
	\input in \detokenize{}.
	(preview-cache-preamble): Arrange the ini file code so that non-ascii
	file name can be used with generated format file.  Be careful not to
	lose capability of handling file name with space.
	(preview-undump-replacements): Use new TeX macro defined in the above
	ini file code to accept even unusual file name with non-ascii
	character or space.
	Delegate quoting of format name to `TeX-inline-preview-internal' so
	that non-ascii character will not be quoted twice.
	(TeX-inline-preview-internal): Adjust to the above change.

2018-05-28  Ikumi Keita  <ikumi@ikumi.que.jp>

	Accept non-ascii file name in accord with change in TL 2018

	* tex.el (TeX-expand-list-builtin): Add new entry %T.  Same as %t,
	except to enclose with \detokenize{} for non UTF-8 LaTeX when \input
	is supplmented.
	Adjust the entries %` and %' so that \input is supplemented only when
	any TeX code is present between them and leave the bind to
	`TeX-command-text' for later examination.
	The bind to `TeX-command-pos' is no longer retained.
	(TeX-command-list): Use %T for "LaTeX".
	Adjust "TeX" and "AmSTeX" as the same with "LaTeX" in the aspect that
	user can supply one's own TeX code, as well as any command line
	options, through `TeX-command-extra-options'.
	* tex-buf.el (TeX--master-or-region-file-with-extra-quotes): New
	function to act as a wrapper of `TeX-master-file' and
	`TeX-region-file' inside `TeX-command-expand'.
	(TeX-command-expand): Use the above function as the value of `file'
	and get rid of tricky temporal overriding of `file' with lambda form.
	(TeX-region-create): Make the first line parsing of %&FORMAT
	construct, if any, to be valid even for region compilation.
	Discard text properties when constructing the content of _region_.tex.
	Drop bind check for `buffer-file-coding-system'.
	* tests/tex/command-expansion.el (TeX-command-expansion): Reflect the
	change that \input is not necessarily supplemented now by %`-%' pair
	in `TeX-command-expand'.

2018-05-28  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix region compilation with \usepackage[utf8]{inputenc}

	* tex-buf.el (TeX-quote-filename): Wrap non-ascii characters in
	\unexpanded{} for non UTF-8 LaTeX so that raw file name is recovered.

2018-05-27  Arash Esbati  <arash@gnu.org>

	Quote %b expansion string for Zathura

	* tex.el (TeX-view-program-list-builtin): Guard %b expansion
	string for Zathura with quotes for file names with spaces
	(bug#31451).

2018-05-14  Ikumi Keita  <ikumi@ikumi.que.jp>

	Prepare for UTF-8 with BOM

	* tex-buf.el (TeX-adjust-process-coding-system): Don't use
	`utf-8-with-signature' to encode keyboard input for TeX process.
	Drop mule feature check.

2018-05-14  Ikumi Keita  <ikumi@ikumi.que.jp>

	Drop compatibility code for older emacsen in preview-latex

	We no longer need messy treatment with regard to coding system in
	preview-latex since xemacs isn't supported anymore.

	* preview.el.in (preview-coding-system): Remove.
	(preview-error-quote): Simplify.  Discard RUN-CODING-SYSTEM argument.
	(preview--decode-^^ab): Drop mule feature check.
	(preview--convert-^^ab): Drop compatibility code for older emacsen.
	(preview-parse-messages): Remove `run-coding-system' argument from
	calls to `preview-error-quote'.
	(TeX-inline-preview-internal): Drop codes related to coding system.
	* prv-emacs.el (preview-buffer-recode-system): Remove.
	* tests/japanese/preview-latex.el
	(japanese-preview-error-quote-shift-jis): Remove `shift_jis' argument
	from call to `preview-error-quote'.
	Remove unnecessary let bind on `TeX-japanese-process-output-coding-system'.
	(japanese-preview-process-coding-system): Remove.
	(japanese-preview-shift-jis):
	(japanese-preview-different-coding-system): Use `copy-sequence' on
	`process-environment' in order to guard it from temporal `setenv'.

2018-05-11  Ikumi Keita  <ikumi@ikumi.que.jp>

	Support UTF-8 with BOM in Japanese TeX documents

	* tex-jp.el (japanese-TeX-coding-ejsu): Consider the case the document
	is encoded in UTF-8 with BOM, which begins to be supported in TeXLive
	2018.

2018-05-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	Replace another cl function with cl-lib

	* style/pstricks.el (eval-when-compile): Require cl-lib.
	(LaTeX-pst-cleanup): Replace `caddr' with `cl-caddr'.

2018-05-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Update URLs further

	* COPYING:
	* Makefile.in:
	* RELEASE:
	* bib-cite.el:
	* build-aux/gitlog-to-auctexlog:
	* latex/README:
	* latex/preview.dtx:
	* preview.el.in:
	* style/foils.el:
	* style/hyperref.el:
	* style/ifluatex.el:
	* style/luatextra.el:
	* style/mathtools.el:
	* style/pstricks.el:
	* tests/Makefile:
	* tex-buf.el:
	* tex.el: Update URLs.  Use https: rather than http: or ftp: where
	possible.
	* build-aux/gitlog-to-changelog: Update URLs.
	Use `before-save-hook' instead of obsolete `write-file-hooks' in
	Local Variables section.

2018-05-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	Update URLs

	* tex-site.el.in:
	* doc/auctex.texi:
	* doc/fdl.texi:
	* doc/install.texi:
	* doc/intro.texi:
	* doc/preview-readme.texi:
	* doc/wininstall.texi: Update URLs.  Use https: rather than http: or
	ftp: where possible.
	* auctex.spec: Update URLs.  Use https: rather than http: or
	ftp: where possible.
	Remove xemacs support.
	Update required emacs version.

2018-05-06  Ikumi Keita  <ikumi@ikumi.que.jp>

	Adjust coding system for Japanese pTeX engine on w32

	Default coding system of Japanese pTeX engine in w32 TeXLive changed
	from SHIFT JIS to UTF-8 in 2018.  Make tex-jp.el to work with both
	TeXLive 2017 and 2018 on w32 platform, with higher priority on newer
	engine with regard to the behavior in non default case.

	* tex-jp.el (japanese-TeX-use-kanji-opt-flag): Set default value to t
	even on w32 platform.
	(japanese-TeX-set-process-coding-system): Change coding system for non
	default case from `shift_jis' to `utf-8' on w32 platform.
	(TeX-expand-list-builtin): Remove mule feature check.

2018-05-05  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove obsolete option related to Japanese TeX

	* tex-jp.el (japanese-TeX-command-list): Remove.  Ataka-san and I
	(Ikumi) discussed this topic and decided to delete this option.
	* doc/auctex.texi (Japanese): Mention the above change.

2018-05-04  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix previous removal of xemacs compatibility code

	* toolbar-x.el (toolbarx-default-toolbar-meaning-alist): Remove
	spurious quote formerly inside "," construct.
	Replace "`" with "'".

2018-04-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Prevent spurious newlines to be added

	* tex-fold.el (TeX-fold-overfull-p): Restore mandatory `and'.  The
	removal of xemacs compatibility code previously done was a bit too
	aggressive.

2018-04-16  Arash Esbati  <arash@gnu.org>

	Update key=val options to geometry package v5.8

	* style/geometry.el (LaTeX-geometry-preamble-key-val-options): Add
	new keys luatex, dvipdfmx and xdvipdfmx.  Delete duplicate
	entries.

2018-04-12  Ikumi Keita  <ikumi@ikumi.que.jp>

	Correct how `TeX-record-buffer' is used

	* tex-buf.el (TeX-pop-to-buffer): Use `TeX-record-buffer' in accord with
	the documents.
	* doc/changes.texi: Mention the change and warn users who have
	customized the option.

2018-04-12  Ikumi Keita  <ikumi@ikumi.que.jp>

	Correct record in changes.texi

	* doc/changes.texi (): Make a new section for release 12.2 and move
	mention about change made after release 12.1 there.

2018-04-07  Arash Esbati  <arash@gnu.org>

	Quote %b expansion string for SumatraPDF

	* tex.el (TeX-view-program-list-builtin): Guard %b expansion
	string for SumatraPDF with quotes for file names with spaces
	(bug#30999).

2018-04-01  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add support for dvipdfmx to \includegraphics

	* style/graphicx.el (LaTeX-includegraphics-extensions-list): Add
	support for dvipdfmx.
	* tests/latex/latex-test.el (LaTeX-includegraphics-extensions): New
	test to check whether correct extensions are generated.

2018-04-01  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use `TeX-search-files-by-type' to assist input \includegraphics

	* style/graphicx.el (LaTeX-includegraphics-extensions-list): New
	function.
	(LaTeX-includegraphics-extensions): Delegate most of its task to the
	above new function and become its wrapper.
	(LaTeX-includegraphics-global-files): New variable.
	(LaTeX-includegraphics-read-file-TeX): Use `TeX-search-files-by-type'
	rather than `TeX-search-files' and cache global value in the above
	new variable.
	Reflect the option `LaTeX-includegraphics-strip-extension-flag'.
	* tex.el (TeX-search-files-type-alist): Remove `graphics' entry,
	which is supplied in latex-mode by `LaTeX-search-files-type-alist'.
	(TeX-normal-mode): Add `LaTeX-includegraphics-global-files' to list of
	variables to be cleared.

2018-04-01  Ikumi Keita  <ikumi@ikumi.que.jp>

	Resolve conflict of argument spec between regexp and literal

	* tex.el (TeX-search-files-kpathsea): Treat EXTENSIONS argument as a
	list of regexps in accordance with other parts of AUCTeX.
	(TeX-ispell-document): Treat `TeX-file-extensions' as a list of
	regexps in accordance with other parts of AUCTeX.
	(TeX-file-extensions, TeX-Biber-file-extensions):
	(BibTeX-file-extensions, BibLaTeX-style-extensions):
	(BibTeX-style-extensions): Change custom type to regexp from string.
	(TeX-doc-extensions): Turn into list of regexps.
	* latex.el (LaTeX-split-bibs): Treat `TeX-Biber-file-extensions' as a
	list of regexps in accordance with other parts of AUCTeX.

2018-03-29  Alex Branham  <branham@utexas.edu>

	Fix TeX-dwim-master

	* tex.el (TeX-dwim-master): `cl-return' is much easier to work with if
	we're alerady using cl- functions, so convert `dolist' to `cl-loop.'

2018-03-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make `TeX-clean' to work in ams-tex-mode

	* plain-tex.el (AmSTeX-clean-intermediate-suffixes,
	AmSTeX-clean-output-suffixes): New customize options.
	(AmS-TeX-mode-hook): Move from tex.el.
	(AmSTeX-mode-command-menu, AmSTeX-mode-menu): Fix doc strings.
	(): Update copyright year.
	* tex.el (TeX-mode-prefix): Add an entry for AmS-TeX.
	(AmS-TeX-mode-hook): Move to plain-tex.el.

2018-03-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make compatible with emacs 24

	* latex.el (TeX-read-label): Use `format' instead of `format-message'
	if the latter is not available.

2018-03-29  Jonathan Underwood  <jonathan.underwood@gmail.com>

	Fix incorrect FSF address

	* multi-prompt.el ():
	* style/comment.el ():
	* style/latexinfo.el (): Fix incorrect FSF address and whitespaces.

2018-03-17  Ikumi Keita  <ikumi@ikumi.que.jp>

	* style/amsmath.el ("amsmath"): Correct \cfrac spec.

2018-03-16  Alex Branham  <branham@utexas.edu>

	* tex.el (TeX-dwim-master): Prefer `cl-return' over `return'.

2018-03-12  Arash Esbati  <arash@gnu.org>

	* font-latex.el (font-latex--get-script-props): Use `cl-case' instead of `case'.

2018-03-04  Arash Esbati  <arash@gnu.org>

	Add new function `TeX-arg-verb-delim-or-brace'

	* latex.el (TeX-arg-verb-delim-or-brace): New function for \verb
	like macros which take their argument either in delimiters or in
	braces.

	* doc/auctex.texi (Adding Macros): Document
	`TeX-arg-verb-delim-or-brace'.

	* style/listings.el ("listings"): Use
	`TeX-arg-verb-delim-or-brace' for \lstinline which also takes an
	optional argument.

	* style/minted.el (LaTeX-minted-auto-cleanup, "minted"): Use
	`TeX-arg-verb-delim-or-brace' for \mintinline and new macros
	defined with \newmintinline.

	* style/url.el ("url"): Use `TeX-arg-verb-delim-or-brace' for \url
	and \path.
	Remove "{" from fontification or \url and \path.

2018-03-01  Alex Branham  <branham@utexas.edu>

	Remove cl from AUCTeX

	* tex.el: replace last 'cl with 'cl-lib
	* latex.el: replace cl function with cl-lib function

2018-03-01  Alex Branham  <branham@utexas.edu>

	Refine how we setup flymake backend function

	* latex.el: Add LaTeX-flymake to TeX-latex-mode
	* latex-flymake.el: Don't add to LaTeX-mode-hook

2018-02-21  Alex Branham  <branham@utexas.edu>

	Improve flymake documentation

	* doc/changes.texi:
	* doc/auctex.texi (Checking): Add Flymake support to manual.

	* latex-flymake.el: Add copyright notice and fix a quote.

2018-02-20  Arash Esbati  <arash@gnu.org>

	* Makefile.in (AUCSRC): Add new file latex-flymake.el.

2018-02-18  Arash Esbati  <arash@gnu.org>

	* style/babel.el (LaTeX-babel-active-languages): Use `cl-pushnew'.

2018-02-17  Mosè Giordano  <mose@gnu.org>

	Replace cl with cl-lib in other files

	* latex.el (LaTeX-hanging-ampersand-position):
	* tex-fold.el (require):
	(TeX-fold-region-macro-or-env):
	(TeX-fold-update-at-point):
	* tex-info.el (require):
	(Texinfo-make-node-list):
	* toolbar-x.el (require):
	(toolbarx-good-option-list-p): Replace cl with cl-lib and corresponding macros.

2018-02-17  Mosè Giordano  <mose@gnu.org>

	Explicitly require Emacs 24

	* tex.el: Error when Emacs < 24 is used.

2018-02-17  Alex Branham  <branham@utexas.edu>

	Support flymake in Emacs 26+ using chktex

	* latex-flymake.el: New file.
	* latex.el (require): Require `latex-flymake' in Emacs >= 26.

2018-02-17  Alex Branham  <branham@utexas.edu>

	Replace cl with cl-lib

	* bib-cite.el (require):
	(psg-list-env):
	* font-latex.el (require):
	* latex.el (require):
	* style/babel.el (require):
	* style/caption.el (require):
	(LaTeX-caption-update-key-val-options):
	* style/empheq.el (require):
	(LaTeX-empheq-update-key-val-options):
	* style/enumitem.el (require):
	(LaTeX-enumitem-update-key-val-options):
	("enumitem"):
	* style/floatrow.el (require):
	(LaTeX-floatrow-update-key-val-options):
	* style/fvextra.el (require):
	(LaTeX-fvextra-update-key-val):
	* style/listings.el (require):
	(LaTeX-listings-update-style-key):
	* style/mdframed.el (require):
	(LaTeX-mdframed-update-style-key):
	* style/tcolorbox.el (require):
	(LaTeX-tcolorbox-update-style-key): Replace cl with cl-lib.

2018-01-25  Alex Branham  <branham@utexas.edu>

	Remove some obsolete functions

	* font-latex.el (font-latex-syntactic-face-function):
	* preview.el.in (preview-gs-restart):
	* tex-buf.el (TeX-run-background):
	(TeX-run-silent):
	* tex.el:
	(TeX-source-correlate-handle-TeX-region):
	(TeX-insert-macro):
	(TeX-doc):
	* texmathp.el (texmathp): Now that AuCTeX requires GNU Emacs 24.1 or greater, we
	can remove some functions that are obsolete in Emacs < 24.1

2018-01-12  Mosè Giordano  <mose@gnu.org>

	Do not actually write bug report instructions

	* tex.el (TeX-submit-bug-report): Use `propertize' to show instructions without
	  writing them in the message.

2017-12-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make sure `process-environment' is recovered after temporal setenv

	* preview.el.in (TeX-inline-preview-internal): Since `setenv' operates
	destructively on `process-environment', use `copy-sequence' for
	maximal safety in order to guard its list structure.

2017-12-28  Arash Esbati  <arash@gnu.org>

	Add fontification for some core macros

	* font-latex.el (font-latex-built-in-keyword-classes): Add macros
	\addvspace, \raggedright and \raggedleft to function class.

2017-12-27  Arash Esbati  <arash@gnu.org>

	* texmathp.el (texmathp-tex-commands-default): Add entries for breqn.sty.

2017-12-21  Mosè Giordano  <mose@gnu.org>

	Restore some code erroneously removed from font-latex.el

	* font-latex.el (font-latex-make-sectioning-faces):
	(font-latex-user-keyword-classes):
	(font-latex-slide-title-face): Restore code.

2017-12-21  Mosè Giordano  <mose@gnu.org>

	Restore loading of prv-emacs

	* preview.el.in: Require prv-emacs.

2017-12-20  Mosè Giordano  <mose@gnu.org>

	Remove compatibility code for XEmacs in toolbar-x.el

	* toolbar-x.el (toolbarx--if-when-compile): Remove macro no more needed.
	(toolbarx-emacs-mount-popup-menu):
	(toolbarx-mount-popup-menu):
	(toolbarx-test-image-type):
	(toolbarx-test-button-type):
	(toolbarx-test-toolbar-type):
	(toolbarx-find-image):
	(toolbarx-emacs-add-button):
	(toolbarx-refresh):
	(toolbarx-install-toolbar):
	(toolbarx-default-toolbar-meaning-alist): Remove code for compatibility with
	XEmacs.
	(toolbarx-xemacs-mount-popup-menu):
	(toolbarx-xemacs-image-properties):
	(toolbarx-xemacs-button-properties):
	(toolbarx-xemacs-refresh-process-button-or-insert-list):
	(toolbarx-xemacs-refresh): Remove functions.

2017-12-20  Mosè Giordano  <mose@gnu.org>

	Remove compatibility code for XEmacs in font-latex.el

	* font-latex.el (font-latex-sectioning-5-face):
	(font-latex-update-sectioning-faces):
	(font-latex-make-sectioning-faces):
	(font-latex-user-keyword-classes):
	(font-latex-fontify-script):
	(font-latex-verbatim-face):
	(font-latex-slide-title-face):
	(font-latex-setup): Remove code for compatibility with XEmacs.

2017-12-20  Mosè Giordano  <mose@gnu.org>

	Remove compatibility code for XEmacs in tex-fold.el

	* tex-fold.el (TeX-fold-overfull-p):
	(TeX-fold-macro-nth-arg):
	(TeX-fold-hide-item):
	(TeX-fold-show-item):
	(TeX-fold-post-command): Remove code for compatibility with XEmacs.

2017-12-20  Mosè Giordano  <mose@gnu.org>

	Remove code for compatibility with very old emacsens in bib-cite.el

	* bib-cite.el (bib-cite-minor-mode):
	(bib-cite-setup-highlight-mouse-keymap):
	(bib-cite-fontify-help-as-bibtex):
	(bib-cite-fontify-help-as-latex):
	(bib-etags):
	(bib-highlight-mouse):
	(bib-toggle-highlight):
	(bib-guess-or-prompt-for-label):
	(bib-etags-find-noselect): Remove compatibility code.

2017-12-20  Mosè Giordano  <mose@gnu.org>

	Delte prv-xemacs.el

	* prv-xemacs.el: Delete file.
	* preview.el.in (preview): Remove code to load prv-xemacs.

2017-12-20  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove XEmacs compatibility code in tex-jp.el

	* tex-jp.el (japanese-TeX-set-process-coding-system)
	(japanese-TeX-coding-ejsu): Remove code for compatibility with
	XEmacs.

2017-12-20  Ikumi Keita  <ikumi@ikumi.que.jp>

	Delete unused options

	* tex-jp.el (japanese-TeX-command-default,
	japanese-LaTeX-command-default): Remove them because they are no
	longer used anywhere in the current code.  Ataka-san and I (Ikumi)
	discussed this matter and agreed to dismiss them.
	* doc/auctex.texi: Reflect the above change.

2017-12-19  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make sure `LaTeX-default-options' is honored

	* latex.el (TeX-arg-document): Use `LaTeX-default-options' as default
	of class options even when the respective `LaTeX-XXXX-class-options'
	is not set.

2017-12-17  Arash Esbati  <arash@gnu.org>

	Update style/bidi.el to package version 31.7

	* style/bidi.el (LaTeX-bidi-package-options): Add
	"extrafootnotefeatures" option.
	(LaTeX-env-bidi-bib): New function.
	("bidi"): Add missing macros and environments.  Add fontification
	support.

2017-12-17  Arash Esbati  <arash@gnu.org>

	Add fontification for some core macros

	* font-latex.el (font-latex-built-in-keyword-classes): Fontify
	core macros \marginpar (reference), \LaTeXe (function) and
	\bibitem (textual).

2017-12-17  Mosè Giordano  <mose@gnu.org>

	Change encoding of Elisp source files to UTF-8

	* style/alphanum.el:
	* style/dk-bib.el:
	* style/doc.el:
	* style/inputenc.el:
	* style/jura.el:
	* style/ltx-base.el:
	* style/ltxdoc.el:
	* tex-font.el:
	* tex.el: Change coding of files to UTF-8.  Now that we require Emacs >= 24 it
	  is always possible to use this encoding.

2017-12-17  Mosè Giordano  <mose@gnu.org>

	Remove code for compatibility with old Emacsens in tex.el

	* tex.el: Always require `crm', which is available in all supported version of
	  Emacs.
	(TeX-completing-read-multiple): Remove function definition for XEmacs.
	(TeX-view-predicate-list-builtin):
	(TeX-source-correlate-sync-source):
	(TeX-tree-expand):
	(TeX-comment-forward): Remove code for compatibility with old Emacsens.

2017-12-17  Mosè Giordano  <mose@gnu.org>

	Remove TeX-line-number-at-pos

	* tex.el (TeX-line-number-at-pos): Remove function and alias.
	* style/pdfsync.el (LaTeX-pdfsync-output-page):
	* tex-info.el (Texinfo-make-node-list): Replace `TeX-line-number-at-pos' with
	  `line-number-at-pos'.

2017-12-17  Mosè Giordano  <mose@gnu.org>

	Remove XEmacs compatibility code in tex.el

	* tex.el (TeX-source-correlate-gnuserv-p):
	(TeX-source-correlate-map):
	(VirTeX-common-initialization):
	(TeX-mode-map):
	(TeX-search-syntax-table): Remove code for compatibility with XEmacs.

2017-12-17  Mosè Giordano  <mose@gnu.org>

	Remove TeX-how-many function

	* tex.el (TeX-how-many): Remove function.
	* latex.el (LaTeX-hanging-ampersand-position): Replace `TeX-how-many' with
	  `how-many'.

2017-12-17  Mosè Giordano  <mose@gnu.org>

	Remove TeX-assoc-string

	* tex.el (TeX-assoc-string): Remove alias.
	(TeX-add-style-hook):
	(TeX-unload-style):
	(TeX-run-style-hooks):
	* tex-info.el (Texinfo-nodename-de-escape):
	(Texinfo-nodename-escape): Replace `TeX-assoc-string' with `assoc-string'.

2017-12-17  Mosè Giordano  <mose@gnu.org>

	Remove TeX-deactivate-mark

	* tex.el (TeX-deactivate-mark): Remove function.
	(TeX-argument-insert):
	* latex.el (LaTeX-env-item):
	* style/currvita.el (LaTeX-currvita-env-with-label):
	* style/dinbrief.el (LaTeX-dinbrief-insert):
	(LaTeX-dinbrief-env-recipient):
	* style/enumitem.el (LaTeX-enumitem-env-with-opts):
	* style/moodle.el (LaTeX-moodle-question-env-with-args):
	* style/tcolorboxlib-raster.el (LaTeX-tcolorbox-lib-raster-env-item): Replace
	  `TeX-deactivate-mark' with `deactivate-mark'.

2017-12-17  Mosè Giordano  <mose@gnu.org>

	Remove old compat functions for commenting and uncommenting

	* tex.el (TeX-comment-regio):
	(TeX-comment-or-uncomment-region):
	(TeX-uncomment-region): Remove old compatibility functions.
	* context.el (ConTeXt-mode-menu):
	* latex.el (LaTeX-mode-menu):
	* plain-tex.el (plain-TeX-menu-entries):
	* tex-info.el (Texinfo-mode-menu):
	* tex.el (TeX-mode-map):
	(TeX-in-comment):
	(TeX-in-commented-line): Replace compat functions with standard functions.

2017-12-16  Mosè Giordano  <mose@gnu.org>

	Remove XEmacs compatibility code in latex.el

	* latex.el (LaTeX-largest-level-set):
	(LaTeX-after-insert-env-hook):
	(LaTeX-indent-line):
	(LaTeX-fill-region-as-paragraph):
	(LaTeX-fill-newline):
	(LaTeX-common-initialization): Remove code for compatibility with XEmacs.
	(LaTeX-fill-delete-newlines): Remove function, no more needed.
	(LaTeX-fill-region-as-para-do): Replace `LaTeX-fill-delete-newlines' with
	`fill-delete-newlines'.

2017-12-16  Mosè Giordano  <mose@gnu.org>

	Remove XEmacs compatibility code in tex-buf.el

	* tex-buf.el (TeX-record-buffer): Always define this option.
	(TeX-recenter-output-buffer):
	(TeX-previous-error):
	(TeX-parse-TeX): Remove code for compatibility with XEmacs.
	(TeX-parse-error): Fix a bug in the regexp.
	(TeX-error-overview): Remove check for Emacs version.  Now this works in all
	supported versions.

2017-12-10  Mosè Giordano  <mose@gnu.org>

	* Version 12.1 released.

2017-12-09  Mosè Giordano  <mose@gnu.org>

	Remove references to old Emacsen from the manual

2017-12-07  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove references to XEmacs from the manual

	* doc/intro.texi:
	* doc/preview-faq.texi:
	* doc/preview-latex.texi:
	* doc/preview-readme.texi: Remove references to XEmacs.

2017-12-04  Mosè Giordano  <mose@gnu.org>

	Remove references to XEmacs from the manual

	* doc/auctex.texi:
	* doc/faq.texi:
	* doc/install.texi:
	* doc/preview-faq.texi:
	* doc/preview-latex.texi:
	* doc/preview-problems.texi:
	* doc/quickstart.texi:
	* doc/tex-ref.tex:
	* doc/todo.texi:
	* doc/wininstall.texi: Remove references to XEmacs.

2017-12-03  Mosè Giordano  <mose@gnu.org>

	Prepare for new brand-new series of AUCTeX

	* RELEASE: Update version number and release notes.
	* doc/changes.texi: Update.
	* configure.ac:
	* doc/tex-ref.tex:
	* latex/preview.dtx: Update version number.
	* tex-site.el.in: Require Emacs 24 of higher.

2017-12-03  Mosè Giordano  <mose@gnu.org>

	* Version 11.92 released.

2017-12-03  Mosè Giordano  <mose@gnu.org>

	Prepare for upcoming release

	* RELEASE: Update version number and release notes.
	* doc/changes.texi: Mention bug fixes.
	* configure.ac:
	* doc/tex-ref.tex:
	* latex/preview.dtx: Update version number.

2017-12-03  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix auto detect of kpathsea delimeter

	* tex.el (TeX-kpathsea-detect-path-delimiter): New function.
	(TeX-kpathsea-path-delimiter): Use it to obtain the default value.
	(TeX-tree-expand): Use it to simplify auto detection method.
	Use `TeX-kpathsea-path-delimiter' for argument given to kpsewhich
	command.  Using constant ";" is completely wrong for most kpsewhich
	implementation.

2017-11-30  Arash Esbati  <arash@gnu.org>

	Get rid of `delete-dups'

	* style/caption.el (LaTeX-caption-update-key-val-options):
	* style/enumitem.el (LaTeX-enumitem-update-key-val-options):
	* style/floatrow.el (LaTeX-floatrow-update-key-val-options):
	* style/graphicx.el (LaTeX-includegraphics-extensions):
	* style/listings.el (LaTeX-listings-update-style-key):
	* style/mdframed.el (LaTeX-mdframed-update-style-key):
	* style/menukeys.el (TeX-arg-menukeys-newmenumacro): Replace
	`delete-dups' with `TeX-delete-duplicate-strings'.

2017-11-30  Arash Esbati  <arash@gnu.org>

	* style/longtable.el ("longtable"): Use `make-local-variable'.

	* tex-ispell.el: Add entry for "xltabular" environment.

2017-11-30  Arash Esbati  <arash@gnu.org>

	Fix style/xltabular.el

	* style/xltabular.el (LaTeX-xltabular-skipping-regexp): New variable.
	(LaTeX-env-xltabular):
	(LaTeX-item-xltabular): New function.
	("xltabular"): Use the above functions in the style hook.

2017-11-30  Mosè Giordano  <mose@gnu.org>

	Reduce code duplication in tests

	* tests/make-test-deps.emacs-lisp: New file.
	* tests/Makefile (%.log): Load it make-test-deps.emacs-lisp when running tests.
	* tests/context/context-test.el:
	* tests/japanese/error-parsing.el:
	* tests/japanese/parse-timing.el:
	* tests/japanese/preview-latex.el:
	* tests/latex/latex-test.el:
	* tests/tex/error-parsing.el:
	* tests/tex/path-expansion.el:
	* tests/tex/utility.el: Remove code moved to make-test-deps.emacs-lisp.

2017-11-30  Ikumi Keita  <ikumi@ikumi.que.jp>

	Revert wrong test

	* tests/tex/path-expansion.el (TeX-kpathsea-delimiter-w32): Remove.

2017-11-30  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add style path explicitly

	* tests/japanese/error-parsing.el ():
	* tests/japanese/parse-timing.el ():
	* tests/japanese/preview-latex.el (): Add "style" subdirectory in the
	repository to `TeX-style-path' so we can load style files inside tests.

2017-11-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Re-implement auto-detect of path separator from kpsewhich output

	* tex.el (TeX-kpathsea-path-delimiter): Accept t for Autodetect again
	and make it default on w32 platform.
	(TeX-tree-expand): Use heuristics as much as possible to determine the
	path separator, paying attention to the case that it cannot be
	determined.

2017-11-23  Tassilo Horn  <tsdh@gnu.org>

	Don't set company-minimum-prefix-length in tex mode buffers

	* tex.el (VirTeX-common-initialization): Don't set
	company-minimum-prefix-length in tex mode buffers.

	AUCTeX used to set company-minimum-prefix-length to 1 initially because there
	aren't too many TeX completions provided by AUCTeX itself.  However, some users
	use multiple completion backends in TeX modes (like dabbrev for example), and
	then the number of completion candidates increases dramatically.

	Also see https://github.com/syl20bnr/spacemacs/issues/9388 and
	https://github.com/alexeyr/company-auctex/issues/18.

2017-11-19  Arash Esbati  <arash@gnu.org>

	* doc/changes.texi: Mention compatibility of preview with GS 9.22.

2017-11-18  Arash Esbati  <arash@gnu.org>

	Improve style/epigraph.el

	* style/epigraph.el ("epigraph"): Leave point inside first pair of
	braces for \epigraph and \qitem.
	Use `LaTeX-add-lengths' for skips instead of `TeX-add-symbols'.
	Use `TeX-arg-length' instead of `TeX-arg-size' for \dropchapter.
	Append qitem macro to `LaTeX-item-regexp'.
	Improve fontification.

2017-11-16  Ikumi Keita  <ikumi@ikumi.que.jp>

	Give proper argument to `TeX-command-expand'

	* preview.el.in (TeX-inline-preview-internal): Give `TeX-region-file'
	or `TeX-master-file' as `file' argument of `TeX-command-expand' when
	preamble caching is enabled.  This argument used to be nil, which
	caused error when lualatex is in use.  The fourth element of the
	`luatex' entry of `TeX-engine-alist-builtin' contains "%s", which
	eventually triggers the use of the `file' argument.

2017-11-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add test for the recent change about `TeX-kpathsea-path-delimiter'

	* tests/tex/path-expansion.el (TeX-kpathsea-delimiter-w32): New test.

2017-11-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	Document `TeX-view-evince-keep-focus'

	* doc/auctex.texi (Starting Viewers):
	* doc/changes.texi (News in 11.92):
	Document `TeX-view-evince-keep-focus'.

2017-11-14  Ikumi Keita  <ikumi@ikumi.que.jp>

	Document `TeX-math-input-method-off-regexp' properly.

	* doc/auctex.texi (Entering Mathematics):
	* doc/changes.texi (News in 11.92):
	Document `TeX-math-input-method-off-regexp'.

2017-11-13  Ikumi Keita  <ikumi@ikumi.que.jp>

	Mention the necessity of GNU make

	* doc/install.texi (Prerequisites): Add an item of GNU make.
	Fix copyright year.

2017-11-13  Ikumi Keita  <ikumi@ikumi.que.jp>

	Bug fix and code refactoring related to kpathsea

	* tex.el (TeX-kpathsea-path-delimiter): Use `path-separator' for
	default value.  Drop t from the candidates because auto detection
	sometimes fails for w32 platform.
	(TeX-tree-expand): Always use `TeX-kpathsea-path-delimiter' if
	non-nil.
	Disable subsequent use of kpathsea if kpsewhich causes error or
	returns non-zero exit value.
	Accept nil for PROGRAM argument.
	(TeX-search-files-kpathsea): Always use `TeX-kpathsea-path-delimiter' if
	non-nil.
	Use `TeX-tree-expand'.
	Don't signal error even if kpsewhich causes error or returns non-zero
	exit value.

2017-11-12  Arash Esbati  <arash@gnu.org>

	Add new style/xltabular.el

	* Makefile.in (STYLESRC): Add new style.

	* style/xltabular.el: New file.

2017-11-12  Arash Esbati  <arash@gnu.org>

	Add new function `LaTeX-env-longtable'

	* style/longtable.el (LaTeX-env-longtable): Add new function.
	Move the body of the anonymous function into this in order to make
	it available for other styles loading longtable.

2017-11-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	* tex.el (TeX-math-input-method-off-regexp): Turn defvar into defcustom.

2017-11-06  David Kastrup  <dak@gnu.org>

	Remove use of .runandhide operator

	Ghostscript bug 698680
	<https://bugs.ghostscript.com/show_bug.cgi?id=698680> has been caused
	by the removal of the .runandhide operator in Ghostscript 9.22
	upstream.  Since .runandhide has no longer been used in a
	security-critical manner, its operation can be emulated by storing the
	respective information in a .preview-ST variable.  Potentially
	malicious code would not be able to retrieve a non-safe "save" object
	from here.

2017-09-30  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix Copyright year

	* context-en.el, context-nl.el, latex.el, plain-tex.el:
	* preview.el.in, prv-xemacs.el, tex-bar.el, tex-buf.el:
	* tex-info.el, tex-site.el.in, tex-style.el, tex.el:
	Fix Copyright year.

2017-09-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Cosmetic Change

	* font-latex.el (font-latex-match-math-env): Quote "\[" with "\=" in
	doc string.
	(font-latex-add-to-syntax-alist): Delete duplicated line.

2017-09-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix doc strings and comments

	* plain-tex.el (TeX-plain-tex-mode, ams-tex-mode): Fix doc strings.
	* tex-fold.el (): Fix typo.

2017-09-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make preview-latex parsing robust to fix Bug#20773, Bug#27088

	* preview.el.in (TeX-inline-preview-internal): Set environment
	variable max_print_line to sufficiently large value of 1000 so that
	LaTeX process does not insert newline in lines necessary to identify
	Bounding Boxes.

2017-09-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add test abount truncation of list

	* tests/tex/path-expansion.el: New file to test whether
	`TeX-search-files-by-type' does not truncate the value of list
	variable.

2017-09-18  Ikumi Keita  <ikumi@ikumi.que.jp>

	Prevent possible truncation of list value

	* tex.el (TeX-search-files-by-type): Use
	`TeX-delete-duplicate-strings' instead of `delete-dups'.

2017-09-16  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add a new option for evince compatible viewer.

	* tex.el: (TeX-view-evince-keep-focus): New option.
	(TeX-evince-sync-view-1): Pull the focus back to Emacs if the above
	new option is non-nil.

2017-09-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make correct extensions are returned

	* style/graphicx.el (LaTeX-includegraphics-extensions):
	Fix misaligned form structure which prevented `cond' to enter clauses
	for engines other than default.
	Use copied list for the last argument of `append' so that
	`delete-dups' does not alter the value of
	`LaTeX-includegraphics-extensions'.
	Use `delete' rather than `remove' for copied sequence.
	():
	(LaTeX-includegraphics-read-file-relative):
	Fix typos.

2017-09-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add test for infinite loop

	* tests/tex/utility.el: New file.

2017-09-10  Ikumi Keita  <ikumi@ikumi.que.jp>

	Parse package/class option with comments correctly

	* latex.el: (LaTeX-auto-class-regexp-list): Replace the regexp for
	RequirePackage/LoadClass option with the same one for usepackage.
	* tests/latex/latex-test.el: Add test for the change above.

2017-09-02  Ikumi Keita  <ikumi@ikumi.que.jp>

	Conform to elisp coding convention

	* style/biblatex.el (LaTeX-arg-addbibresource)
	(LaTeX-biblatex-package-options):
	* style/fontspec.el (LaTeX-fontspec-arg-font):
	Add "done" message.
	* style/relsize.el ("relsize"): Tailor prompt string.
	* style/bidi.el: Remove spurious execution bit.

2017-08-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Prevent possible infinite loop

	* tex.el (TeX-delete-duplicate-strings): Make sure that comparison is
	done with valid list elements.
	(TeX-delete-dups-by-car): Ditto.
	Use `TeX-sort-strings' and `TeX-car-string-lessp'.
	(TeX-car-string-lessp): Move the position of defun before the
	defcustom of `TeX-engine'.  Since the defcustom requires
	`TeX-delete-dups-by-car' at load time, all the functions used in
	`TeX-delete-dups-by-car' must be defined before the defcustom.

2017-08-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use `delete' correctly for list variable

	* tex.el (TeX-search-files-kpathsea): Make sure that "." will be
	removed from the directory list even if "." is the first element of
	the list, when the SCOPE argument is `global'.

2017-08-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add test for my commit on Aug 18

	* tests/japanese/parse-timing-test.tex:
	* tests/japanese/parse-timing.el:
	New file.

2017-08-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix doc string and indent

	* tex.el (TeX-PDF-from-DVI, TeX-insert-braces-alist)
	(TeX-arg-literal, TeX-auto-add-type):
	Fix doc string.
	(TeX-auto-parse-region): Fix indent.

2017-08-25  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add %(PDF) when undumped format is used in preview-latex

	* preview.el.in (TeX-inline-preview-internal): Make pdflatex to be
	called when default output is PDF and dumped format is used.  Although
	it seems that if the dumped format is created by pdflatex, the format
	produces PDF output even when the command name is (non-pdf) latex, it
	would be better that pdflatex is used in that case, too.

2017-08-20  Arash Esbati  <arash@gnu.org>

	Add new style/arabxetex.el

	* Makefile.in (STYLESRC): Add new style.

	* style/arabxetex.el: New file.

2017-08-18  Vincent Belaïche  <vincent.b.1@hotmail.fr>

	Improvements for tex-info.el

	* tex-info.el (Texinfo-arg-nodename): Fix default prompt.
	(Texinfo-arg-lrc): New function, used for commands that take Left,
	Center, and Right entries for setting page header.
	(Texinfo-arg-next-line): New function. Used to break line if need
	be after entering command argument.
	(Texinfo-arg-on|off): New function for entering boolean input.
	(TeX-texinfo-mode): Add TeX symbols `allowcodebreak', `atchar',
	`codequotebacktick', `codequoteundirected', `documentlanguage',
	`documentencoding', `evenfooting', `evenheading', `everyfooting',
	`everyheading', `LaTeX', `oddfooting', `oddheading',
	`setchapternewpage', and `url'.

2017-08-18  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use #' to quote function names

	* tex-jp.el (japanese-plain-tex-mode-initialization,
	add-hook, japanese-latex-mode-initialization,
	japanese-TeX-reset-mode-name, TeX-insert-punctuation):
	Use #' to quote function names.

2017-08-18  Ikumi Keita  <ikumi@ikumi.que.jp>

	Delay setting Japanese TeX engine in `japanese-latex-mode'

	* tex-jp.el (japanese-latex-mode-initialization): The part which
	guesses and sets `TeX-engine' using `TeX-match-style' is factored out
	and put in `TeX-update-style-hook'.  `TeX-match-style' eventually
	triggers `TeX-update-style', which isn't appropriate in
	`LaTeX-mode-hook'.
	(japanese-LaTeX-guess-engine): New function.

2017-08-11  Arash Esbati  <arash@gnu.org>

	* style/XCharter.el ("XCharter"): Update to package v1.094 from 2017/08/08.

2017-08-09  Arash Esbati  <arash@gnu.org>

	* style/amsthm.el ("amsthm"): Use `LaTeX-amsthm-env-label'.

2017-07-31  Ikumi Keita  <ikumi@ikumi.que.jp>

	Conform to elisp coding convention in context.el

	* context.el (ConTeXt-numbered-section-heading,
	ConTeXt-unnumbered-section-heading, ConTeXt-environment): Tailor
	prompt string.
	(ConTeXt-menu-update): Add "done" messages.

2017-07-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* font-latex.el: Use the standard utf-8 rather than latin-1

2017-07-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	Fix unescaped character literals

	* font-latex.el (font-latex-command-with-args-opt-arg-delims)
	* tex-fold.el (TeX-fold-expand-spec): Escape [ and ] character literals

2017-07-25  Tassilo Horn  <tsdh@gnu.org>

	Manually cherry-pick commit bc0db60e

2017-07-24  Mosè Giordano  <mose@gnu.org>

	* Version 11.91 released.

2017-07-24  Mosè Giordano  <mose@gnu.org>

	Prepare for upcoming release

2017-07-22  Arash Esbati  <arash@gnu.org>

	Update key=val options to minted package v2.5

	* style/minted.el (LaTeX-minted-key-val-options): Update options
	to package version v2.5 from 2017/07/19.

2017-07-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Conform to elisp coding conventions.

	* latex.el (LaTeX-section-heading, LaTeX-environment)
	(TeX-arg-document, LaTeX-arg-usepackage-read-packages-with-options)
	(TeX-arg-bibstyle, TeX-arg-bibliography, TeX-arg-verb)
	(LaTeX-fill-region): Taylor minibuffer prompt string. Add or taylor
	"done" messages.
	* tex-buf.el (TeX-command-query, TeX-printer-query): Ditto.
	* tex.el (TeX-master-file-ask, TeX-master-file, TeX-update-style)
	(TeX-auto-list-information, TeX-auto-generate): Ditto.

2017-07-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	* doc/changes.texi: Mention changes related to Japanese TeX.

2017-07-03  Arash Esbati  <arash@gnu.org>

	* doc/auctex.texi (European): Add babel languages which load english.el.

2017-07-03  Arash Esbati  <arash@gnu.org>

	Check and set `TeX-quote-language' if necessary

	* style/english.el ("english"): Reset `TeX-quote-language' to nil
	if changed by other babel language options.

2017-07-03  Arash Esbati  <arash@gnu.org>

	Add new style/australian.el and style/newzealand.el

	* Makefile.in (STYLESRC): Add new styles.

	* style/australian.el:
	* style/newzealand.el: New files.

2017-07-02  Arash Esbati  <arash@gnu.org>

	Add new style/canadian.el

	* Makefile.in (STYLESRC): Add new style.

	* style/canadian.el: New file.

2017-07-01  Arash Esbati  <arash@gnu.org>

	Add new style/moodle.el

	* Makefile.in (STYLESRC): Add new style.

	* style/moodle.el: New file.

2017-07-01  Arash Esbati  <arash@gnu.org>

	* latex.el (LaTeX-babel-hyphen-language-alist): Fix typo in docstring.

2017-06-17  Antoine Levitt  <antoine.levitt@gmail.com>

	Add support for xreader viewer

	* tex.el (TeX-evince-dbus-p):
	(TeX-evince-sync-view-1):
	(TeX-view-program-select-evince):
	(TeX-raise-frame-function):
	(TeX-source-correlate-mode): Adapt functions and docstrings to xreader.
	(TeX-xreader-sync-view): New function.
	(TeX-view-program-list-builtin): Add xreader.

2017-06-14  Arash Esbati  <arash@gnu.org>

	Update key=value options to graphicx package version 1.1a

	* style/graphicx.el (LaTeX-graphicx-key-val-options): Add new
	key=value options.
	(LaTeX-arg-graphicx-includegraphics-key-val): Support "pagebox"
	key with pdfTeX or LuaTeX.

2017-06-13  Arash Esbati  <arash@gnu.org>

	* style/beamer.el ("beamer"): Query for optional argument after \pause.

2017-06-13  Mosè Giordano  <mose@gnu.org>

	Suggest to rerun LaTeX if xsim properties changed

	* tex-buf.el (TeX-LaTeX-sentinel): Catch xsim warning suggesting to rerun LaTeX
	and set LaTeX and next default command.

2017-06-13  Mosè Giordano  <mose@gnu.org>

	Catch expl3 warnings

	* tex-buf.el (LaTeX-warnings-regexp): Adapt regexp to the style of expl3
	warnings.
	* tests/tex/error-parsing.el (TeX-error-parsing-expl3-warnings): New test for
	expl3 warnings.

2017-06-02  Ikumi Keita  <ikumi@ikumi.que.jp>

	Correct actions on region file in included file not placed in master dir

	* tex-buf.el (TeX-command-region): Call `TeX-region-file' with nil
	`nondirectory' argument.
	Fix a typo in doc string.
	(TeX-command-default): Use `(TeX-region-file)' instead of `TeX-region'
	for comparison with the given argument.

2017-05-30  Ikumi Keita  <ikumi@ikumi.que.jp>

	Imporve fix for Bug#26694

	* tex-buf.el (TeX-command): Update point in region file if the
	command is "View".
	(TeX-view):
	(TeX-region-create): Pass the above job to `TeX-command'.
	(TeX-region-update-point): Move point according to the column in
	the original buffer.
	Do nothing when `TeX-source-correlate-mode' is disabled.
	Use `TeX-current-offset' instead of `TeX-line-number-at-pos' in
	case narrowing is in effect in the original buffer.
	* preview.el.in (preview-at-point): Revert previous commit in
	accord with the changes above.
	* tex.el (TeX-evince-sync-view-1): Use `TeX-current-offset'
	instead of `TeX-line-number-at-pos' in case narrowing is in
	effect in the original buffer.
	Add FIXME comment about using `current-column'.
	(TeX-synctex-output-page-1): Ditto.
	Arrange regexp to pick up page number more correctly.
	(TeX-view-program-list-builtin): Remove spurious quotation around
	%b in SumatraPDF entry.

2017-05-29  Mosè Giordano  <mose@gnu.org>

	* tests/tex/compilation-log.txt:
	* tests/tex/error-parsing.el: Add test for error starting with exclamation mark.

2017-05-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Resolve preview-latex incompatibility with Japanese TeX (Bug#25322)

	* preview.el.in (preview-error-quote): Work consistently with
	decoded text.  The idea of "encoding entire string beforehand and
	decoding it at the last stage" was used previously, but that failed
	with `japanese-shift-jis' coding system containing bytes which
	happen to coincide with regexp meta characters.
	(preview--decode-^^ab):
	(preview--convert-^^ab): New functions.
	(TeX-inline-preview-internal): Record the process coding system
	for decode assigned already so that `preview-error-quote' can
	decode the given text correctly afterward.  To achive that, change
	the role of `preview-coding-system' together with the changes to
	`preview-error-quote'.
	Give back the command options provided in `(TeX-engine-alist)' to
	latex command when preamble caching is enabled.
	(preview-coding-system): Modify doc string according to the
	changes above to `preview-error-quote' and
	`TeX-inline-preview-internal'.
	* tex-buf.el (TeX-adjust-process-coding-system): New function.
	Adjust the process coding system for asynchronous process launched
	within AUCTeX.
	(TeX-after-start-process-function): Change default value to
	`TeX-adjust-process-coding-system'.
	* tex-jp.el (japanese-TeX-set-process-coding-system): Specify end
	of line format on the coding systems assigned to process.
	(): Don't set `japanese-TeX-set-process-coding-system' to
	`TeX-after-start-process-function'.  It is now called within
	`TeX-adjust-process-coding-system'.
	* prv-xemacs.el (preview-buffer-recoding-alist): Fix docstring.
	(coding-system-change-eol-conversion): Add advice because XEmacs
	21.4 mule-ucs fails to define `utf-8' coding system to respond
	properly to this function.
	(preview-ps-quote-filename): Add advice so that this function is
	not confused by backslashes as path separator in the return value
	of XEmacs function.
	* tests/japanese/preview-latex.el:
	* tests/japanese/preview-error-test.tex:
	* tests/japanese/preview-error-test2.tex:
	* tests/japanese/prv-dif-code.tex: New files for regression test.

2017-05-21  Mosè Giordano  <mose@gnu.org>

	Fix indentation in ConTeXt mode after indented optional argument

	* context.el (ConTeXt-find-indent): Fix indentation.  Requested by Henri Menke.
	* tests/context/context-test.el:
	* tests/context/context-indentation-in.tex:
	* tests/context/context-indentation-out.tex: New test files.

2017-05-17  Ikumi Keita  <ikumi@ikumi.que.jp>

	Don't discard process output with `TeX-run-silent'

	* tex-buf.el (TeX-run-silent): Associate the process to the buffer
	"*TeX silent*".

2017-05-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	* tex.el (TeX-command-list): Fix typo in help string (mendex -> upmendex)

2017-05-12  Arash Esbati  <arash@gnu.org>

	* latex.el (LaTeX-env-label-as-keyval): Use `buffer-substring-no-properties'.

2017-05-11  Arash Esbati  <arash@gnu.org>

	* doc/changes.texi: Document recent changes.

2017-05-10  Arash Esbati  <arash@gnu.org>

	* tests/latex/fontification-general.tex: New file.

2017-05-10  Arash Esbati  <arash@gnu.org>

	Exclude arguments to math environments from fontification

	* font-latex.el (font-latex-match-math-envII)
	(font-latex-extend-region-backwards-math-envII): Match and exclude
	optional and mandatory argument(s) to math environments from
	fontification.

2017-05-08  Arash Esbati  <arash@gnu.org>

	Improve further the exclusion of reserved characters

	* font-latex.el (font-latex-match-simple-exclude-list): New
	variable.
	(font-latex-match-simple-command): Use
	`font-latex-match-simple-exclude-list'.  Add check for docTeX mode
	in order to remove "_" from the list.

2017-05-06  Mosè Giordano  <mose@gnu.org>

	Work around bug#26694

	* preview.el.in (preview-at-point): Let-bind `TeX-source-correlate-mode' to nil.
	* tex-buf.el (TeX-region-create): Move point only when
	`TeX-source-correlate-mode' is non-nil.

2017-05-06  Arash Esbati  <arash@gnu.org>

	* latex/preview.dtx: Adjust contact email address.

2017-05-04  Arash Esbati  <arash@gnu.org>

	* tex-ispell.el: Move entries from style/empheq.el to this file.

	* latex/preview.dtx: Adjust modification date for CTAN.

2017-05-03  Arash Esbati  <arash@gnu.org>

	Query for expl3 package options

	* style/expl3.el (LaTeX-expl3-package-options): New function to
	read package options from user.
	Add missing file footer.

2017-05-03  Arash Esbati  <arash@gnu.org>

	Add new style/floatrow.el

	* Makefile.in (STYLESRC): Add new style.

	* style/floatrow.el: New file.

2017-05-02  Arash Esbati  <arash@gnu.org>

	Use `ispell-tex-arg-end' on parsed elements

	* style/mdframed.el (LaTeX-mdframed-auto-cleanup, "mdframed"): Use
	correct function `ispell-tex-arg-end'.

2017-04-27  Arash Esbati  <arash@gnu.org>

	Improve exclusion of reserved characters from command matches

	* font-latex.el (font-latex-match-simple-command): Skip matches
	starting with reserved characters.

2017-04-27  Arash Esbati  <arash@gnu.org>

	Add support for plus sign in macro syntax specification list

	* font-latex.el (font-latex-match-command-with-arguments): Support
	plus sign besides asterisk in specification of macro syntax.

2017-04-27  Arash Esbati  <arash@gnu.org>

	Update style/fontspec.el to package version 2.6a

	* style/fontspec.el (LaTeX-fontspec-font-features): Update
	variable to package version 2.6a.
	(LaTeX-fontspec-auto-cleanup): New function for parsing support
	for \newfontfamily and \newfontface macros.
	("fontspec"): Add missing macros and environment.
	(LaTeX-fontspec-package-options): Update with new options.

2017-04-27  Arash Esbati  <arash@gnu.org>

	Consider the return value of `assq-delete-all'

	* style/breqn.el (LaTeX-breqn-update-color-keys):
	* style/fvextra.el (LaTeX-fvextra-update-key-val):
	* style/mdframed.el (LaTeX-mdframed-update-style-key):
	* style/minted.el (LaTeX-minted-update-key-vals):
	* style/tcolorbox.el (LaTeX-tcolorbox-update-style-key): Use the
	return value of `assq-delete-all' rather than looking at the saved
	value of the temporary variable.

2017-04-27  Arash Esbati  <arash@gnu.org>

	* latex.el (LaTeX-common-initialization): Add eminnershape macro.

2017-04-26  Arash Esbati  <arash@gnu.org>

	* tex-ispell.el (TeX-ispell-skip-cmds-list): Add \addlinespace.

2017-04-25  Tassilo Horn  <tsdh@gnu.org>

	Correctly exclude hypenation and thin spaces from command matches

	* font-latex.el (font-latex-match-simple-command): Skip matches starting with
	\- or \,.

2017-04-25  Arash Esbati  <arash@gnu.org>

	Add LaTeX core command \oldstylenums

	* font-latex.el (font-latex-built-in-keyword-classes): Add
	\oldstylenums to "type-command" keyword class.

	* latex.el (LaTeX-common-initialization): Add \oldstylenums to
	LaTeX core commands.

	* style/textcomp.el ("textcomp"): Remove \oldstylenums from
	textcomp.el which is provided by LaTeX core.

2017-04-24  Arash Esbati  <arash@gnu.org>

	Make preview.sty compatible with recent luatex

	* latex/preview.dtx: Check if file luatex85.sty is loadable and
	require the package (bug#25601).

2017-04-24  Arash Esbati  <arash@gnu.org>

	Do not highlight control spaces with "\ "

	* font-latex.el (font-latex-match-simple-command): Add space to
	the list of characters to be ignored.

2017-04-23  Arash Esbati  <arash@gnu.org>

	Adjust macros acc. to change in `LaTeX-paragraph-commands-regexp-make'

	* style/bicaption.el ("bicaption"): Add \bicaption, \bicaptionbox,
	\bisubcaption and \bisubcaptionbox to paragraph commands.

	* style/caption.el ("caption"): Add \captionbox and \captionof to
	paragraph commands.

	* style/subcaption.el ("subcaption"): Add \subcaption and
	\subcaptionbox to paragraph commands.

2017-04-23  Arash Esbati  <arash@gnu.org>

	* style/exam.el ("exam"): Remove duplicate entries and backslash.

2017-04-23  Uwe Brauer  <oub@mat.ucm.es>

	Add the select environment and related macros to exam style.

	* style/exam.el ("exam"): Add the select environment and related macros.

2017-04-23  Tassilo Horn  <tsdh@gnu.org>

	Fix comment environment highlighting

	* style/comment.el ("comment"): Don't set comment starter/ender but generic
	comment delimiters.

2017-04-21  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add test for my last commit

	* tests/japanese/error-parsing.el: New file.

2017-04-21  Mosè Giordano  <mose@gnu.org>

	Do not highlight thin spaces with \,

	* font-latex.el (font-latex-match-simple-command): Add comma to the list of
	characters to be ignored.

2017-04-19  Mosè Giordano  <mose@gnu.org>

	Fix parsing of LaTeX2e date formats

	* tex-buf.el (TeX-LaTeX-sentinel): Support ISO date format, now used by
	LaTeX2e.  Reported by Uwe Siart.
	* tests/tex/error-parsing.el (TeX-LaTeX2e-date): Add a test for LaTeX2e date
	formats.

2017-04-19  Ikumi Keita  <ikumi@ikumi.que.jp>

	Improve error handling for Japanese users

	* tex-buf.el (TeX-help-error): Use number based condition to
	detect whether the search over `TeX-error-description-list'
	comes to its last element.  Comparison with a literal string
	breaks when tex-jp.el installs Japanese help messages into
	`TeX-error-description-list'.

2017-04-18  Ikumi Keita  <ikumi@ikumi.que.jp>

	Deal with strange file name

	* tex-jp.el (): Increase `pos' in case the master file
	name happens to contain special %-sequence.

2017-04-17  Ikumi Keita  <ikumi@ikumi.que.jp>

	Support upmendex

	* tex-jp.el (): Make "%(makeindex)" to expand to upmendex when
	upmendex is available and `TeX-engine' is supported by it.
	Add "%(dic)" expander for the dictionary option of (up)mendex.
	* tex.el (TeX-command-list): Add "upMendex" entry.  Set 4th
	element to t so that user will get a chance to supply
	dictionary option to the command line string.

2017-04-17  Tassilo Horn  <tsdh@gnu.org>

	Improve command highlighting to not be triggered by hyphenation

	Reported by François Patte.

2017-04-17  Tassilo Horn  <tsdh@gnu.org>

	Add proper copyright header to some styles

	Add the required headers so that the ELPA build works again.

2017-04-15  Arash Esbati  <arash@gnu.org>

	* doc/changes.texi: Update with recent changes.

2017-04-10  Arash Esbati  <arash@gnu.org>

	* doc/auctex.texi (Selecting a Command): Document `TeX-ispell-verb-delimiters'.

2017-04-04  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix `paragraph-start' and `paragraph-separate'

	* plain-tex.el (plain-TeX-common-initialization): Remove "^" from
	`paragraph-start' according to the doc string.
	Remove LaTeX display math delimiters "\[" and "\]" from
	`paragraph-start'.
	Add "item" and "itemitem" to `paragraph-start'.
	Change the regexp grouping to shy group in `paragraph-start' and
	`paragraph-separate'.
	* tex-info.el (TeX-texinfo-mode): Remove "^" from `paragraph-start'
	and `paragraph-separate'.

2017-04-03  Arash Esbati  <arash@gnu.org>

	Update package options in style/amsmath.el

	* style/amsmath.el (LaTeX-amsmath-package-options): Update package
	options to v2.16a.

2017-04-01  Arash Esbati  <arash@gnu.org>

	Append \b to regexp built from TeX control words

	* latex.el (LaTeX-paragraph-commands-regexp-make): Append \b to
	regexp built from TeX control words.  Fix this report
	http://lists.gnu.org/archive/html/auctex/2017-03/msg00009.html

	* tests/latex/latex-filling-in.tex:
	* tests/latex/latex-filling-out.tex:
	* tests/latex/latex-test.el (LaTeX-filling): Extend test for addition
	in `LaTeX-paragraph-commands-regexp-make' in latex.el.

2017-03-31  Mosè Giordano  <mose@gnu.org>

	Fix detection of bibliography files with dots in path

	* latex.el (LaTeX-auto-regexp-list): Remove dot from the list of excluded
	characters in addbibresource's regexp.
	* tests/latex/latex-test.el (LaTeX-addbibresource): New test for addbibresource.

2017-03-29  Ikumi Keita  <ikumi@ikumi.que.jp>

	Don't alter standard value or saved value themselves of customize option

	* tex-jp.el (): Stop using `setcar' on the elements of
	`TeX-command-list'.  This used to alter the standard value
	or saved value themselves of the customize option since
	`setcar' operates descructively on lists as Lisp objects.
	Instead create new list by `mapcar' and `append'.
	(): Deal with the case that `TeX-view-program-list-builtin'
	doesn't have an entry of "xdvi".
	Change the expected executable name to "%(xdvi)" as well.

2017-03-28  Arash Esbati  <arash@gnu.org>

	Fix last improvement for skipping of inline verbatim macros

	* tex.el (TeX-ispell-tex-arg-verb-end): New function.

	* tex-ispell.el (TeX-ispell-verb-delimiters): Replace
	`TeX-ispell-verb-opening-delimiters' and
	`TeX-ispell-verb-closing-delimiters' with new customizable option
	`TeX-ispell-verb-delimiters'.
	(TeX-ispell-skip-setcar): Use new function
	`TeX-ispell-tex-arg-verb-end' with verbatim macros.

2017-03-27  Arash Esbati  <arash@gnu.org>

	Improve skipping of inline verbatim macros

	* tex-ispell.el (TeX-ispell-verb-opening-delimiters)
	(TeX-ispell-verb-closing-delimiters): New customizable options.
	(TeX-ispell-skip-setcar): Skip inline verbatim macros from
	listings and fancyvrb package.  Use new variables for minted
	package.

2017-03-27  Arash Esbati  <arash@gnu.org>

	* tests/latex/fontification-verb-macros.tex: New file.

2017-03-27  Arash Esbati  <arash@gnu.org>

	Improve fontification of verbatim macros in style/minted.el

	* style/minted.el (LaTeX-minted-auto-cleanup): Add key=val query
	and fontification support for parsed elements.
	(LaTeX-minted-add-syntactic-keywords-extra): New function.
	("minted"): Use `LaTeX-minted-add-syntactic-keywords-extra' to add
	fontification support for \mint and \mintinline macros.
	Add \mint and \mintinline to textual keywords class and apply the
	fontification only for optional and first mandatory argument.

2017-03-27  Arash Esbati  <arash@gnu.org>

	Adapt fontification for \lstinline

	* style/listings.el ("listings"): Fontify only the optional
	argument of \lstinline.

2017-03-27  Arash Esbati  <arash@gnu.org>

	Recognize optional argument in verb macros with delimiters/braces

	* font-latex.el (font-latex-built-in-keyword-classes): Add \verb
	to textual keyword class.
	(font-latex-set-syntactic-keywords): Extend regexp to ignore an
	optional argument for verbatim macros with delimiters and/or
	braces.

2017-03-26  Ikumi Keita  <ikumi@ikumi.que.jp>

	Add support for Japanese font command

	* tex-jp.el (): Append entries for mincho and gothic font
	commands to `LaTeX-font-list'.
	(japanese-latex-mode-initialization): Add font lock support
	to \textgt, \mathgt and \gtfamily commands for displaying
	with bold font in Emacs buffer.
	* doc/auctex.texi (Japanese): Mention new font commands and
	add indexes for them.

2017-03-23  Ikumi Keita  <ikumi@ikumi.que.jp>

	Enhance Japanese class files support

	* style/tarticle.el:
	* style/tbooks.el:
	* style/treport.el:
	* style/jsreport.el: Add new style files.
	* Makefile.in (STYLESRC): Add them and tweak order not to break the
	format of file name alignment.
	* style/j-book.el ("j-book"): Correct the largest section level to
	"part" following book.el.
	* style/jarticle.el:
	* style/jbook.el:
	* style/jreport.el:
	* style/jsarticle.el:
	* style/jsbook.el: Add defvar for class options, counters and
	pagestyles following {article,book,report}.el.
	Correct the largest section level in jbook.el, too.
	Deal with "report" option in jsbook.el.

2017-03-24  Arash Esbati  <arash@gnu.org>

	* texmathp.el (texmathp-tex-commands-default): Add entries for empheq.sty.

2017-03-23  Arash Esbati  <arash@gnu.org>

	* style/minted.el ("minted"): Add key=val query for \mint and \mintinline.

2017-03-19  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use `TeX-line-number-at-pos' further for older emacsen

	* tex-buf.el (TeX-region-create):
	(TeX-region-update-point):
	* tex-info.el (Texinfo-make-node-list): Replace `line-number-at-pos'
	with `TeX-line-number-at-pos'.

2017-03-19  Ikumi Keita  <ikumi@ikumi.que.jp>

	Use compatibility function `TeX-line-number-at-pos' for older emacsen

	* tex.el (TeX-evince-sync-view-1):
	(TeX-synctex-output-page-1): Replace `line-number-at-pos' with
	`TeX-line-number-at-pos'.

2017-03-18  Arash Esbati  <arash@gnu.org>

	Use the variable `LaTeX-listing-label'

	* style/minted.el ("minted"):
	* style/newfloat.el (LaTeX-newfloat-auto-cleanup): Use
	`LaTeX-listing-label' instead of hard-coded "lst:" string.

2017-03-18  Arash Esbati  <arash@gnu.org>

	Use compat function `TeX-replace-regexp-in-string' in core files

	* tex.el (TeX-source-correlate-sync-source):
	* latex.el (LaTeX-split-bibs): Use compat function
	`TeX-replace-regexp-in-string'.

2017-03-18  Arash Esbati  <arash@gnu.org>

	Use `TeX-replace-regexp-in-string' in style files

	* style/empheq.el (LaTeX-empheq-item-equation):
	* style/tcolorbox.el (LaTeX-tcolorbox-load-used-libraries):
	* style/xcolor.el (LaTeX-xcolor-auto-cleanup): Use compat function
	`TeX-replace-regexp-in-string'.

2017-03-18  Arash Esbati  <arash@gnu.org>

	Add new compat function `TeX-replace-regexp-in-string'

	* tex.el (TeX-replace-regexp-in-string): New compat function.
	With XEmacs, pass arguments to `replace-in-string', with Emacs to
	`replace-regexp-in-string'.  This function supports only mandatory
	arguments of the original functions just mentioned.

2017-03-17  Ikumi Keita  <ikumi@ikumi.que.jp>

	Avoid altering user option as much as possible

	* tex-jp.el (): Alter `TeX-view-predicate-list-builtin' and
	`TeX-view-program-list-builtin' instead of their customize option
	cousins.
	Append to `TeX-view-program-selection' only on w32 system.

2017-03-16  Arash Esbati  <arash@gnu.org>

	Add LaTeX inline math delimiters to Ispell skip list

	* tex-ispell.el: Add LaTeX inline math delimiters \( \) to Ispell
	skip list.  (bug#26125)
	Remove unnecessary part from regexp for \cmidrule.

2017-03-15  Arash Esbati  <arash@gnu.org>

	Fix addition of key=val's

	* style/fvextra.el (LaTeX-fvextra-update-key-val): Fix addition of
	key=val's to `LaTeX-fancyvrb-key-val-options-local'.

2017-03-15  Ikumi Keita  <ikumi@ikumi.que.jp>

	Modify `TeX-expand-list-builtin' instead of `TeX-expand-list'

	* tex-jp.el (): `TeX-expand-list' is user option since 2015.  Add
	extra entries for Japanese TeX engines to `TeX-expand-list-builtin'
	instead.

2017-03-13  Arash Esbati  <arash@gnu.org>

	Add new style/fvextra.el

	* Makefile.in (STYLESRC): Add new style.

	* style/fvextra.el: New file.

2017-03-13  Arash Esbati  <arash@gnu.org>

	Improve parsing capabilities of style/fancyvrb.el

	* style/fancyvrb.el (LaTeX-fancyvrb-key-val-options): Add
	undocumented keys, update some values.
	(LaTeX-fancyvrb-key-val-options-local)
	(LaTeX-fancyvrb-base-macros, LaTeX-fancyvrb-base-environments)
	(LaTeX-fancyvrb-key-val-skip-regexp): New variables.
	(LaTeX-fancyvrb-macro-regexp, LaTeX-fancyvrb-environment-regexp):
	Update for new parsing mechanism.
	(LaTeX-fancyvrb-arg-define-macro)
	(LaTeX-fancyvrb-arg-define-environment)
	(LaTeX-fancyvrb-arg-file-relative): New functions.
	("fancyvrb"): Use new variables and functions in the hook.  Update
	fontification.

2017-03-10  Arash Esbati  <arash@gnu.org>

	Improve fallback for indentation when & is omitted

	* latex.el (LaTeX-hanging-ampersand-position): Improve handling of
	fallback which now respects also intended tabular environments.
	Thanks to Ikumi Keita for testing and providing code.  (bug#26032)

	* tests/latex/tabular-in.tex:
	* tests/latex/tabular-out.tex: Add additional test for indented
	tabular.

2017-03-09  Ikumi Keita  <ikumi@ikumi.que.jp>

	Remove spurious entries of view settings.

	* tex-jp.el (TeX-view-program-list):
	(TeX-view-program-selection): Remove spurious entries, most of which
	are related with other TeX IDEs.
	cf. http://lists.gnu.org/archive/html/auctex-devel/2016-04/msg00036.html

2017-03-09  Arash Esbati  <arash@gnu.org>

	Add fallback for indentation when & is omitted

	* latex.el (LaTeX-hanging-ampersand-position): Add fallback for
	indentation if the row searched does not contain a column
	separator &.

	* tests/latex/tabular-in.tex:
	* tests/latex/tabular-out.tex: Add filling test for missing & in
	row.

2017-02-06  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix auto selection of japanese TeX engine

	* tex-jp.el (japanese-latex-mode-initialization): Use
	`LaTeX-match-class-option' to detect uplatex option given to
	jsarticle, jsreport and jsbook class.  (The root of this problem is
	the same as Bug#25563)
	(): Quit appending to `LaTeX-command-style' because this made the
	user's intentional selection of `TeX-engine' ineffective with regard
	to the selection of the executable names.
	Fix copyright year.
	* doc/auctex.texi (Japanese): Add description of Japanese TeX engine:
	How to use, change and set the value of the engine.
	Add description of the customize options related to the encoding of
	Japanese TeX documents.

2017-03-08  Arash Esbati  <arash@gnu.org>

	Detect \& in tabular cells when filling

	* latex.el (LaTeX-indent-tabular): Search backward for any
	ampersands not escaped with a backslash, i.e. control symbol \&,
	and return the adjusted value.  Thanks to Ikumi Keita for his
	perceptive comments on the implementation.  (bug#26010)

	* tests/latex/tabular-in.tex:
	* tests/latex/tabular-out.tex: Add test for table filling with \&
	in cells.

2017-03-06  Arash Esbati  <arash@gnu.org>

	* tex-ispell.el (TeX-ispell-skip-cmds-list): Add hyperref macros.

2017-03-05  Arash Esbati  <arash@gnu.org>

	* tex-ispell.el (TeX-ispell-skip-setcdr): Add entry for filecontents package.

2017-03-04  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix documents and add trivial improvements.

	* font-latex.el (font-latex-deactivated-keyword-classes): Add keyword
	class biblatexnoarg, biblatex and slide-title to doc string.
	Use `buffer-string'.
	(font-latex-keyword-matcher): Mention that face attributes is accepted
	as FACE argument in doc string.
	(font-latex-make-built-in-keywords): Arrange doc string for generated
	defvar of `font-latex-match-*-keywords-local' depending on the keyword
	type.
	Remove spurious type declaration from generated defcustom of
	`font-latex-match-*-keywords'.
	Replace meaningless argument with nil and add doc string for generated
	defvar of `font-latex-match-*'.
	Replace redundant call to intern with literal quote of symbol.
	(font-latex-user-keyword-classes): Fix doc string.  The accepted face
	argument is face attribute rather than font specification.
	Add doc string for generated defvar of `font-latex-match-*'.
	(font-latex-make-user-keywords): Replace backquote with quote where
	backquote is not necessary.
	(font-latex-add-keywords): Add keyword class biblatexnoarg to doc
	string.
	* doc/auctex.texi (): Update copyright year.
	(Deactivating defaults of built-in keyword classes): Add keyword
	class biblatexnoarg, biblatex and slide-title.
	Fix sample lisp code.
	(User-defined keyword classes): The accepted face argument is face
	attribute rather than font specification.

2017-03-04  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make customization to face specification to appear in
	customization buffer.

	* font-latex.el (font-latex-user-keyword-classes): Exchange the order
	of `face' and `custom-face-edit'.  Tweak doc string.

2017-03-04  Ikumi Keita  <ikumi@ikumi.que.jp>

	Unify treatment of face argument over the relevant functions.

	* font-latex.el (font-latex-keyword-matcher): Conform the face
	argument correctly to the format `font-lock-keywords' requires.
	(font-latex-make-user-keywords) : Call `font-latex-make-match-defun'
	directly without `eval'.
	(font-latex-deactivated-keyword-classes) : Accept a face symbol, as
	well as a form returning a face symbol, for the third element for each
	item of `font-latex-built-in-keyword-classes'.
	(font-latex-built-in-keyword-classes) : Remove quoting from the face
	names.  Contrary to the sentence of the doc string
	"The third element is the symbol of a face to be used or a Lisp
	form returning a face symbol.", symbol of a face was invalid due to
	the above bugs.

2017-03-04  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix font-latex-make-match-defun to generate intended code.

	* font-latex.el (font-latex-make-match-defun): Arrange the order of
	evaluation not to generate meaningless clause.  Byte compile warning
	on xemacs went away.

2017-03-04  Mosè Giordano  <mose@gnu.org>

	Partially revert previous commit, will look better later

	* tex-buf.el (TeX-command-expand): Do not error if `string' is nil.  This made
	"View" command unusable.

2017-03-04  Mosè Giordano  <mose@gnu.org>

	Prevent infinite loop in TeX-command-expand

	* tex-buf.el (TeX-command-expand): Throw an error if `string' is not a string.
	This prevents an infinite loop.
	* tex.el (TeX-engine-in-engine-alist): New function to pick up an engine from
	`TeX-engine-alist' and throw an error if the engine is not there.
	(TeX-expand-list-builtin): Use `TeX-engine-in-engine-alist'.
	* context.el (ConTeXt-expand-options): Use `TeX-engine-in-engine-alist'.
	* tests/tex/command-expansion.el (TeX-command-expansion-errors): Add tests for
	error handling of `TeX-command-expand'.

2017-02-24  Ikumi Keita  <ikumi@ikumi.que.jp>

	Tweak locale treatment on xemacs.

	* tex-jp.el (japanese-TeX-set-process-coding-system): Use the locale
	related environment variables for fallback value.

2017-02-21  Arash Esbati  <arash@gnu.org>

	Add new style/sourcecodepro.el

	* Makefile.in (STYLESRC): Add new style.

	* style/sourcecodepro.el: New file.

2017-02-21  Arash Esbati  <arash@gnu.org>

	* style/subfiles.el (LaTeX-subfiles-class-options): New function.

2017-02-04  Ikumi Keita  <ikumi@ikumi.que.jp>

	Make papersize predicate in tex-jp.el to work again.
	Problem parallel to bug#25563.

	* tex-jp.el (): Use `LaTeX-match-class-option' to examine paper size
	option of document class.

2017-02-14  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix setting of coding system for Japanese TeX

	* tex-jp.el (japanese-TeX-set-process-coding-system): Cater for the
	case that kanji option is requested by user but cannot be determined.
	XEmacs doesn't have `locale-coding-system'.  Use
	`get-coding-system-from-locale' and `current-locale' instead.
	Cleanup indentation.
	(japanese-TeX-coding-ejsu): Add entry for xemacs coding system of cp932.

2017-02-20  Mosè Giordano  <mose@gnu.org>

	Improve regexp for looking for documentclass macro

	* latex.el (LaTeX-env-document): Allow any non line-breaking character in regexp
	  used to look for `documentclass' macro.  Previous regexp did not catch class
	  options containing dots or slash, that may occur when using `subfiles' class.

2017-02-20  Mosè Giordano  <mose@gnu.org>

	Improve determination of master file with subfiles class

	* style/subfiles.el ("subfiles"): Do not strip dirname from master file.

2017-02-19  Arash Esbati  <arash@gnu.org>

	Add new keys for package version 4.00

	* style/tcolorbox.el (LaTeX-tcolorbox-keyval-options): Add new
	keys for v4.00 of the package.

2017-02-16  Arash Esbati  <arash@gnu.org>

	* latex.el (LaTeX-label): Eliminate premature returning of label.

2017-02-16  Arash Esbati  <arash@gnu.org>

	Append "lstlisting" to `LaTeX-label-alist'

	* style/listings.el ("listings"): Append "lstlisting" to
	`LaTeX-label-alist'.
	(LaTeX-listings-auto-cleanup): Use `LaTeX-listing-label' as a
	symbol during clean up.

2017-02-10  Arash Esbati  <arash@gnu.org>

	Add new style/preview.el

	* Makefile.in (STYLESRC): Add new style.

	* style/preview.el: New file.

2017-02-10  Arash Esbati  <arash@gnu.org>

	* .gitignore: Ignore only preview.el in top directory.

2017-02-10  Arash Esbati  <arash@gnu.org>

	Improve parsing process in style/xcolor.el

	* style/xcolor.el (LaTeX-xcolor-definecolor-regexp): Use
	`regexp-opt' to build a regexp to match all color defining macros.
	(LaTeX-xcolor-colorlet-regexp): Remove variable.
	(LaTeX-xcolor-auto-cleanup): Romove unnecessary *.

2017-02-09  Arash Esbati  <arash@gnu.org>

	Improve parsing process in style/color.el

	* style/color.el (LaTeX-color-definecolor-regexp): Remove
	unnecessary 2nd and 3rd arguments from regexp.
	(LaTeX-color-auto-cleanup): Delete unnecessary function and remove
	it from `TeX-auto-cleanup-hook'.

2017-02-09  Arash Esbati  <arash@gnu.org>

	Fix parsing bug in style/xcolor.el

	* style/xcolor.el (LaTeX-xcolor-definecolor-regexp): Move parsing
	of \colorlet macro into `LaTeX-xcolor-colorlet-regexp'.
	(LaTeX-xcolor-colorlet-regexp): New variable.
	("xcolor"): Activate `LaTeX-xcolor-colorlet-regexp' in style hook.

2017-02-06  Arash Esbati  <arash@gnu.org>

	* latex/preview.dtx: Fix example for \PreviewMacro* macro.
	Add missing backslash.

2017-02-04  Ikumi Keita  <ikumi@ikumi.que.jp>

	Fix minor problems
	* tex.el (TeX-view-predicate-list-builtin): Enclose whole alternatives
	in regexp with shy group in order that the effect of "\`" and "\'"
	covers all the alternatives.
	* latex.el (LaTeX-auto-cleanup): Regard "Class", in addition to
	"class", as an indicator of LaTeX2e document.

2017-02-02  Arash Esbati  <arash@gnu.org>

	Simplify addition of entirely skipped environments

	* tex-ispell.el (TeX-ispell-skip-envs-list): New variable for
	environments which should be skipped entirely.
	(TeX-ispell-skip-envs-regexp): New variable keeping the regexp
	generated from `TeX-ispell-skip-envs-list'.

2017-02-02  Tassilo Horn  <tsdh@gnu.org>

	Fix TeX-view-predicate-list-builtin predicates wrt class opts

	* latex.el (LaTeX-match-class-option): New function.
	* tex.el (TeX-view-predicate-list-builtin): Use above function to check
	paper sizes orientation from documentclass options (bug#25563).

2017-02-01  Mosè Giordano  <mose@gnu.org>

	Fix number of arguments of local-variable-p in XEmacs

	* font-latex.el (font-latex-after-hacking-local-variables): Second argument of
	`local-variable-p' is mandatory in XEmacs.

2017-02-01  Tassilo Horn  <tsdh@gnu.org>

	Fix font-latex-after-hacking-local-variables on XEmacs

	* font-latex.el (font-latex-after-hacking-local-variables): Cater for the
	fact that file-local-variables-alist isn't there in XEmacs and older
	Emacs versions (bug#25564).

2017-02-01  Arash Esbati  <arash@gnu.org>

	* tex-ispell.el: Add support for enviroments from breqn.sty.

2017-02-01  Tassilo Horn  <tsdh@gnu.org>

	Fix plain-TeX-auto-regexp-list docstring

	* tex.el: Fix docstring of plain-TeX-auto-regexp-list (bug#25574).

2017-01-29  Arash Esbati  <arash@gnu.org>

	Add new style/breqn.el

	* Makefile.in (STYLESRC): Add new style.

	* style/breqn.el: New file.

2017-01-29  Arash Esbati  <arash@gnu.org>

	Update style/listings.el to use `LaTeX-env-label-as-keyval'

	* style/listings.el (LaTeX-listings-key-val-options): Comment the
	"label" key.
	(LaTeX-listings-key-val-label-extract):
	(LaTeX-listings-key-val-label-regexp): New variable.
	(LaTeX-listings-auto-cleanup): Use `LaTeX-add-environments'
	instead of adding new enviroments to `LaTeX-auto-environment'.
	Use the function `LaTeX-env-label-as-keyval' to insert labels.
	Add parsed enviroments to AUCTeX parser with `TeX-auto-add-regexp'.
	("listings"): Add `LaTeX-listings-key-val-label-regexp' to the
	parser.
	Use `LaTeX-env-label-as-keyval' for "lstlisting".

2017-01-29  Arash Esbati  <arash@gnu.org>

	Add function to put labels in opt. argument of environments

	* doc/changes.texi: Document new feature.

	* latex.el (LaTeX-listing-label): New custom prefix for labels in
	code typesetting environments.
	(LaTeX-env-label-as-keyval): New function.
	(LaTeX-narrow-to-environment): Fix typo in docstring.

2017-01-27  Arash Esbati  <arash@gnu.org>

	Add `NO-INSERT' argument to `LaTeX-label'

	* doc/changes.texi: Document changes to `LaTeX-label' and
	`LaTeX-label-function'.

	* latex.el (LaTeX-label): Add second optional argument NO-INSERT.
	This argument is passed to function bound to
	`LaTeX-label-function' (usually `reftex-label' with RefTeX
	enabled).  If `LaTeX-label-function' is nil and NO-INSERT is
	non-nil, label is read and returned as a string.  Remove some
	unnecessary checks.
	(LaTeX-label-function): Mention in docstring that the function is
	expected to take an optional argument NO-INSERT.  This is an
	incompatible change.

2017-01-27  Arash Esbati  <arash@gnu.org>

	Check if label is defined before adding it to known labels

	* latex.el (TeX-read-label): Check if label is already defined and
	ask for user confirmation before adding it list of known labels.
	Do not add label if empty string or the value of
	`TeX-read-label-prefix'.

2017-01-26  Arash Esbati  <arash@gnu.org>

	Add \citetitle to `reftex-cite-format' in style/biblatex

	* style/biblatex.el ("biblatex"): Add \citetitle[*] to
	`reftex-cite-format' and bind them to keys i/I per user request
	http://lists.gnu.org/archive/html/auctex/2017-01/msg00049.html.

2017-01-25  Mosè Giordano  <mose@gnu.org>

	Guard setcar with appropriate test

	* tex-jp.el (assoc): Replace second element of "BibTeX" and "Index" entries of
	`TeX-command-list' only if they are already there.  This variable is
	customizable and users may have removed them.  Reported by jfbu.

2017-01-20  Mosè Giordano  <mose@gnu.org>

	* latex.el (LaTeX-newline): Make interactive.  See bug#24412.

2017-01-20  Mosè Giordano  <mose@gnu.org>

	Add makeglossaries to the list of commands

	* tex.el (TeX-command-list): Add makeglossaries.  Fixes bug#24952.
	* latex.el (LaTeX-clean-intermediate-suffixes): Add extensions of files created
	  by makeglossaries.

2017-01-15  Mosè Giordano  <mose@gnu.org>

	Show summary of tests at the end of make check

	* tests/Makefile (check): Depend on `check-doit' and `mostlyclean' phony
	  targets.
	(check-doit): New rule for showing summary of tests.
	(mostlyclean): Delete log files.

2017-01-13  Davide G. M. Salvetti  <salve@debian.org>

	Fix ConTeXt-outline-regexp

	Add a separator between different elements; see Debian bug #850444.

2017-01-13  Mosè Giordano  <mose@gnu.org>

	Remove also a gitignore

	* Makefile.in (EXCLUDEDFILES): Add latex/.gitignore to excluded files.

2017-01-13  Mosè Giordano  <mose@gnu.org>

	Remove file from distributed tar ball

	* Makefile.in (EXCLUDEDFILES): Add doc/tex-ref.log.

2017-01-12  Mosè Giordano  <mose@gnu.org>

	Add AUCTeX Logo

	* etc/auctex-logo.tex: Logo of AUCTeX.  It was realized with comments from
	Vincent Belaïche, Marcin Borkowski, Marta Dell’Atti, Tamas Papp and others.

	* .gitignore: Ignore some files automatically created during compilation.

2017-01-11  Mosè Giordano  <mose@gnu.org>

	Make gitlog-to-changelog ignore release-commit

	* Makefile.in (release-commit): Prefix the commit message with "; ", so that
	the commit will be ignored when automatically updating the ChangeLog.

2017-01-10  Mosè Giordano  <mose@gnu.org>

	* Version 11.90 released.

2017-01-10  Mosè Giordano  <mose@gnu.org>

	Refresh RELEASE file

	* RELEASE: Update "Availability" and "Future development and additional
	information" sections.

2017-01-10  Mosè Giordano  <mose@gnu.org>

	* Makefile.in (release-commit): Use UTF-8 coding for ChangeLog entry.

	* ChangeLog-preview: Change encoding to UTF-8.

	* Makefile.in (release-commit): Fix name of preview ChangeLog.

2017-01-10  Arash Esbati  <arash@gnu.org>

	Use RefTeX for multiple references in cleveref

	* style/cleveref.el (TeX-arg-cleveref-multiple-labels): Check if
	RefTeX is enabled and use it for multiple referencing macros.
	("cleveref"): Use `TeX-arg-ref' instead of `TeX-arg-label'.
	("cleveref"): Remove call of (font-latex-set-syntactic-keywords).

2017-01-10  Arash Esbati  <arash@gnu.org>

	Skip macros and environments from tcolorbox and raster library

	* tex-ispell.el (TeX-ispell-sort-skip-cmds-list): Extract macros
	with optional argument from `TeX-ispell-skip-cmds-list'.
	(TeX-ispell-skip-cmds-opt-arg-regexp): New variable containing
	macros where only the optional argument is skipped while spell
	checking.
	Add macros and environments from tcolorbox.el and
	tcolorboxlib-raster.el.

2017-01-10  Arash Esbati  <arash@gnu.org>

	Advertise AUCTeX installation from ELPA

	* doc/quickstart.texi (Quick Start): Emphasize the necessity to
	drop (load "auctex.el" nil t t) when installed from ELPA.

	* doc/install.texi (Installation): Advertise installation from
	ELPA.

2017-01-09  Mosè Giordano  <mose@gnu.org>

	Prepare for upcoming release

	* RELEASE: Update AUCTeX version, the new features section, and
	the list of contributors.

	* configure.ac: Update AUCTeX version.

	* doc/changes.texi: Reorder changes for 11.90 version section.

	* doc/tex-ref.tex: Update AUCTeX version and copyright years
	across the file.

	* latex/preview.dtx: Manually update release version.

2017-01-07  Mosè Giordano  <mose@gnu.org>

	Adapt Makefile to new ChangeLog file name

	* Makefile.in (release-commit): Use `CHANGELOG_N' in place of
	`ChangeLog'.

2017-01-06  Tassilo Horn  <tsdh@gnu.org>

	Don't use cl function copy-list

	* font-latex.el (font-latex--get-script-props): Use copy-sequence instead of
	copy-list, the latter being a cl function.

2017-01-05  Tassilo Horn  <tsdh@gnu.org>

	Fix bug where font-latex-sub/superscript-face was not applied to ^_

	* font-latex.el (font-latex-make-user-keywords): prepend
	font-latex-script-char-face, don't replace existing specs.

2017-01-05  Tassilo Horn  <tsdh@gnu.org>

	Fontify script characters with a new face

	* doc/auctex.texi (Fontification of math): Document it.
	* doc/changes.texi: Mention that.
	* font-latex.el (font-latex-make-user-keywords): Adapt.
	(font-latex-script-char-face): New face.
	(font-latex-match-script-chars): Improve it so that double ^_ aren't
	matched because such errors were hard to see with
	font-latex-fontify-script set to invisible.
	(font-latex-script-char): New function.

2017-01-05  Arash Esbati  <arash.esbati@gmail.com>

	Support biblatex cite format in all Emacsen

	* style/biblatex.el ("biblatex"): Check if biblatex is available
	in `reftex-cite-format-builtin' and use it.  If not, add entries
	for older Emacsen manually.

2017-01-05  Arash Esbati  <arash.esbati@gmail.com>

	Check new custom option before activating RefTeX cite format

	* doc/changes.texi: Document new variable.

	* style/biblatex.el ("biblatex"):
	* style/harvard.el ("harvard"):
	* style/jurabib.el ("jurabib"):
	* style/natbib.el ("natbib"): Set cite format provided by RefTeX
	when `LaTeX-reftex-cite-format-auto-activate' is non-nil.

	* tex-style.el (LaTeX-reftex-cite-format-auto-activate): New
	customizable variable.

2017-01-04  Tassilo Horn  <tsdh@gnu.org>

	Fix script unfontification bug

	* font-latex.el (font-latex-unfontify-region): Remove script-level
	property and raise display property even though it's value is different
	from what's specified in font-latex-script-display.

2017-01-04  Tassilo Horn  <tsdh@gnu.org>

	Improve completion docs

	* doc/auctex.texi (Completion): Improved docs.
	* doc/changes.texi: Mention math completion, add link to Completion node
	in the manual.
	* tex.el (TeX-complete-list): Improve docstring.

2017-01-04  Tassilo Horn  <tsdh@gnu.org>

	Refactor normal completion and completion at point a bit

	* tex.el (TeX--complete-find-entry): New function.
	(TeX-complete-symbol,TeX--completion-at-point): Use it.

2017-01-04  Tassilo Horn  <tsdh@gnu.org>

	Completion for math macros

	* latex.el (LaTeX--after-math-macro-prefix-p): New function.
	(LaTeX-common-initialization): Use it for new TeX-complete-list entry.
	* tex.el (TeX-complete-list): Also allow match-data setting predicates in
	entries.
	(TeX-complete-symbol,TeX--completion-at-point): Adapt to new possibility.

2017-01-03  Tassilo Horn  <tsdh@gnu.org>

	Add completion-at-point support

	* doc/auctex.texi (Completion): Document completion-at-point support.
	* doc/changes.texi: Mention completion-at-point support.
	* tex.el (TeX--completion-at-point): New function.
	(VirTeX-common-initialization): Add TeX--completion-at-point to
	completion-at-point-functions in TeX buffers if that's bound.

2017-01-03  Mosè Giordano  <mose@gnu.org>

	Use RefTeX for multiple citations in biblatex

	* style/biblatex.el (LaTeX-arg-biblatex-cites): Use RefTeX when
	  available.  Suggested by Arash Esbati.

2017-01-03  Tassilo Horn  <tsdh@gnu.org>

	Simple docfix

	* font-latex.el (font-latex-fontify-script-max-level): Correct escaping of
	\(...\) in the docstring.

2017-01-03  Tassilo Horn  <tsdh@gnu.org>

	Improve multi-level script fontification

	* doc/auctex.texi (Fontification of math): Update docs.
	* doc/changes.texi: Add an item for the new script fontification
	features.
	* font-latex.el (font-latex-fontify-script): Update docstring.
	(font-latex-fontify-script-max-level): New custom variable.
	(font-latex--get-script-props): Apply script face only for levels up to
	font-latex-fontify-script-max-level.
	(font-latex-script): Adapt call to font-latex--get-script-props.

2017-01-03  Arash Esbati  <arash.esbati@gmail.com>

	Add a newline only if \label is inserted

	* style/caption.el (LaTeX-arg-caption-captionof):
	* style/bicaption.el (LaTeX-arg-bicaption-bicaption): Save the
	position before asking for a label.  Add a newline only if a label
	is inserted.

2017-01-03  Tassilo Horn  <tsdh@gnu.org>

	Bring back multi-level script font-locking

	* doc/auctex.texi (Fontification of math): Add documentation.
	* font-latex.el (font-latex-script-display): Increase default raise level to
	0.5.
	(font-latex-superscript-face,font-latex-subscript-face): Let scripts be a bit
	larger (:height 0.85 instead of 0.8).
	(font-latex--get-script-props): New function for incrementing/decrementing
	raise display property values.
	(font-latex-script): Use it.

2017-01-03  Tassilo Horn  <tsdh@gnu.org>

	Revert "Remove multi-level/invisible feature of font-latex-fontify-script"

	This reverts commit ccec8501960a448dd8faccaae54dfd9839a37c30.

2017-01-02  Tassilo Horn  <tsdh@gnu.org>

	Remove multi-level/invisible feature of font-latex-fontify-script

	* font-latex.el (font-latex-make-user-keywords,font-latex-script-display)
	(font-latex-script): Remove multi-level/invisible feature of
	font-latex-fontify-script.
	(font-latex-doctex-preprocessor-face): Remove function.
	* doc/auctex.texi (Fontification of math): Remove documentation for
	font-latex-fontify-script's multi-level and invisible values.

2016-12-31  Arash Esbati  <arash.esbati@gmail.com>

	Set `reftex-set-cite-format' to biblatex or natbib

	* style/biblatex.el ("biblatex"): Set `reftex-set-cite-format' to
	biblatex or natbib depending on package option.

2016-12-30  Uwe Brauer  <oub@mat.ucm.es>

	Add new style/exam.sty

	* Makefile.in (STYLESRC): add exam.el
	* style/exam.el: Add style file
	* tex-style.el: Move defcustom from exam.el to tex-style.el

2016-12-30  Arash Esbati  <arash.esbati@gmail.com>

	Fix the names also in expert macros

	* style/cleveref.el ("cleveref"): Fix the names also in expert macros.

2016-12-30  Arash Esbati  <arash.esbati@gmail.com>

	Fix name of macros \lcnamecref and \lcnamecrefs

	* style/cleveref.el ("cleveref"): Fix name of macros \lcnamecref
	and \lcnamecrefs.

2016-12-30  Arash Esbati  <arash.esbati@gmail.com>

	Add fontification for varioref's referencing macros

	* font-latex.el (font-latex-built-in-keyword-classes): Add starred
	version to \vref macro.

	* style/varioref.el ("varioref"): Add fontification support for
	referencing macros.

2016-12-30  Arash Esbati  <arash.esbati@gmail.com>

	Add starred version of \citeauthor and \Citeauthor

	* font-latex.el (font-latex-built-in-keyword-classes):
	* style/biblatex.el ("biblatex"): Add starred version of
	\citeauthor and \Citeauthor macros.

2016-12-30  Arash Esbati  <arash.esbati@gmail.com>

	Fix fontification for natbib compat macros

	* style/biblatex.el ("biblatex"): Fix fontification for natbib
	compat macros which take 2 optional arguments.

2016-12-29  Arash Esbati  <arash.esbati@gmail.com>

	Add \switchcolumn to paragraph commands

	* style/paracol.el ("paracol"): Add \switchcolumn to paragraph
	commands.

2016-12-29  Arash Esbati  <arash.esbati@gmail.com>

	Add new style/titletoc.el

	* style/titletoc.el: New file.

	* Makefile.in (STYLESRC): Add new style.

2016-12-29  Arash Esbati  <arash.esbati@gmail.com>

	Add new style/titlesec.el

	* Makefile.in (STYLESRC): Add new style.

	* style/titlesec.el: New file.

2016-12-29  Arash Esbati  <arash.esbati@gmail.com>

	Add new style/titleps.el

	* Makefile.in (STYLESRC): Add new style.

	* style/titleps.el: New file.

2016-12-29  Arash Esbati  <arash.esbati@gmail.com>

	Add new style/mdframed.el

	* Makefile.in (STYLESRC): Add new style.

	* style/mdframed.el: New file.

2016-12-29  Arash Esbati  <arash.esbati@gmail.com>

	Add new tcolorbox library style/tcolorboxlib-raster.el

	* Makefile.in (STYLESRC): Add new style.

	* style/tcolorboxlib-raster.el: New file.

2016-12-29  Arash Esbati  <arash.esbati@gmail.com>

	Update style/tcolorbox.el to package v3.96

	* style/tcolorbox.el: Update style to package v3.96.

2016-12-29  Arash Esbati  <arash.esbati@gmail.com>

	Query for optional float position

	* style/newfloat.el (LaTeX-newfloat-auto-cleanup): Query for
	optional float position.

2016-12-29  Arash Esbati  <arash.esbati@gmail.com>

	Improve inserting arguments of \captionof macro

	* style/caption.el (LaTeX-arg-caption-captionof): New function
	improving query and insert of caption and label acc. to float
	type.
	("caption"): Use it.

2016-12-29  Mosè Giordano  <mose@gnu.org>

	Fix documentation of TeX-arg-file

	* doc/auctex.texi (Adding Macros): `TeX-arg-file' does not strip
	  extension.  Reported by Tyler Smith.  Fixes bug#24444.

2016-12-26  Uwe Brauer  <oub@mat.ucm.es>

	Make AUCTeX and RefTeX aware of file loading macro \subfile

	* style/subfiles.el ("subfiles"): Make subfile macro be recognized
	as a paragraph command.  For AUCTeX, add argument of subfile to
	`TeX-auto-file'.  For RefTeX, append subfile to
	`reftex-include-file-commands' and run `reftex-compile-variables'
	only once.  Code rearrangement.

2016-12-24  Mosè Giordano  <mose@gnu.org>

	Print only first line of the message in error overview

	* tex-buf.el (TeX-error-overview-make-entries): Use `push' in place of
	  `add-to-list'.  Print only the first line of the message.

2016-12-23  Arash Esbati  <arash.esbati@gmail.com>

	Mention improvements to `LaTeX-array-count-columns' in news

	* doc/changes.texi: Mention improvements to
	`LaTeX-array-count-columns' in news since 11.89.

2016-12-23  Arash Esbati  <arash.esbati@gmail.com>

	Extend test for new column counting code with style files loaded

	* tests/latex/tabular-count-ampersands-out.tex:
	* tests/latex/tabular-count-ampersands-in.tex: Add tests for
	tabularx, tabulary, longtable, dcolumn, siunitx constructs.

	* tests/latex/latex-test.el
	(LaTeX-count-ampersands-inserted-in-tabular): Set `TeX-parse-self'
	to t in order to load style files in the test.  Thanks to Mosè
	Giordano for enabling this feature.

2016-12-22  Arash Esbati  <arash.esbati@gmail.com>

	Update style/minted.el to package version 2.4.1.

	* style/minted.el (LaTeX-minted-key-val-options): Add new key=vals
	from package version 2.4.1.
	(LaTeX-minted-key-val-options-local): New variable.
	(LaTeX-minted-language-list): Set the variable
	`LaTeX-minted-language-list' after the first call of function.
	(LaTeX-minted-style-list): New variable.
	(LaTeX-minted-style-list): New function analogous to
	`LaTeX-minted-language-list' returning styles provided by
	pymentize program.
	(LaTeX-arg-minted-style): New function to insert styles provided
	by pymentize program into buffer.
	(LaTeX-minted-update-key-vals): New function to update key=vals in
	`LaTeX-minted-key-val-options-local'.
	(LaTeX-minted-auto-cleanup): Call `LaTeX-minted-update-key-vals'.
	("minted"): Use `LaTeX-minted-key-val-options-local' for all
	key=val queries.  Update macros incl. fontification.  Run style
	hook for `newfloat' when package option is given.

2016-12-22  Tassilo Horn  <tsdh@gnu.org>

	Uniform font-lock updates/don't break prettify (bug#25245)

	* font-latex.el (font-latex-update-font-lock): New function.
	(font-latex-add-keywords): Use it.
	(font-latex-after-hacking-local-variables): Use it.
	* style/alltt.el: Use font-latex-update-font-lock.
	* style/beamer.el: Ditto.
	* style/comment.el: Ditto.
	* style/expl3.el: Ditto.
	* style/fancyhdr.el: Ditto.
	* style/fancyvrb.el: Ditto.
	* style/listings.el: Ditto.
	* style/minted.el: Ditto.
	* style/url.el: Ditto.

2016-12-22  Mosè Giordano  <mose@gnu.org>

	Fix to TeX-add-local-master

	* tex.el (TeX-add-local-master): Parse local variables again after
	  calling the mode function, which killed local variables.

2016-12-21  Mosè Giordano  <mose@gnu.org>

	Add style/ directory to TeX-style-path for tests

	* tests/latex/latex-test.el: Add our "style/" directory `TeX-style-path'
	  to make it possible to load style files inside tests.

2016-12-20  Mosè Giordano  <mose@gnu.org>

	* tex.el (TeX-add-local-master): Inherit major mode from master file.

2016-12-19  Arash Esbati  <arash.esbati@gmail.com>

	Mention that arguments to *-operator must be in braces

	* doc/auctex.texi (Tabular-like): Mention that the new code for
	counting columns in *{num}{cols} expects num and cols to be
	enclosed in braces.

2016-12-19  Arash Esbati  <arash.esbati@gmail.com>

	Add test for new column counting code

	* tests/latex/tabular-count-ampersands-out.tex:
	* tests/latex/tabular-count-ampersands-in.tex: New files.

	* tests/latex/latex-test.el
	(LaTeX-count-ampersands-inserted-in-tabular): Test new column
	counting code in `LaTeX-array-count-columns'.

2016-12-19  Arash Esbati  <arash.esbati@gmail.com>

	Count *-operator in column specification

	* latex.el (LaTeX-array-count-columns): Detect *-operator in
	column specification and count the arguments for final calculation
	of columns.  Thanks to Ikumi Keita for pointing out this
	deficiency and code to fix it.

2016-12-19  Arash Esbati  <arash.esbati@gmail.com>

	Add new style/dcolumn.el

	* Makefile.in (STYLESRC): Add new style.

	* style/dcolumn.el: New file.

2016-12-19  Arash Esbati  <arash.esbati@gmail.com>

	Accept non-letter characters as column specifier

	* style/array.el (LaTeX-array-newcolumntype-regexp): Accept
	non-letter characters as column specifier.

2016-12-17  Arash Esbati  <arash.esbati@gmail.com>

	Use `LaTeX-item-longtable' while inserting longtable's

	* style/longtable.el (LaTeX-longtable-skipping-regexp): New variable.
	(LaTeX-item-longtable): New function.  This function is a
	variation of `LaTeX-item-array' which uses
	`LaTeX-longtable-skipping-regexp' when inserting ampersands.
	("longtable"): Append longtable to `LaTeX-item-list'.

2016-12-17  Arash Esbati  <arash.esbati@gmail.com>

	Add "s" and "S" to `LaTeX-array-column-letters'

	* style/siunitx.el ("siunitx"): Add column specification letters
	"s" and "S" to `LaTeX-array-column-letters'.

2016-12-17  Arash Esbati  <arash.esbati@gmail.com>

	Append tabular[xy] to `LaTeX-item-list'

	* style/tabulary.el ("tabulary"):
	* style/tabularx.el ("tabularx"): Append tabularx and tabulary to
	`LaTeX-item-list'.

2016-12-06  Arash Esbati  <arash.esbati@gmail.com>

	Support RefTeX with `reftex-add-index-macros' in style/splitidx.el

	* style/splitidx.el ("splitidx"): Support RefTeX with
	`reftex-add-index-macros' and not by appending macros to
	`reftex-index-macros'.

2016-12-06  Arash Esbati  <arash.esbati@gmail.com>

	Support RefTeX with `reftex-add-label-environments' in style/mathtools.el

	* style/mathtools.el (LaTeX-mathtools-auto-cleanup, "mathtools"):
	Support RefTeX with `reftex-add-label-environments' and not by
	appending environments to `reftex-label-alist'.
	("mathtools"): Add fontification support for referencing macros.

2016-12-06  Arash Esbati  <arash.esbati@gmail.com>

	Support RefTeX with `reftex-add-label-environments' in style/empheq.el

	* style/empheq.el ("empheq"): Support RefTeX with
	`reftex-add-label-environments' and not by appending environments
	to `reftex-label-alist'.

2016-12-05  Arash Esbati  <arash.esbati@gmail.com>

	Fix query for defined colors in style/textpos.el

	* style/textpos.el ("textpos"): Use `cond' to check which color
	defining package is loaded and use the respective function for
	`completing-read'.

2016-12-05  Arash Esbati  <arash.esbati@gmail.com>

	Fix query for defined colors in style/ntheorem.el

	* style/ntheorem.el ("ntheorem"): Use `cond' to check which color
	defining package is loaded and use the respective function for
	`completing-read'.

2016-11-30  Arash Esbati  <arash.esbati@gmail.com>

	Add support for LaTeX core command \textsubscript

	* font-latex.el (font-latex-built-in-keyword-classes):
	* latex.el (LaTeX-common-initialization): Add entry for
	"textsubscript" which is in LaTeX core since 2015/01/01.

2016-11-28  Arash Esbati  <arash.esbati@gmail.com>

	Do not spell-check arguments of \LTXtable

	* tex-ispell.el (TeX-ispell-skip-cmds-list): Add entry for
	\LTXtable.

2016-11-28  Arash Esbati  <arash.esbati@gmail.com>

	Add \LTXtable to list of file-loading commands

	* style/ltxtable.el (LaTeX-ltxtable-file-regexp): New variable.
	("ltxtable"): Make AUCTeX and RefTeX aware of \LTXtable as file
	loading command.
	Add fontification support.

2016-11-25  Arash Esbati  <arash.esbati@gmail.com>

	Support new floats defined with newfloat package

	* style/caption.el (LaTeX-caption-update-key-val-options): Append
	new floating environments defined with "newfloat.sty" as values to
	"type*?" keys in `LaTeX-caption-key-val-options-local'.

2016-11-25  Arash Esbati  <arash.esbati@gmail.com>

	Append entry to `LaTeX-label-alist' for new "verbatim" floats

	* style/newfloat.el (LaTeX-newfloat-auto-cleanup): Append an entry
	for parsed environments of "verbatim" type to `LaTeX-label-alist'.

2016-11-24  Arash Esbati  <arash.esbati@gmail.com>

	Insert \label inside the mandatory argument of \caption

	* style/longtable.el ("longtable"): Append \label at the end of
	caption text inside the mandatory argument.
	(LaTeX-longtable-package-options): New variable to suppress the
	query for package options.

2016-11-24  Uwe Brauer  <oub@mat.ucm.es>

	Add style file for subfiles package.

	* Makefile.in (STYLESRC): add subfiles.el entry

	* style/subfiles.el ("subfiles"): add new style.

2016-11-23  Mosè Giordano  <mose@gnu.org>

	Min fix to kpfonts package

	* style/kpfonts.el ("kpfonts"): Move setting of `TeX-font-list' inside
	  the hook.

2016-11-23  Mosè Giordano  <mose@gnu.org>

	Add style file for amsfonts package

	* style/amsfonts.el: New file.
	* Makefile.in (STYLESRC): Install it.
	* style/amssymb.el ("amssymb"): Run `amsfonts' hook.

2016-11-21  Arash Esbati  <arash.esbati@gmail.com>

	Add new style/bicaption.el

	* Makefile.in (STYLESRC): Add new style.

	* style/bicaption.el: New file.

2016-11-21  Arash Esbati  <arash.esbati@gmail.com>

	Add support for style/bicaption.el to style/caption.el

	* style/caption.el (LaTeX-caption-supported-float-types): Add
	supported caption types available with bicaption.el.
	("caption"): Append key=vals from bicaption.el to
	`LaTeX-caption-key-val-options-local'.
	("caption"): Query for a second optional argument with
	\captionsetup*? if bicaption.el is loaded.  Same for
	fontification.

2016-11-21  Arash Esbati  <arash.esbati@gmail.com>

	Do not insert a new line if \label is omitted

	* style/subcaption.el (LaTeX-arg-subcaption-subcaption): Insert a
	new line only if \label is given.

2016-11-18  Arash Esbati  <arash.esbati@gmail.com>

	Improve caption and label insertion in style/caption.el

	* style/caption.el (LaTeX-caption-key-val-options): Add key slc
	which is an abbrev for singlelinecheck.
	(LaTeX-arg-caption-captionbox): Delete unused prompt argument.
	Ask for short caption acc. to the value of
	`LaTeX-short-caption-prompt-length'.  Use `LaTeX-label' instead of
	`TeX-insert-macro' to insert a label.  Use `TeX-argument-insert'
	instead of conditional insert.
	("caption"): Do not fontify the last argument of \captionbox.
	Fontification happens within \begin...\end{tabular} or
	\includegraphics.

2016-11-18  Arash Esbati  <arash.esbati@gmail.com>

	Improve caption and label insertion in style/subcaption.el

	* style/subcaption.el (LaTeX-arg-subcaption-subcaption): Delete
	unused prompt argument.  Ask for short caption acc. to the value
	of `LaTeX-short-caption-prompt-length'.  Fill the inserted
	sub-caption before using `LaTeX-label' to insert the label.
	(LaTeX-arg-subcaption-subcaptionbox): Delete unused prompt
	argument.  Ask for short caption acc. to the value of
	`LaTeX-short-caption-prompt-length'.  Use `LaTeX-label' to insert
	the label.  Use `TeX-argument-insert' instead of conditional
	insert.
	("subcaption"): Append package environments to `LaTeX-label-alist'.
	("subcaption"): Do not fontify the last argument of
	\subcaptionbox.  Fontification happens within
	\begin...\end{tabular} or \includegraphics.

2016-11-16  Arash Esbati  <arash.esbati@gmail.com>

	Add new style/FiraSans.el

	* Makefile.in (STYLESRC): Add new style.

	* style/FiraSans.el: New file.

2016-11-16  Arash Esbati  <arash.esbati@gmail.com>

	Add new style/FiraMono.el

	* Makefile.in (STYLESRC): Add new style.

	* style/FiraMono.el: New file.

2016-11-14  Mosè Giordano  <mose@gnu.org>

	Suggest to display warnings when there are no errors in error overview

	* tex-buf.el (TeX-error-overview): When there are no errors, suggest to
	  display warnings and bad boxes, if present.  Fixes bug #24877.

2016-11-04  Tassilo Horn  <tsdh@gnu.org>

	Refresh font-latex fontification if vars are modified

	Refresh font-latex fontification if variables such as
	LaTeX-verbatim-*-local are set in a file-local variables block or as
	directory-local variables (bug#24868).

	* font-latex.el (font-latex-after-hacking-local-variables): New function.
	(font-latex-setup): Add it do hack-local-variables-hook.
	* tex.el (TeX--list-of-string-p): New function.
	* latex.el (LaTeX-verbatim-environments-local):
	(LaTeX-verbatim-macros-with-braces-local):
	(LaTeX-verbatim-macros-with-delims-local): Use it for
	safe-local-variable property.

2016-11-02  Arash Esbati  <arash.esbati@gmail.com>

	Update style/natbib.el to package version 8.31b

	* style/natbib.el ("natbib"): Add missing macros to catch up with
	package version 8.31b.  Rearrange code.
	(LaTeX-arg-natbib-notes): Remove redundant check if
	`TeX-arg-cite-note-p' is non-nil.

2016-10-17  Tassilo Horn  <tsdh@gnu.org>

	Make Copyright headers conforming to convention

2016-10-17  Arash Esbati  <arash.esbati@gmail.com>

	Do not insert unnecessary brackets for citation macros

	* style/natbib.el (LaTeX-arg-natbib-notes): Rename function name
	from `natbib-note-args'.
	Improve the insertion of arguments in order not to have an empty
	pair of brackets when both pre- and post-note are omitted.
	("natbib"): Replace occurrence of `natbib-note-args' with
	`LaTeX-arg-natbib-notes'.

2016-10-17  Arash Esbati  <arash.esbati@gmail.com>

	Use `TeX-argument-insert' instead of conditional `insert'

	* style/biblatex.el (LaTeX-arg-biblatex-natbib-notes): Use
	`TeX-argument-insert' instead of `insert' for arguments
	insertion.

2016-10-16  Arash Esbati  <arash.esbati@gmail.com>

